/****************************************************************************

  Copyright (C) Cambridge Silicon Radio April 2000

FILE
        BTRACE.c  -  debug services

MODIFICATION HISTORY
	1.2  27-apr-00 npm  - added boilerplating

*/


#ifdef	RCS_STRINGS
static  char    btrace_c_id[]
  = "$Id: //depot/bc/main/devHost/HostStack/BCSP/Generic/BTRACE.c#7 $";
#endif


#include "BCSPStack.h"
#include "stdarg.h"

#ifdef _DEBUG

#include <stdio.h>

uint32 BCSPdebugMask = 0xffffffff;
ichar * BCSPDebugID = null ;
FILE * BCSPDebugLog = null ;

void openDebugLog(ichar * filename)
{

	BCSPDebugLog = ifopen(filename,II("w")) ;
}

void plainbtrace(uint32 bit,ichar * fmt,...) 
{
	va_list arglist ;
	if (BCSPdebugMask & bit)
	{
		va_start(arglist,fmt) ;
		if (BCSPDebugLog) 
		{
			ivfprintf(BCSPDebugLog,fmt,arglist) ;
			fflush(BCSPDebugLog) ;
		}
		else
		{
			ivprintf(fmt,arglist) ;
		}
	}
}


void btrace(uint32 bit,ichar * fmt,...) 
{
	va_list arglist ;
	if (BCSPdebugMask & bit)
	{
		va_start(arglist,fmt) ;
		if (BCSPDebugID) 							
		{
			if (BCSPDebugLog) 
			{
				ifprintf(BCSPDebugLog,II("%s:"),BCSPDebugID) ;
			}
			else
			{
				iprintf(II("%s:"),BCSPDebugID) ;
			}
		}
		if (BCSPDebugLog) 
		{
			ivfprintf(BCSPDebugLog,fmt,arglist) ;
			fflush(BCSPDebugLog) ;
		}
		else
		{
			ivprintf(fmt,arglist) ;
		}

	}
}

#endif