//Copyright May 2000 Cambridge Silicon Radio

//a simple application which shows how packets can be sent from
//one bcsp stack to another 
//This code is unsupported and is intended only as an example.

#include "envdefs.h"
#include "BCProtocols.h"
#include "PosixBCSP.h"
#include <stdlib.h>
#include <unistd.h>

#define CHANNEL BC_HCI_CMD_EVT
#define SCHANNEL "BC_HCI_CMD_EVT"

// #define SENDCMDS /* Send out a few HCI commands, expecting events back */

#ifdef SENDCMDS
void doNothing(BCTransferRequest * req, BCTransferStatus status,void * vcount)
{
	printf ("tx cmd done\n");
	free (req);
}
#endif

//continueRead
//called every time that a callback is received 

void continueRead(BCTransferRequest * req, BCTransferStatus status,void * vcount)
{
	uint32 *count = (uint32 *) vcount ;
	static uint8 rcvBuf [100] ;
	switch (status)
	{
	case transferComplete:
		{
#ifdef SENDCMDS
			size_t n;
			static int sentrba = 0, sentrbs = 0, sentwse = 0;
			printf ("Rx on channel %u: ", req->channel);
			for (n = 0; n < req->length; ++n)
			{
				printf ("%02x", req->data[n]);
			}
			printf (" [%u]\n", req->length);
			if (!sentrba)
			{
				static uint8 rba[] = { 0x09, 0x10, 0x00 };
				sentrba = 1;
				BCTransferRequest * req = (BCTransferRequest*) calloc(1,sizeof(BCTransferRequest)) ;
				BCinitTransferRequest(req,rba,3,doNothing,NULL);
				BCwritePacket(CHANNEL,req) ;
			}
			else if (!sentrbs)
			{
				static uint8 rbs[] = { 0x05, 0x10, 0x00 };
				sentrbs = 1;
				BCTransferRequest * req = (BCTransferRequest*) calloc(1,sizeof(BCTransferRequest)) ;
				BCinitTransferRequest(req,rbs,3,doNothing,NULL);
				BCwritePacket(CHANNEL,req) ;
			}
			else if (!sentwse)
			{
				static uint8 wse[] = { 0x1a, 0x0c, 0x01, 0x02 };
				sentwse = 1;
				BCTransferRequest * req = (BCTransferRequest*) calloc(1,sizeof(BCTransferRequest)) ;
				BCinitTransferRequest(req,wse,4,doNothing,NULL);
				BCwritePacket(CHANNEL,req) ;
			}
#endif
			if (*count)
			{
			printf("getting data count %d\n",*count) ;
			BCreloadTransferRequest(req,rcvBuf,sizeof(rcvBuf)) ;
			BCreadPacket(CHANNEL,req) ;
			*count = *count -1 ;
			}
			else
			{
				free(req) ;
			}
		}
		break ;
	case transferCancelled:
		printf("Error - transfer cancelled\n") ;
		break ;
	default :
		break ;
	}
}

void doRead(uint32*count)
{
	BCTransferRequest * req = (BCTransferRequest*) calloc(1,sizeof(BCTransferRequest)) ;
	BCinitTransferRequest(req,0,0,continueRead,(void*) count) ;
	continueRead(req,transferComplete,count) ;
}



//continue write
//called every time a write callback is received

void continueWrite(BCTransferRequest * req, BCTransferStatus status,void * vcount)
{
	uint32 * count = (uint32*) vcount ;
	static uint8 xmitBuf [100] ;
	switch (status)
	{
	case transferComplete:
		{
			if (*count)
			{
			printf("sending data count %d\n",*count) ;
			BCreloadTransferRequest(req,xmitBuf,sizeof(xmitBuf)) ;
			BCwritePacket(CHANNEL,req) ;
			*count = *count -1 ;
			}
			else 
			{
				free(req) ;
			}
		}
		break ;
	case transferCancelled:
		printf("Error - transfer cancelled\n") ;
		break ;
	default :
		break ;
	}
}

void doWrite(uint32 * count)
{
	BCTransferRequest * req = (BCTransferRequest*) calloc(1,sizeof(BCTransferRequest)) ;
	BCinitTransferRequest(req,0,0,continueWrite,(void*) count) ;
	continueWrite(req,transferComplete,count) ;
}

int main(int argc, char* argv[])
{
	if (argc ==1) 
	{
		printf("usage: ftp port [write]\n") ;
		printf("(e.g. \"ftp /dev/term/a write\")\n") ;
		return 0 ;
	}

	PosixBCSP posixStack ;
	if (!posixStack.open(argv[1],38400))
	{
		printf("Error - couldn't open port '%s'\n",argv[1]) ;
		return 0 ;
	}
	
	BTRACEDISABLE(0xffffffff) ;

	posixStack.start() ;
	if (!posixStack.connect(5000))
	{
		printf("Couldn't establish link with peer\n") ;
		return 0;
	}
	printf ("Link with peer established\n");

	initialiseBCProtocols(posixStack.getBCSPStack()) ;

	if (!BCopenChannel(CHANNEL))
	{
		printf("Couldn't open " SCHANNEL " channel\n") ;
		return 0 ;
	}
	printf (SCHANNEL " channel opened\n");

	uint32 count =100 ;;
	if (argv[2]) doWrite(&count);
	else doRead(&count) ;
	while (1) sleep(1) ;
	return 0;
}
