/****************************************************************************

  Copyright (C) Cambridge Silicon Radio April 2000

FILE
        BCProtocols.h  -  attempt to make BC01 channels independent of BCSP


MODIFICATION HISTORY
	1.4  27-apr-00 npm  - added boilerplating

*/


#ifndef _BCPROTOCOLS_H_
#define _BCPROTOCOLS_H_

#ifdef	RCS_STRINGS
static  char    bcprotocols_h_id[]
  = "$Id";
#endif

#include "common/bool.h"
#include "BCSP/BCSPLinkage.h"

struct _BCSPStack ;
struct _BCTransferRequest ;

typedef enum _BCChannelId
{

	BC_LINK_MGT			=1,
	BC_CHIP_MGT_HC		=2,
	BC_CHIP_MGT_CH_CHAN	=3,
	BC_DEV_MGT			=4,
	BC_HCI_CMD_EVT		=5,
	BC_HCI_ACL			=6,
	BC_HCI_SCO			=7,
	BC_L2CAP			=8,
	BC_RFCOMM			=9,
	BC_SDD				=10,
	BC_RSVD0			=11,
	BC_RSVD1			=12,
	BC_RSVD2			=13,
	BC_RSVD3			=14,
	BC_RSVD4			=15,

} BCChannelId;


BCSP_API void initialiseBCProtocols(struct _BCSPStack * stack) ;
BCSP_API bool BCopenChannel(BCChannelId chanId);
BCSP_API void BCwritePacket(BCChannelId chanId,struct _BCTransferRequest * req);
BCSP_API void BCreadPacket(BCChannelId chanId,struct _BCTransferRequest * req);

#endif