/****************************************************************************

  Copyright (C) Cambridge Silicon Radio April 2000

FILE
        Protocols.c  -  attempt to make BC01 channels independent of BCSP


MODIFICATION HISTORY
	1.4  27-apr-00 npm  - added boilerplating

*/


#ifdef	RCS_STRINGS
static  char    protocols_c_id[]
  = "$Id";
#endif



#include "BCSPStack.h"
#include "BCProtocols.h"
#include "malloc.h"
#include "memory.h"


//At this layer, the user loses contact with the actual stack - the
//idea is to create a bcsp-independent interface
//Their only involvement is to pass in a stack value for us on initialisation
//obviously this means that only one stack can be used by each client

static BCSPStack * theStack = null ;


//now have a static array of channels for protocols

static BCSPChannel channels[16] ;




BCSP_API void initialiseBCProtocols(BCSPStack * stack) 
{
	theStack = stack ;
	//clear the channels

	memset(channels,0,sizeof(channels)) ;
}


BCSP_API bool BCopenChannel(BCChannelId chanId)
{	
	if (!chanId) return false ;
	else 
		return BCSPopenChannel(&channels[chanId],theStack,(uint8)chanId,
							BCSPChannelReliable,BCSPCallbackDeferred) ;
}


BCSP_API void BCwritePacket(BCChannelId chanId,BCTransferRequest * req)
{
	BCSPwritePacket(&channels[chanId],req) ;
}

BCSP_API void BCreadPacket(BCChannelId chanId,BCTransferRequest * req)
{
	BCSPreadPacket(&channels[chanId],req) ;
}
