#include "stdafx.h"
#include "Win32BCSP_UART.h"
#include "WinEnvironment.h"

void winSignal(void * envState)
{
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	SetEvent(state->winSignal) ;
}


void winEnterCS(void * envState)
{
	//called by stack
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	EnterCriticalSection(&state->winCS) ;
}

void winLeaveCS(void * envState)
{
	//called by stack
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	LeaveCriticalSection(&state->winCS) ;
}

void winLinkFail(void * envState)
{
	((WinEnvironment*) envState)->winStack->onLinkFail() ;
}


void initialiseEnvironment(BCSPEnvironment * current,BCSPEnvironment * newEnv,WinEnvironmentState * state,HANDLE sig,Win32BCSPUart * winStack)
{
	
	
	state->winSignal = sig ;
	InitializeCriticalSection(&state->winCS) ;
	memcpy(newEnv,current,sizeof(BCSPEnvironment)) ; //keep the current memory funcs
	newEnv->leaveCS = winLeaveCS ;
	newEnv->enterCS = winEnterCS ;
	newEnv->signal = winSignal ;
	newEnv->envState = state ;
	newEnv->onLinkFailure = winLinkFail ;
	newEnv->winStack = winStack ;
}
