/****************************************************************************

  Copyright (C) Cambridge Silicon Radio April 2000

FILE
        Win32Environment.cpp  -  environment helper for bcsp stack

MODIFICATION HISTORY
	1.2  27-apr-00 npm  - added boilerplating
	1.3  12-mar-01 at  -  added cleanup code
*/


#ifdef	RCS_STRINGS
static  char    winenvironment_c_id[]
  = "$Id: //depot/bc/main/devHost/HostStack/BCSP/Win32/Win32UART/WinEnvironment.cpp#4 $";
#endif

#include "stdafx.h"
#include "Win32BCSP.h"
#include "WinEnvironment.h"

void winSignal(void * envState)
{
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	SetEvent(state->winSignal) ;
}


void winEnterCS(void * envState)
{
	//called by stack
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	EnterCriticalSection(&state->winCS) ;
}

void winLeaveCS(void * envState)
{
	//called by stack
	WinEnvironmentState * state = (WinEnvironmentState*) envState ;
	LeaveCriticalSection(&state->winCS) ;
}

void winLinkFail(void * envState)
{
	((WinEnvironmentState*) envState)->winStack->onLinkFail() ;
}


void initialiseEnvironment(BCSPEnvironment * current,BCSPEnvironment * newEnv,WinEnvironmentState * state,HANDLE sig,Win32BCSP * winStack)
{
	
	
	state->winSignal = sig ;
	InitializeCriticalSection(&state->winCS) ;
	memcpy(newEnv,current,sizeof(BCSPEnvironment)) ; //keep the current memory funcs
	newEnv->leaveCS = winLeaveCS ;
	newEnv->enterCS = winEnterCS ;
	newEnv->signal = winSignal ;
	newEnv->envState = state ;
	newEnv->onLinkFailure = winLinkFail ;
	state->winStack = winStack ;
}

void cleanupEnvironment(WinEnvironmentState * state)
{
	DeleteCriticalSection(&state->winCS);
}
