// bluechat2Dlg.cpp : implementation file
//
// $Id: //depot/bc/main/devHost/HostStack/Bluechat2CE/BlueChat2Dlg.cpp#4 $

#include "stdafx.h"

#include "BlueChat2HciDefs.h"


#include "bluechat2.h"
#include "bluechat2Dlg.h"
#include "testdialog.h"		/* chat screen */
#include "DebugWindow.h"	/* debug screen */
#include "xferctrl3.h"		/* file send screen */

#include "hcidebug.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef _WINCE
#include <windows.h>
#include <tchar.h>
#include <olectl.h>
#include <ctype.h>
#include <dbgapi.h>
#include "time.h"
#endif

#ifdef _WINCE
#include <afxwin.h>
#include <windef.h>
#include <winuser.h>
#endif

#include "stdafx.h"
//#include "BlueChat.h"
//#include "BlueChatDlg.h"
//#include "HCICmdDialog.h"
#include "DlgProxy.h"

#include "hci_def.h"

#include "TraceDialog.h"
#include "hci/Packer_parameters.h"

/*************************         Global Data          **********************/


/*************************         Local Macros         **********************/
// Enable Debug Info
#define DEBUG_PROCESS_HCI_COMMAND_REQUEST									1					// Enables HCI Command Request Data array Debug


// Inquiry Scan defines
#define HCI_INQUIRY_LAP														0x9e8b33 
#define HCI_INQUIRY_LENGTH_DEFAULT          								((uint8) 10)
#define HCI_INQUIRY_RESPONSES_DEFAULT       								((uint8)  8)

#define ARRAY_LENGTH_AND_CMD_DATA											2					// Additional data length added to cmd parameters 

// HCI Command Lengths
#define HCI_INQUIRY_CMD_LEN													((uint8)  3)
#define HCI_INQUIRY_CANCEL_CMD_LEN											((uint8)  0)
#define HCI_READ_BD_ADDR_CMD_LEN											((uint8)  0)
#define HCI_SET_EVENT_FILTER_CMD_LEN										((uint8)  3)
#define HCI_WRITE_PAGE_SCAN_ACTIVITY_CMD_LEN								((uint8)  2)
#define HCI_WRITE_INQUIRY_SCAN_ACTIVITY_CMD_LEN								((uint8)  2)
#define HCI_WRITE_SCAN_ENABLE_CMD_LEN										((uint8)  1)
#define HCI_CREATE_CONNECTION_CMD_LEN										((uint8)  8)
#define HCI_DISCONNECT_CMD_LEN												((uint8)  2)
#define HCI_ADD_SCO_CONNECTION_CMD_LEN										((uint8)  2)
#define HCI_READ_BD_ADDR_CMD_LEN											((uint8)  0)
#define HCI_READ_BUFFER_SIZE_CMD_LEN										((uint8)  0)
#define HCI_COMMAND_STATUS_EVENT_CMD_LEN									((uint8)  3)
#define HCI_ACCEPT_CONNECTION_REQUEST_CMD_LEN								((uint8)  4)
#define HCI_WRITE_LINK_POLICY_SETTINGS_CMD_LEN								((uint8)  4)


// Set_Event_Filter defines
#define EVENT_FILTER_TYPE_CONNECTION_SETUP									0x02
#define CONNECTION_SETUP_FILTER_CONDITION_TYPE_ALLOW_FROM_ALL_DEVICES		0x00
#define CONNECTION_SETUP_FILTER_CONDITION_DO_NOT_AUTO_ACCEPT				0x01
#define CONNECTION_SETUP_FILTER_CONDITION_AUTO_ACCEPT						0x02

// Connection Request Event defines
#define CONNECTION_EVENT_LINK_TYPE_SCO										0x00
#define CONNECTION_EVENT_LINK_TYPE_ACL										0x01


// Disconnect Reasons
#define HCI_DISCONNECT_REASON_OTHER_END_TERMINATED							0x13
#define HCI_DISCONNECT_REASON_HOST_TERMINATED								0x16


// Timers 	ON_WM_TIMER() Event ID's
#define CONNECTION_TIMER													1
#define WORK_TIMER															2
#define SUBSEQUENT_CONNECTION_TIMER											3
#define TIMER_EVENT_ID_RESET_CASIRA											4
#define TIMER_EVENT_ID_ENABLE_AUDIO_CHECK									5
#define TIMER_EVENT_ID_ENABLE_DATA_CHECK									6
#define TIMER_EVENT_ID_SEND_FILE_DATA										7
#define TIMER_EVENT_ID_UPDATE_SENT_PROGRESS_BAR								8
#define WAITING_FOR_BUFFER_SIZES_TIMER										9

#define CONNECTION_HANDLE_MASK												(0xfff) // 12 bits meaningful
																									 
#define CHECK_SUSPEND_TIME													5000
#define SEND_FILE_DATA_TIME													1
#define UPDATE_SENT_PROGESS_TIME											50


#define CHANNEL_1_CHARS														1
#define CHANNEL_2_FILE_FRAGMENTS											2
#define CHANNEL_65_CHARS                                                    (0x41)
#define CHANNEL_66_FILENAME                                                 (0x42)
#define CHANNEL_67_FILE_CONTENT                                             (0x43)

#define HCI_PKT_PER_L_PKT 													(32)


/*************************       Type definitions       **********************/

/*************************         Local Types          **********************/

/*************************  Local Function Prototypes   **********************/


/*************************          Local Data          **********************/

// Horible Global data used for BCSP tracing.
static CString 	traceFile 	= "";
static uint32 	traceMask 	= 0;

/*************************        Start of Code         **********************/


/*************************         Text Strings         **********************/

TCHAR TxtPleaseEnterValAddress[]	= _T("Please enter a valid Bluetooth Device Address,\nor select from the list");
TCHAR TxtTryingToConnect[]			= _T("Trying to Connect...");
TCHAR TxtConnected[]				= _T("Connected.");
TCHAR TxtTryingToDisconnect[] 		= _T("Trying to Disconnect...");
TCHAR TxtRemovingSCO[] 				= _T("Removing SCO...");
TCHAR TxtDisconnecting[] 			= _T("Disconnecting:");
TCHAR TxtDisconnected[] 				= _T("Disconnected:");

TCHAR TxtDisconnectSuccessfull[]	= _T("Disconnect successfull.");
TCHAR TxtDisconnectFailed[]			= _T("Disconnect failed.");

TCHAR TxtPleaseResetCasira[]		= _T("Please Reset Your CASIRA");
TCHAR TxtCommunicationError[]		= _T("Communication Error");

extern "C"
{
time_t gettimet(void);				/* get time_t time */
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


testdialog * g_pTestDlg=NULL;				// chat screen 
CDebugWindow * g_pDebugWindow=NULL;			// debug window
Cxferctrl3 * g_pxferctrl=NULL;				// file send screen 
CDebugWindow * g_pDebugWindow2=NULL;
CAboutDlg * g_pAboutBox=NULL;

/////////////////////////////////////////////////////////////////////////////
// CBlueChat2Dlg dialog

CBlueChat2Dlg::CBlueChat2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlueChat2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlueChat2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

//	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;

	m_pModeless = NULL;

}
CBlueChat2Dlg::~CBlueChat2Dlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;

}


void CBlueChat2Dlg::UpdateProgressBar(WPARAM dummy, LPARAM ldummy) 
{
	uint16 			Position;
	int 			nResponse;
	TCHAR	Buffer[200];

    //  Advance the progress bar.  With protection against division by zero...
    if(ReadFileLength != 0)
    {
		//Position = (uint16)(100 * ((float)FilePositionCounter / ReadFileLength));
		Position = (uint16)(100 * ((float)(FilePositionCounter - mEngine->getSizeOfBufferContent() ) / ReadFileLength));
		
		if(Position < 0) Position = 0;
		//progress bar on different screen now
 
	    ((CProgressCtrl*)(g_pxferctrl->GetDlgItem(IDC_FILEOUTPROGRESS)))->SetPos(Position);

    }
	

    //  print a nice message if this has completed successfully, rather than having been cut short...
    
    if(FileSent)
    {
        DWORD TimeAtEnd = ::GetTickCount();
		
		// Kill Timer
//		KillTimer(TIMER_EVENT_ID_UPDATE_SENT_PROGRESS_BAR);


    	FileSent = false;


    	(void) _stprintf(Buffer,
            _T("File: %s,\r\n %u bytes sent in %d.%d seconds: approximately %d Kbits/sec."),
            ReadFile->GetFilePath(), ReadFileLength, (TimeAtEnd - FileStartTime)/1000 , ( (TimeAtEnd - FileStartTime) % 1000 + 5 ) / 10 ,
            ((8 * ReadFileLength / ((TimeAtEnd - FileStartTime)?(TimeAtEnd - FileStartTime):1)) ) );

    	nResponse = MessageBox(Buffer, NULL, MB_ICONINFORMATION);
    	// catch errors from message box?

		if(ReadFile)
    	{
    	    ReadFile->Close();
    		delete ReadFile;
    	    ReadFile = NULL;
    	}

		ReadFileLength = 0;
    
//    	((CProgressCtrl*)GetDlgItem(IDC_FILEOUTPROGRESS))->SetPos(0);
	    ((CProgressCtrl*)(g_pxferctrl->GetDlgItem(IDC_FILEOUTPROGRESS)))->SetPos(0);
    	//  Stop sending a file.
		//TODO channel->send_data(NULL,0,false);
		HCISendData->ConnectionHandle		= AclConnectionCompleteEventData->ConnectionHandle;
		HCISendData->PacketBoundaryFlag		= 1;
		HCISendData->BroadcastFlag			= 0;
		HCISendData->DataStart				= NULL;
		HCISendData->DataLength				= 0;
		SendHCIMessage();

	}
}

/////////////////////////////////////////////////////////////////////////////////////
//  Function: OnHCIFileMore - called when the BCM_FILE_MORE message is sent.
//
//  Description:  Send a file as HCI data packets.
/////////////////////////////////////////////////////////////////////////////////////
void CBlueChat2Dlg::OnHCIFileMore(WPARAM dummy, LPARAM ldummy) 
{
	unsigned int 	Length;
	char 		   *FileBuffer;
	bool 			Boundary = true;
	uint16 			LLCAPpacketLength;
    char            TempBuffer[ 128 * HCI_PKT_PER_L_PKT ];   // could only be 128 but we don't care about stack space

    Length = HCICmdCompReadBufferSizeEventData->HcAclDataPacketLength * HCIpacketsPerL2CAPpacket;

    //  If there is some data in the buffer, leave it.  This function should be called at least
    //  once every 8 HCI packets, so this isn't a problem ATM...
    if ( mEngine->getSizeOfBufferContent() > Length )
        return;

	if (Length > sizeof (TempBuffer))
    {
		FileBuffer = new char[Length];
    }
    else
    {
        FileBuffer = TempBuffer;
    }

    //  The Length of each HCI packet has been defined by the chip.
    if (FileBeingSent)
    {
	   	LLCAPpacketLength = ReadFile->Read(FileBuffer + 4, Length - 4);
		Length = LLCAPpacketLength + 4;

	   	//  Length of the L2CAP packet, is in that case, just 4 less than the HCI packet.
	   	FileBuffer[1] = LLCAPpacketLength / 256;
	   	FileBuffer[0] = LLCAPpacketLength % 256;

	   	//  file transfer packet, so channel is 0x0002.
	   	FileBuffer[2] = 2;
	   	FileBuffer[3] = 0;

	   	FilePositionCounter += LLCAPpacketLength;

	   	if(FilePositionCounter >= ReadFileLength)
	   	{
	   		FileBeingSent 	= false;
            FileSent = true;
            OutputDebugString (_T("Ended\n"));
	   	}

        PostMessage ( UDM_HCI_FILE_PROGRESS );
	   	
	   	// channel->send_data(FileBuffer, Length, Boundary);
	   	HCISendData->ConnectionHandle		= AclConnectionCompleteEventData->ConnectionHandle;
	   	HCISendData->PacketBoundaryFlag		= Boundary;
	   	HCISendData->BroadcastFlag			= 0;
	   	HCISendData->DataStart				= (uint8*)FileBuffer;
	   	HCISendData->DataLength				= Length;
	   	SendHCIMessage();
    }

    if (TempBuffer != FileBuffer)
    {
	   	delete FileBuffer;
    }

//TODO    else if (!channel->DataToChip->EventWaiting)
	
	//if(FileSent) PostMessage(UDM_HCI_FILE_PROGRESS, 0, 0);
}

void CBlueChat2Dlg::OnHCIEvent(unsigned int EventCode, void * HCIDataPacket)
{
	unsigned int 	i;
	unsigned int 	EParIndex;
	CString			BufferStatus;
	CString			TempString;
	bool			DisplayTextToScreen		= true;

	
	// Make a copy to reduce casting issues
	PARAMETER_ARRAY HCIEventData = (PARAMETER_ARRAY)HCIDataPacket;


	switch(EventCode)
	{

		case HCI_EV_INQUIRY_COMPLETE:	
			{
				TempString = "Inquiry Complete";
				// Memory Clean Up done by dialog box code
				HCI_INQUIRY_COMPLETE_EVENT * InquiryCompleteEventData = new HCI_INQUIRY_COMPLETE_EVENT;
				
				InquiryCompleteEventData->Status 			= (unsigned char)	HCIEventData[2];    
				InquiryCompleteEventData->NumberResponces 	= (unsigned char)	HCIEventData[3];    
							 
				//((CBlueChat2Engine*)aThis)->BC2Dialog
				PostMessage(UDM_ON_HCI_INQUIRY_COMPLETE_EVENT, 0, (LPARAM)InquiryCompleteEventData);
				break;
			}
	
		case HCI_EV_INQUIRY_RESULT:
			TempString = "Inquiry Result";

			for(i = 0, EParIndex = 3; i < HCIEventData[2]; i++, EParIndex = 3)
			{
				// Memory Clean Up done by dialog box code
				HCI_INQUIRY_RESULT_EVENT * InquiryEventData = new HCI_INQUIRY_RESULT_EVENT;
				//((CBlueChat2Engine*)aThis)->HCIInquiryResultEventData = InquiryEventData;
				
				InquiryEventData->NumberResponces			= (unsigned char)	HCIEventData[2];    

				InquiryEventData->BTDeviceAddress.Lap    	= (unsigned int)	HCIEventData[EParIndex += i];
				
				i = EParIndex;

				InquiryEventData->BTDeviceAddress.Uap    	= (unsigned char)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->BTDeviceAddress.Nap    	= (unsigned short)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->PScanRepititionMode		= (unsigned char)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->PScanPeriodMode    		= (unsigned char)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->PScanMode         		= (unsigned char)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->ClassOfDevice      		= (unsigned char)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
				InquiryEventData->ClockOffset        		= (unsigned short)	HCIEventData[EParIndex += InquiryEventData->NumberResponces];
			
				PostMessage(UDM_ON_HCI_INQUIRY_EVENT, 0, (LPARAM)InquiryEventData);
			}
	
			break;

		case HCI_EV_CONN_COMPLETE:
			{
				TempString = "Conn Complete";
		 	
		 		// Memory Clean Up done by dialog box code
		 		HCI_CONNECTION_COMPLETE_EVENT * ConnectionCompleteEventData = new HCI_CONNECTION_COMPLETE_EVENT;
		 		//((CBlueChat2Engine*)aThis)->HCIInquiryResultEventData = InquiryEventData;
				
				ConnectionCompleteEventData->Status					= (unsigned char)	HCIEventData[2];
				ConnectionCompleteEventData->ConnectionHandle		= (unsigned int)	(CONNECTION_HANDLE_MASK & HCIEventData[3]);
				ConnectionCompleteEventData->BTDeviceAddress.Lap	= (unsigned int)	HCIEventData[4];
				ConnectionCompleteEventData->BTDeviceAddress.Uap	= (unsigned char)	HCIEventData[5];
				ConnectionCompleteEventData->BTDeviceAddress.Nap	= (unsigned short)	HCIEventData[6];
				ConnectionCompleteEventData->LinkType				= (unsigned char)	HCIEventData[7];
				ConnectionCompleteEventData->EncryptionMode			= (unsigned char)	HCIEventData[8];
				
				PostMessage(UDM_ON_HCI_CONNECTION_COMPLETE_EVENT, 0, (LPARAM)ConnectionCompleteEventData);
			}
			break;
															                                                    	      

		case HCI_EV_CONN_REQUEST:                     		
			{
				TempString = "Conn Request";

		 		// Memory Clean Up done by dialog box code
		 		HCI_CONNECTION_REQUEST_EVENT * ConnectionRequestEventData = new HCI_CONNECTION_REQUEST_EVENT;
				
				ConnectionRequestEventData->BTDeviceAddress.Lap	= (unsigned int)	HCIEventData[2];
				ConnectionRequestEventData->BTDeviceAddress.Uap	= (unsigned char)	HCIEventData[3];
				ConnectionRequestEventData->BTDeviceAddress.Nap	= (unsigned short)	HCIEventData[4];
				ConnectionRequestEventData->ClassOfDevice		= (unsigned int)	HCIEventData[5];
				ConnectionRequestEventData->LinkType			= (unsigned char)	HCIEventData[6];
				
				ProcessHciEvConnectionRequest(ConnectionRequestEventData);
			
			}
			break;
															                                                    	      


		case HCI_EV_DISCONNECT_COMPLETE:              		
			{
				TempString = "Disconnect Complete";
		 		
		 		// Memory Clean Up done by dialog box code
		 		HCI_DISCONNECTION_COMPLETE_EVENT * DisconnectionCompleteEventData = new HCI_DISCONNECTION_COMPLETE_EVENT;
		 		//((CBlueChat2Engine*)aThis)->HCIInquiryResultEventData = InquiryEventData;
				
				DisconnectionCompleteEventData->Status				= (unsigned char)	HCIEventData[2];
				DisconnectionCompleteEventData->ConnectionHandle	= (unsigned int)	(CONNECTION_HANDLE_MASK & HCIEventData[3]);
				DisconnectionCompleteEventData->Reason				= (unsigned char)	HCIEventData[4];


				PostMessage(UDM_ON_HCI_DISCONNECT_EVENT, 0, (LPARAM)DisconnectionCompleteEventData);

			}
			break;

		case HCI_EV_AUTH_COMPLETE:                    		TempString = "Auth Complete";                  	break;
															                                                   	      
		case HCI_EV_REMOTE_NAME_REQ_COMPLETE:         		TempString = "Remote Name Req Complete";       	break;
															                                                                     	      
		case HCI_EV_ENCRYPTION_CHANGE:                		TempString = "Encryption Change";              	break;
															                                                   	      
		case HCI_EV_CHANGE_CONN_LINK_KEY_COMPLETE:    		TempString = "Change Conn Link Key Complete";  	break;
															                                                   	      
		case HCI_EV_MASTER_LINK_KEY_COMPLETE:         		TempString = "Master Link Key Complete";       	break;
															                                                   	      
		case HCI_EV_READ_REM_SUPP_FEATURES_COMPLETE:  		TempString = "Read Rem Supp Features Complete";	break;
															                                                   	      
		case HCI_EV_READ_REMOTE_VER_INFO_COMPLETE:    		TempString = "Read Remote Ver Info Complete";  	break;
															                                                   	      
		case HCI_EV_QOS_SETUP_COMPLETE:               		TempString = "Qos Setup Complete";             	break;
															                                                    	      
		case HCI_EV_COMMAND_COMPLETE:                 		
			{
				TempString = "Command Complete";

				// Memory Clean Up done by dialog box code
				PARAMETER_ARRAY CommandCompleteHCIDataPacket = new PARAMETER_VALUE[(HCIEventData[0])];
				
				for(i = 0; i < HCIEventData[0]; i++) CommandCompleteHCIDataPacket[i] = HCIEventData[i];
				
				PostMessage(UDM_ON_HCI_COMMAND_COMPLETE_EVENT, (WPARAM)CommandCompleteHCIDataPacket[3], (LPARAM)CommandCompleteHCIDataPacket);
				
				break;
			}												                                                    	      
		
		case HCI_EV_COMMAND_STATUS:                   		
			{
				TempString = "Command Status";

				// Memory Clean Up done by Process handler
				HCI_COMMAND_STATUS_EVENT * HCICmdStatusEvent = new HCI_COMMAND_STATUS_EVENT;
			
				HCICmdStatusEvent->Status 				= (unsigned char)HCIEventData[2];
				HCICmdStatusEvent->NumHciCommandPackets = (unsigned char)HCIEventData[3];
				HCICmdStatusEvent->CommandOpCode		= HCIEventData[4];

				ProcessHciEvCommandStatus(HCICmdStatusEvent);
			
				break;
			}
		case HCI_EV_HARDWARE_ERROR:                   		TempString = "Hardware Error";                 	break;
															                                                   	      
		case HCI_EV_FLUSH_OCCURRED:                   		TempString = "Flush Occurred";                 	break;
															                                                   	      
		case HCI_EV_ROLE_CHANGE:                      		TempString = "Role Change";                    	break;
															                                                    	      
		case HCI_EV_NUMBER_COMPLETED_PKTS:            		

			DisplayTextToScreen = false;
			
//TO Do		// For Now, Send Next Packet
			if(FileBeingSent)
			{
                OnHCIFileMore ( 0 , 0 );
			}
			
			break;
															                                                    	      
		case HCI_EV_MODE_CHANGE:                      		TempString = "Mode Change";                    	break;
															                                                         
		case HCI_EV_RETURN_LINK_KEYS:                 		TempString = "Return Link Keys";               	break;
															                                                         
		case HCI_EV_PIN_CODE_REQ:                     		TempString = "Pin Code Req";                   	break;
															                                                         
		case HCI_EV_LINK_KEY_REQ:                     		TempString = "Link Key Req";                   	break;
															                                                         
		case HCI_EV_LINK_KEY_NOTIFICATION:            		TempString = "Link Key Notification";          	break;
															                                                         
		case HCI_EV_LOOPBACK_COMMAND:                 		TempString = "Loopback Command";               	break;
															                                                         
		case HCI_EV_DATA_BUFFER_OVERFLOW:             		TempString = "Data Buffer Overflow";           	break;
															                                                         
		case HCI_EV_MAX_SLOTS_CHANGE:                 		TempString = "Max Slots Change";               	break;
															                                                         
		case HCI_EV_READ_CLOCK_OFFSET_COMPLETE:       		TempString = "Read Clock Offset Complete";     	break;
															                                                         
		case HCI_EV_CONN_PACKET_TYPE_CHANGED:         		TempString = "Conn Packet Type Changed";       	break;
															                                                         
		case HCI_EV_QOS_VIOLATION:                    		TempString = "Qos Violation";                  	break;
															                                                         
		case HCI_EV_PAGE_SCAN_MODE_CHANGE:            		TempString = "Page Scan Mode Change";          	break;
															                                                         
		case HCI_EV_PAGE_SCAN_REP_MODE_CHANGE:        		TempString = "Page Scan Rep Mode Change";      	break;
															                                                         
		case HCI_MAX_EVENT_OPCODE:                    		TempString = "Hci Max Event Opcode";            break;

	}

// 
// 		EventCode: 000f HCIDataPacket: 0005 000f 0000 0001 0000 fdfdfdfd 0041 0041 5530e0 0000
// 		EventCode: 000e HCIDataPacket: 0008 000e 0001 1009 0000 0000 005b 0002 cdcdcdcd cdcdcdcdResent RBS and RBA
// 
// 		EventCode: 000e HCIDataPacket: 0009 000e 0001 1005 0000 0080 0040 0008 0008 cdcdcdcd
// 		EventCode: 000e HCIDataPacket: 0008 000e 0001 1009 0000 0000 005b 0002 cdcdcdcd cdcdcdcd
// 	
	
	if(DisplayTextToScreen)
	{
		// Display received HCI_Event message to screen.
		BufferStatus.Format(_T("HCI Event: %s  Event Code: %02x  "), TempString, HCIEventData[1]);
		if(HCIEventData[0] > 2)
		{
			TempString.Format(_T("Parameters: "));
			BufferStatus.Insert(500, TempString);

			for(i = 2; i < HCIEventData[0]; i++)
			{
				TempString.Format(_T(" %04lx "), HCIEventData[i]);
				BufferStatus.Insert(500, TempString);
			}
		}
		AppendHCIDisplay(BufferStatus);
	}

	// Clean up the memory here....
	delete (PARAMETER_ARRAY*)HCIEventData;
}

void CBlueChat2Dlg::SendChar(WPARAM nChar, LPARAM dummy)
{

	//  Called on every keypress in InputWindow.
	if(Connected && !Audio && !FileBeingSent)
	{
		//  And send data to the other bluetooth device.
		//  It's a character, length = 2, so channel = 1.
		HCISendDataMessage[0] 				= (char) 2;
		HCISendDataMessage[1] 				= (char) 0;
		HCISendDataMessage[2] 				= (char) 1;
		HCISendDataMessage[3] 				= (char) 0;
		HCISendDataMessage[4] 				= (char) nChar;
		HCISendDataMessage[5] 				= (char) NULL;

		HCISendData->ConnectionHandle		= AclConnectionCompleteEventData->ConnectionHandle;
		HCISendData->PacketBoundaryFlag		= 1;
		HCISendData->BroadcastFlag			= 0;
		HCISendData->DataStart				= HCISendDataMessage;
		HCISendData->DataLength				= 6;

		SendHCIMessage();
	}
}


void CBlueChat2Dlg::OnCommandComplete(unsigned int Opcode, void *HCIDataPacket)
{
	CString TempString;
	CString	Address;
	CString	BufferStatus;
	bool	DisplayTextToScreen		= true;
	unsigned int i;

	// Make a copy to reduce casting issues
	PARAMETER_ARRAY HCIEventData = (PARAMETER_ARRAY)HCIDataPacket;

	// AppendHCIDisplay("On Command Complete Posted Message");
		
	switch(Opcode)
	{
		/******************************************************************************
		OCF opcode defines - Link Control Commands
		*****************************************************************************/
		case  HCI_INQUIRY:						TempString = "hci_inquiry";						break;
		case  HCI_INQUIRY_CANCEL:				TempString = "hci_inquiry_cancel";				break;
		case  HCI_PERIODIC_INQUIRY_MODE:		TempString = "hci_periodic_inquiry_mode";		break;
		case  HCI_EXIT_PERIODIC_INQUIRY_MODE:	TempString = "hci_exit_periodic_inquiry_mode";	break;
		case  HCI_CREATE_CONNECTION:			TempString = "hci_create_connection";			break;
		case  HCI_DISCONNECT:					TempString = "hci_disconnect";					break;
		case  HCI_ADD_SCO_CONNECTION:			TempString = "hci_add_sco_connection";			break;
		case  HCI_ACCEPT_CONNECTION_REQ:		TempString = "hci_accept_connection_req";		break;
		case  HCI_REJECT_CONNECTION_REQ:		TempString = "hci_reject_connection_req";		break;
		case  HCI_LINK_KEY_REQ_REPLY:			TempString = "hci_link_key_req_reply";			break;
		case  HCI_LINK_KEY_REQ_NEG_REPLY:		TempString = "hci_link_key_req_neg_reply";		break;
		case  HCI_PIN_CODE_REQ_REPLY:			TempString = "hci_pin_code_req_reply";			break;
		case  HCI_PIN_CODE_REQ_NEG_REPLY:		TempString = "hci_pin_code_req_neg_reply";		break;
		case  HCI_CHANGE_CONN_PKT_TYPE:			TempString = "hci_change_conn_pkt_type";		break;
		case  HCI_AUTH_REQ:						TempString = "hci_auth_req";					break;
		case  HCI_SET_CONN_ENCRYPTION:			TempString = "hci_set_conn_encryption";			break;
		case  HCI_CHANGE_CONN_LINK_KEY:			TempString = "hci_change_conn_link_key";		break;
		case  HCI_MASTER_LINK_KEY:				TempString = "hci_master_link_key";				break;
		case  HCI_REMOTE_NAME_REQ:				TempString = "hci_remote_name_req";				break;
		case  HCI_READ_REMOTE_SUPP_FEATURES:	TempString = "hci_read_remote_supp_features";	break;
		case  HCI_READ_REMOTE_VER_INFO:			TempString = "hci_read_remote_ver_info";		break;
		case  HCI_READ_CLOCK_OFFSET:			TempString = "hci_read_clock_offset";			break;
		case  HCI_MAX_LINK_OCF:					TempString = "hci_max_link_ocf";				break;

		/******************************************************************************
		OP CODE defines - Link Policy Commands
		*****************************************************************************/
		case HCI_HOLD_MODE:						TempString = "hci_hold_mode";					break;
		case HCI_SNIFF_MODE:					TempString = "hci_sniff_mode";					break;
		case HCI_EXIT_SNIFF_MODE:				TempString = "hci_exit_sniff_mode";				break;
		case HCI_PARK_MODE:						TempString = "hci_park_mode";					break;
		case HCI_EXIT_PARK_MODE:				TempString = "hci_exit_park_mode";				break;
		case HCI_QOS_SETUP:						TempString = "hci_qos_setup";					break;
		case HCI_ROLE_DISCOVERY:				TempString = "hci_role_discovery";				break;
		case HCI_SWITCH_ROLE:					TempString = "hci_switch_role";					break;
		case HCI_READ_LINK_POLICY_SETTINGS:		TempString = "hci_read_link_policy_settings";	break;
		case HCI_WRITE_LINK_POLICY_SETTINGS:	TempString = "hci_write_link_policy_settings";	break;
		case HCI_MAX_POLICY_OCF:				TempString = "hci_max_policy_ocf";				break;

		/******************************************************************************
		OP CODE defines - Host Controller and Baseband commands
		*****************************************************************************/
		case HCI_SET_EVENT_MASK:				TempString = "hci_set_event_mask";				break;
		case HCI_RESET:							TempString = "hci_reset";						break;
		case HCI_SET_EVENT_FILTER:				TempString = "hci_set_event_filter";			break;
		case HCI_FLUSH:							TempString = "hci_flush";						break;
		case HCI_READ_PIN_TYPE:					TempString = "hci_read_pin_type";				break;
		case HCI_WRITE_PIN_TYPE:				TempString = "hci_write_pin_type";				break;
		case HCI_CREATE_NEW_UNIT_KEY:			TempString = "hci_create_new_unit_key";			break;
		case HCI_READ_STORED_LINK_KEY:			TempString = "hci_read_stored_link_key";		break;
		case HCI_WRITE_STORED_LINK_KEY:			TempString = "hci_write_stored_link_key";		break;
		case HCI_DELETE_STORED_LINK_KEY:		TempString = "hci_delete_stored_link_key";		break;
		case HCI_CHANGE_LOCAL_NAME:				TempString = "hci_change_local_name";			break;
		case HCI_READ_LOCAL_NAME:				TempString = "hci_read_local_name";				break;
		case HCI_READ_CONN_ACCEPT_TIMEOUT:		TempString = "hci_read_conn_accept_timeout";	break;
		case HCI_WRITE_CONN_ACCEPT_TIMEOUT:		TempString = "hci_write_conn_accept_timeout";	break;
		case HCI_READ_PAGE_TIMEOUT:				TempString = "hci_read_page_timeout";			break;
		case HCI_WRITE_PAGE_TIMEOUT:			TempString = "hci_write_page_timeout";			break;
		case HCI_READ_SCAN_ENABLE:				TempString = "hci_read_scan_enable";			break;
		case HCI_WRITE_SCAN_ENABLE:				TempString = "hci_write_scan_enable";			break;
		case HCI_READ_PAGESCAN_ACTIVITY:		TempString = "hci_read_pagescan_activity";		break;
		case HCI_WRITE_PAGESCAN_ACTIVITY:		TempString = "hci_write_pagescan_activity";		break;
		case HCI_READ_INQUIRYSCAN_ACTIVITY:		TempString = "hci_read_inquiryscan_activity";	break;
		case HCI_WRITE_INQUIRYSCAN_ACTIVITY:	TempString = "hci_write_inquiryscan_activity";	break;
		case HCI_READ_AUTH_ENABLE:				TempString = "hci_read_auth_enable";			break;
		case HCI_WRITE_AUTH_ENABLE:				TempString = "hci_write_auth_enable";			break;
		case HCI_READ_ENC_MODE:					TempString = "hci_read_enc_mode";				break;
		case HCI_WRITE_ENC_MODE:				TempString = "hci_write_enc_mode";				break;
		case HCI_READ_CLASS_OF_DEVICE:			TempString = "hci_read_class_of_device";		break;
		case HCI_WRITE_CLASS_OF_DEVICE:			TempString = "hci_write_class_of_device";		break;
		case HCI_READ_VOICE_SETTING:			TempString = "hci_read_voice_setting";			break;
		case HCI_WRITE_VOICE_SETTING:			TempString = "hci_write_voice_setting";			break;
		case HCI_READ_AUTO_FLUSH_TIMEOUT:		TempString = "hci_read_auto_flush_timeout";		break;
		case HCI_WRITE_AUTO_FLUSH_TIMEOUT:		TempString = "hci_write_auto_flush_timeout";	break;
		case HCI_READ_NUM_BCAST_RETXS:			TempString = "hci_read_num_bcast_retxs";		break;
		case HCI_WRITE_NUM_BCAST_RETXS:			TempString = "hci_write_num_bcast_retxs";		break;
		case HCI_READ_HOLD_MODE_ACTIVITY:		TempString = "hci_read_hold_mode_activity";		break;
		case HCI_WRITE_HOLD_MODE_ACTIVITY:		TempString = "hci_write_hold_mode_activity";	break;
		case HCI_READ_TX_POWER_LEVEL:			TempString = "hci_read_tx_power_level";			break;
		case HCI_READ_SCO_FLOW_CON_ENABLE:		TempString = "hci_read_sco_flow_con_enable";	break;
		case HCI_WRITE_SCO_FLOW_CON_ENABLE:		TempString = "hci_write_sco_flow_con_enable";	break;
		case HCI_SET_HCTOHOST_FLOW_CONTROL:		TempString = "hci_set_hctohost_flow_control";	break;
		case HCI_HOST_BUFFER_SIZE:				TempString = "hci_host_buffer_size";			break;
		case HCI_HOST_NUM_COMPLETED_PACKETS:	TempString = "hci_host_num_completed_packets";	break;
		case HCI_READ_LINK_SUPERV_TIMEOUT:		TempString = "hci_read_link_superv_timeout";  	break;
		case HCI_WRITE_LINK_SUPERV_TIMEOUT:		TempString = "hci_write_link_superv_timeout"; 	break;
		case HCI_READ_NUM_SUPPORTED_IAC:		TempString = "hci_read_num_supported_iac";	  	break;
		case HCI_READ_CURRENT_IAC_LAP:			TempString = "hci_read_current_iac_lap";	  	break;
		case HCI_WRITE_CURRENT_IAC_LAP:			TempString = "hci_write_current_iac_lap";	  	break;
		case HCI_READ_PAGESCAN_PERIOD_MODE:		TempString = "hci_read_pagescan_period_mode"; 	break;
		case HCI_WRITE_PAGESCAN_PERIOD_MODE:	TempString = "hci_write_pagescan_period_mode";	break;
		case HCI_READ_PAGESCAN_MODE:			TempString = "hci_read_pagescan_mode";			break;
		case HCI_WRITE_PAGESCAN_MODE:			TempString = "hci_write_pagescan_mode";			break;
		case HCI_MAX_HOST_BB_OCF:				TempString = "hci_max_host_bb_ocf";				break;

		/******************************************************************************
		OP CODE defines - Informational Parameters
		*****************************************************************************/
		case HCI_READ_LOCAL_VER_INFO:			TempString = "hci_read_local_ver_info";			break;
		case HCI_READ_LOCAL_SUPP_FEATURES:		TempString = "hci_read_local_supp_features";  	break;

		case HCI_READ_BUFFER_SIZE:
			DisplayTextToScreen = false;
			BufferStatus.Format(_T("hci_read_buffer_size: Status: %d"), HCIEventData[4]);
			AppendHCIDisplay(BufferStatus);
			
			HCICmdCompReadBufferSizeEventData->Status					   	= (unsigned char) HCIEventData[4];
			
			if(HCICmdCompReadBufferSizeEventData->Status == 0)
			{															   	  
				// Display this to HCI list display
				BufferStatus.Format(_T("ACL Packet Length: %03d   Total Packets: %03d"), HCIEventData[5], HCIEventData[7]);
				
				AppendHCIDisplay(BufferStatus);
				BufferStatus.Format(_T("SCO Packet Length: %03d   Total Packets: %03d"), HCIEventData[6], HCIEventData[8]);
				AppendHCIDisplay(BufferStatus);
				
				HCICmdCompReadBufferSizeEventData->HcAclDataPacketLength   	= (unsigned int)  HCIEventData[5];
				HCICmdCompReadBufferSizeEventData->HcScoDataPacketLength   	= (unsigned char) HCIEventData[6];
				HCICmdCompReadBufferSizeEventData->HcTotalNumAclDataPackets	= (unsigned int)  HCIEventData[7];
				HCICmdCompReadBufferSizeEventData->HcTotalNumScoDataPackets	= (unsigned int)  HCIEventData[8];
			}
			else
			{
				// Process Error
				TRACE(_T("\n\rBUFFER SIZE ERROR"));
			}

			break;

		
		case HCI_READ_COUNTRY_CODE:				TempString = "hci_read_country_code";	break;

		
		case HCI_READ_BD_ADDR:					
			DisplayTextToScreen 	= false;

			TempString = "hci_read_bd_addr";			  	

			HCICmdCompReadBdAddrEventData->Status				  	= (unsigned char)  HCIEventData[4];
			
			if(HCICmdCompReadBdAddrEventData->Status == 0)
			{
				HCICmdCompReadBdAddrEventData->BTDeviceAddress.Lap	= (unsigned int)   HCIEventData[5];
				HCICmdCompReadBdAddrEventData->BTDeviceAddress.Uap	= (unsigned char)  HCIEventData[6];
				HCICmdCompReadBdAddrEventData->BTDeviceAddress.Nap	= (unsigned short) HCIEventData[7];
				Address.Format(_T("LAP:%06x  UAP:%02x  NAP:%04x"),	HCIEventData[5], HCIEventData[6], HCIEventData[7]);

				GetDlgItem(IDC_LOCAL_BDADDR)->SetWindowText(Address);
			}
			else
			{
				// Process Error
				TRACE(_T("\n\rREAD BD ADDRESS ERROR"));
			}
			
			break;
		
		case HCI_MAX_INFO_OCF:					TempString = "hci_max_info_ocf";			  	break;

		/******************************************************************************
		OP CODE defines - Status Parameters
		*****************************************************************************/
		case HCI_READ_FAILED_CONTACT_COUNT:		TempString = "hci_read_failed_contact_count"; 	break;
		case HCI_RESET_FAILED_CONTACT_COUNT:	TempString = "hci_reset_failed_contact_count";	break;
		case HCI_GET_LINK_QUALITY:				TempString = "hci_get_link_quality";			break;
		case HCI_READ_RSSI:						TempString = "hci_read_rssi";					break;
		case HCI_MAX_STATUS_OCF:				TempString = "hci_max_status_ocf";				break;

		/******************************************************************************
		OP CODE defines - Testing Parameters
		*****************************************************************************/
		case HCI_READ_LOOPBACK_MODE:			TempString = "hci_read_loopback_mode";			break;
		case HCI_WRITE_LOOPBACK_MODE:			TempString = "hci_write_loopback_mode";			break;
		case HCI_ENABLE_DUT_MODE:				TempString = "hci_enable_dut_mode";				break;
		case HCI_MAX_TEST_OCF:					TempString = "hci_max_test_ocf";				break;

		/******************************************************************************
		OP CODE defines - VENDOR SPECIFIC DEBUG parameters
		*****************************************************************************/
		case HCI_DEBUG_STATS:					TempString = "hci_debug_stats";					break;
		case HCI_DEBUG_STATS_ACL:				TempString = "hci_debug_stats_acl";				break;
		case HCI_DEBUG_STATS_SCO:				TempString = "hci_debug_stats_sco";				break;
		case HCI_DEBUG_MEM:						TempString = "hci_debug_mem";					break;
		case HCI_DEBUG_RAND:					TempString = "hci_debug_rand";					break;
		case HCI_DEBUG_KEY:						TempString = "hci_debug_key";					break;
		case HCI_DEBUG_SRES:					TempString = "hci_debug_sres";					break;
				
		default:								TempString = "Command Complete: Error Unknown OpCode";	break;
	}


	// Display a 'usefull' text message to screen if command commplete is not yet being handled....
	if(DisplayTextToScreen)
	{
		BufferStatus.Format(_T("HCI Command Complete: %s  Event Code: %02x  NoHCICmdPkts: %02x  OpCode: %04x  "), TempString, HCIEventData[1], HCIEventData[2], HCIEventData[3]);
		if(HCIEventData[0] > 4)
		{
			TempString.Format(_T("Parmeters: "));
			BufferStatus.Insert(500, TempString);

			for(i = 4; i < HCIEventData[0]; i++)
			{
				TempString.Format(_T("%lx "), HCIEventData[i]);
				BufferStatus.Insert(500, TempString);
			}
		}
		AppendHCIDisplay(BufferStatus);
	}
	
	// Clean up the memory here....
	delete (PARAMETER_ARRAY*)HCIEventData;
}
void CBlueChat2Dlg::OnInquiryComplete(WPARAM dummy, void * HCIDataPacket)
{
	CComboBox	   *pCBoxItem;
	CString			Address;
	unsigned short	i;

	AppendHCIDisplay("Inquiry Complete: Device's found...");

	pCBoxItem = (CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR);
	
	//re-enable connect button only if there is someone out there...
	if(pCBoxItem->GetCount())	
	{
		GetDlgItem(IDC_CONNECT)->EnableWindow(true);
		
		for(i = 0; i < pCBoxItem->GetCount(); i++)
		{
			pCBoxItem->GetLBText(i, Address);
			AppendHCIDisplay(Address);
		} 
	}
	else AppendHCIDisplay("No responses received");
	
    //re-enable inquiry button
    GetDlgItem(IDC_INQUIRE)	  		->EnableWindow(true);
    GetDlgItem(IDC_DISCONNECT2)		->EnableWindow(true);
    GetDlgItem(IDC_INQUIRE)   		->EnableWindow(true);
    GetDlgItem(IDC_INQUIRE)   		->ShowWindow( SW_SHOWNOACTIVATE );
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->ShowWindow( SW_HIDE );
	
	delete (HCI_INQUIRY_COMPLETE_EVENT*)HCIDataPacket;
}
void  CBlueChat2Dlg::ReceiveHCIDataPacket(WPARAM Dummy,	void * HCIDataPacket)
{
	uint8		  * Data;
	bool 			NameNeedsDeleting 	= false;
    HCI_SEND_DATA * thisPacket = (HCI_SEND_DATA*)HCIDataPacket;
    uint32          excessData = 0;
	if( thisPacket->PacketBoundaryFlag)
    {
        //  New packet arriving.  Process the complete one.
        checkStatusOfPacket ( currentL2CAPPacket );
        //  create a new one.
        currentL2CAPPacket = new L2CAP_PACKET_T;
        currentL2CAPPacket->channel = 0;
        currentL2CAPPacket->length = 0;
        currentL2CAPPacket->nextByteToRecv = 0;
        currentL2CAPPacket->Data = 0;
    }

    if ( currentL2CAPPacket == NULL )
    {
        OutputDebugString (_T( "!!! Data without a packet Boundary start..." ));
        return;
    }

    for ( Data = thisPacket->DataStart ; Data != thisPacket->DataStart + thisPacket->DataLength ; Data ++ )
    {
		TRACE(_T(". %ld %c"), Data, *Data); /* Debug */
        
		TRACE(_T(" %ld ."), thisPacket->DataStart + thisPacket->DataLength); /* Debug */
		
		switch  ( currentL2CAPPacket->nextByteToRecv )
        {
        case 0:
            //  Low byte of uint16 of length
            currentL2CAPPacket->length = *Data;
			break;
        case 1:
            //  High byte of uint16 of length
            currentL2CAPPacket->length += *Data << 8;
            {
                TCHAR debug_buffer[256];
                _stprintf (debug_buffer, _T("\n\rRecv Length %04x"), currentL2CAPPacket->length);
                
				OutputDebugString (debug_buffer);
            }
            break;
        case 2:
            //  Low byte of uint16 of channel
            currentL2CAPPacket->channel = *Data;
            break;
        case 3:
            //  High byte of uint16 of channel
            currentL2CAPPacket->channel += *Data << 8;
            if ( currentL2CAPPacket->length == 0 )
            {
                OutputDebugString ( _T("ZeroLength L2CAP packet!!") );
                delete currentL2CAPPacket;
                currentL2CAPPacket = NULL;
            }
            else
                currentL2CAPPacket->Data = new uint8[currentL2CAPPacket->length];
            break;
        default:
            //  Real Data!!
            if ( currentL2CAPPacket != NULL )
            {
                currentL2CAPPacket->Data[currentL2CAPPacket->nextByteToRecv - 4] = *Data;
            }
            else
            {
                if ( excessData == 0 )
                {
                    OutputDebugString ( _T("Help, Help, too much data..." ));
                }
                excessData ++;
            }
            break;
        }
        
        if ( currentL2CAPPacket != NULL )
        {
            currentL2CAPPacket->nextByteToRecv ++ ;

            if ( currentL2CAPPacket->nextByteToRecv == currentL2CAPPacket->length + 4 )
            {
                processPacket ( currentL2CAPPacket );
            }
            else if ( currentL2CAPPacket->nextByteToRecv > currentL2CAPPacket->length + 4 )
                OutputDebugString ( _T("More Data in Current L2CAP Packet than we want.") );
        }
    }

    if ( excessData > 0 )
    {
        TCHAR buffer[100];
        _stprintf ( buffer , _T("Discarded %u bytes of data") , excessData );
		OutputDebugString ( buffer );
    }

	delete thisPacket->DataStart;
    delete HCIDataPacket;
}


void CBlueChat2Dlg::ProcessHciEvCommandStatus(HCI_COMMAND_STATUS_EVENT * HCICmdStatusEvent)
{
	{
		// TO DO......................
		// Process Command Status
	}

	// Delete that memory....
	delete HCICmdStatusEvent;
}



void CBlueChat2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlueChat2Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

IMPLEMENT_DYNAMIC(CBlueChat2Dlg, CDialog);

BEGIN_MESSAGE_MAP(CBlueChat2Dlg, CDialog)
	//{{AFX_MSG_MAP(CBlueChat2Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_INQUIRE, 							OnInquire)
	ON_BN_CLICKED(IDC_MASTER, 							OnMaster)
	ON_BN_CLICKED(IDC_SLAVE, 							OnSlave)
	ON_BN_CLICKED(IDC_CONNECT, 							OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT2, 						OnDisconnect)
	ON_BN_CLICKED(IDC_AUDIO, 							OnAudio)
	ON_BN_CLICKED(IDC_DATA, 							OnData)
	ON_CBN_SELCHANGE(IDC_REMOTE_BDADDR, 				OnSelchangeRemoteBdaddr)
	ON_WM_TIMER()
//	ON_BN_CLICKED(IDC_BROWSE, 							OnBrowse)
//	ON_BN_CLICKED(IDC_SEND, 							OnSend)
	ON_BN_CLICKED(IDC_INQUIRE_CANCEL2, 					OnInquireCancel)
	ON_BN_CLICKED(IDCHAT, OnMore)
	ON_BN_CLICKED(IDDEBUGSCREEN, OnMore2)
	ON_BN_CLICKED(IDFILE, OnXfer)
	ON_BN_CLICKED(IDC_ABOUTBUTTON1, OnAboutcsr)
	//}}AFX_MSG_MAP

	ON_MESSAGE(UDM_ON_HCI_INQUIRY_EVENT, 				OnHCIInquiryResultEvent)
	ON_MESSAGE(UDM_ON_HCI_CONNECTION_COMPLETE_EVENT, 	OnConnectionComplete)
	ON_MESSAGE(UDM_ON_HCI_DISCONNECT_EVENT, 			OnDisconnectComplete)
    ON_MESSAGE(UDM_SEND_CHAR,							SendChar)
	ON_MESSAGE(UDM_RECEIVE_HCI_DATA_PACKET, 			ReceiveHCIDataPacket)
	ON_MESSAGE(UDM_ON_HCI_INQUIRY_COMPLETE_EVENT, 		OnInquiryComplete)
	ON_MESSAGE(UDM_ON_HCI_COMMAND_COMPLETE_EVENT, 		OnCommandComplete)
	ON_MESSAGE(UDM_ON_HCI_EVENT, 						OnHCIEvent)
    ON_MESSAGE(UDM_HCI_FILE_MORE,						OnHCIFileMore)
    ON_MESSAGE(UDM_HCI_FILE_PROGRESS,					UpdateProgressBar)
    ON_MESSAGE(UDM_SEND_FILE,							OnSend)




END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlueChat2Dlg message handlers

BOOL CBlueChat2Dlg::OnInitDialog()
{

	

	g_pTestDlg=NULL;	



	
	CDialog::OnInitDialog();

#ifndef _WINCE
	CMenu* pSysMenu = GetSystemMenu(this, FALSE);
#else
//	HMenu* pSysMenu = GetSystemMenu(this, FALSE);
#endif
#ifndef _WINCE
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		CString strHCICMD = "HCI Commands";
		CString strTraceOptions = "Trace setup";

		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			pSysMenu->AppendMenu(MF_STRING, IDM_HCICMD, strHCICMD);
#ifdef _DEBUG
			pSysMenu->AppendMenu(MF_STRING, IDM_TRACEOPTIONS, strTraceOptions);
#endif
		}
	}
#endif
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////

    mEngine = new CBlueChatEngine;

    // Set Dialog in Engine to this Dialog box for postmessage use
	mEngine->BC2Dialog = m_hWnd;

    // Link the chat window to the console object /*frig*/
    HCIDisplay.Initialise (IDC_HCIDISPLAY,	this, &m_hWnd);
    InputWindow.Initialise(IDC_INPUTWINDOW, this, &m_hWnd);

    //  Clear the messages
    InputWindow.Clear();
	InputWindow.SetWriteable(true);

	mEngine->setFactory (mFactory);
    mEngine->startChip();

    SetTimer(CONNECTION_TIMER, 50 , NULL);

	// Set flags status
	AboutToClose              	= false;
	Audio                     	= false;
	                          
	CommsStarted              	= false;
	Connected                 	= false;
	                          
	currentL2CAPPacket        	= NULL;
	FileBeingSent             	= false;
	FileSent                  	= false;
	FirstPacket               	= false;
	                          
	HiResClock                	= false;
	InquiryScanAllowed        	= false;
	Master                    	= false;
	PageScanAllowed           	= false;
	ReallyCloseComplete       	= false;
	Scanning                  	= false;
	TryingToDisconnect        	= false;
	                          
	WaitingForFirstPacket     	= false;
	WaitOnInit                	= false;
    DiscardFileData	          	= false;
    NewFile                   	= NULL;

    HCIpacketsPerL2CAPpacket 	= HCI_PKT_PER_L_PKT; // 256 = 32768 / 128, which is the max possible.
													 // cut down to 32 - so that the recv bar is updated more often
													 // overhead is 4 bytes in every 4k instead of 4 bytes in every 32k.

    PacketCounter 				= 0;


    // Set up initial status of dialog items
    ((CButton*)			GetDlgItem(IDC_DATA))			->SetCheck(1);
    ((CButton*)			GetDlgItem(IDC_AUDIO))			->SetCheck(0);
   ((CProgressCtrl*)	GetDlgItem(IDC_FILEINPROGRESS2))	->SetRange(0,100);

	ScoConnectionCompleteEventData   								= new HCI_CONNECTION_COMPLETE_EVENT;
	AclConnectionCompleteEventData   								= new HCI_CONNECTION_COMPLETE_EVENT;
	HCISendData						 								= new HCI_SEND_DATA;
	HCISendDataMessage 				 								= new uint8[256];
	HCIReceivedData					 								= new HCI_SEND_DATA;
	
	HCICmdCompReadBufferSizeEventData								= new HCI_CMD_COMPLETE_READ_BUFFER_SIZE_EVENT;
	HCICmdCompReadBufferSizeEventData->Status 						= 0;
	HCICmdCompReadBufferSizeEventData->HcAclDataPacketLength		= 0;
	HCICmdCompReadBufferSizeEventData->HcScoDataPacketLength		= 0;
	HCICmdCompReadBufferSizeEventData->HcTotalNumAclDataPackets		= 0;
	HCICmdCompReadBufferSizeEventData->HcTotalNumScoDataPackets		= 0;
	
	HCICmdCompReadBdAddrEventData	 								= new HCI_CMD_COMPLETE_READ_BD_ADDR_EVENT;
	HCICmdCompReadBdAddrEventData->Status							= 0;
	HCICmdCompReadBdAddrEventData->BTDeviceAddress.Lap				= 0;
	HCICmdCompReadBdAddrEventData->BTDeviceAddress.Uap				= 0;
	HCICmdCompReadBdAddrEventData->BTDeviceAddress.Nap				= 0;




	// Set timer event TIMER_EVENT_ID_RESET_CASIRA to see if we are talking to CASIRA, 
	// If timer reaches 0 and is run post message to reset CASIRA and or check comms and baud rate...
#ifndef _WINCE
    SetTimer(TIMER_EVENT_ID_RESET_CASIRA, 1000, NULL);
#else
    SetTimer(TIMER_EVENT_ID_RESET_CASIRA, 6000, NULL);
#endif

    //  Set up a timer to monitor the start transport initialisation.
    SetTimer ( CONNECTION_TIMER , 50 , NULL );

//	SipShowIM(SIPF_ON);		/* show the SIP icon - does not work on H/PC 2000*/
	// Display Port Name in dialog box
	GetDlgItem(IDC_USEDCOMPORT)->SetWindowText(mEngine->ComPortID);


///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}




void CBlueChat2Dlg::OnMore() 
{

	g_pTestDlg = new testdialog;
	if(g_pTestDlg->DoModal() == IDOK)
	{

	}
	delete g_pTestDlg;
	g_pTestDlg=NULL;

}

void CBlueChat2Dlg::OnAboutcsr() 
{
	g_pAboutBox = new CAboutDlg();
	if(g_pAboutBox->DoModal() == IDOK)
	{

	}
	delete g_pAboutBox;
	g_pAboutBox=NULL;
}


/* This is the dialog which displays the latest debug information */
/* I first of all tried to make it modeless but it would not create */
/* Windows CE? */

void CBlueChat2Dlg::OnMore2() 
{

/* modeless version - does not work*/

//	if (m_pModeless == NULL)
//	{
//		m_pModeless = new Chcidebug(this);
//		if (m_pModeless->Create() == TRUE)
//		{
//			GetDlgItem(IDDEBUGSCREEN)->EnableWindow(FALSE);
//			m_pModeless->SetActiveWindow();
//			SetForegroundWindow(m_pModeless);
//		}

//	}
//	else
//		m_pModeless->SetActiveWindow();

	
	g_pDebugWindow2 = new CDebugWindow(this);
	if(g_pDebugWindow2->DoModal() == IDOK)
	{

	}
	delete g_pDebugWindow2;
	g_pDebugWindow2=NULL;



}


/* Dialog for entering the name of a file 
to send to a connected Bluetooth device */



void CBlueChat2Dlg::OnXfer() 
{



	g_pxferctrl = new Cxferctrl3;

	if(g_pxferctrl->DoModal() == IDOK)
	{

	}
	delete g_pxferctrl;
	g_pxferctrl=NULL;



}



/////////////////////////////////////////////////////////////////////////////////////
//  Function: OnSend - called when the IDC_SEND button is pressed
//
//  Description:  Initialise the GUI to ]snd a file as HCI data packets.
//                The filename is in the IDC_FILENAME field.
//
//	For Windows CE - UDM_SEND_FILE message from the child window
//				causes this routine to be entered 
//
/////////////////////////////////////////////////////////////////////////////////////
void CBlueChat2Dlg::OnSend() 
{
	int 		nResponse;
	CString 	FileName = "";
	char	   *FileBuffer;
	int 		Length;
	uint16 		LLCAPpacketLength;

	
	CEdit* pList = (CEdit*) (g_pxferctrl->GetDlgItem(IDC_XFERFILENAME));
	CButton* pButton1 = (CButton*) (g_pxferctrl->GetDlgItem(IDC_BROWSER));
	CButton* pButton2 = (CButton*) (g_pxferctrl->GetDlgItem(IDC_SENDFILE));





    // Only allow one file to be sent at a time.
    if (!FileBeingSent)
    {
		//  Check we're connected
		if (!Connected)
		{
		    nResponse = MessageBox(_T("No bluetooth connection, cannot transmit data"), NULL, MB_ICONERROR);
		    // catch errors from message box?


//		    GetDlgItem(IDC_FILENAME)->EnableWindow(false);
//		    GetDlgItem(IDC_BROWSE)	->EnableWindow(false);
//		    GetDlgItem(IDC_SEND)	->EnableWindow(false);

			pList->EnableWindow(false);
			pButton1->EnableWindow(false);
			pButton2->EnableWindow(false);
			return;
		}

		//  Check that we aren't in audio mode
		if(Audio)
		{
		    nResponse = MessageBox(_T("Audio stream open, cannot transmit data"), NULL, MB_ICONERROR);
		    // catch errors from message box?
//		    GetDlgItem(IDC_FILENAME)->EnableWindow(false);
//			GetDlgItem(IDC_BROWSE)	->EnableWindow(false);
//			GetDlgItem(IDC_SEND)	->EnableWindow(false);

			pList->EnableWindow(false);
			pButton1->EnableWindow(false);
			pButton2->EnableWindow(false);			

			return;
		}
		
////		//  Get the filename from the screen field.
//		GetDlgItem(IDC_FILENAME)->GetWindowText(FileName);

		CEdit* pEdit = (CEdit*) (g_pxferctrl->GetDlgItem(IDC_XFERFILENAME));
		pEdit->GetWindowText(FileName);


		if(!FileName.IsEmpty())
		{
	        //  Open the file for reading.
		    ReadFile = new CStdioFile;
		    
		    if(ReadFile->Open(FileName,ReadFile->modeRead | ReadFile->shareDenyWrite | ReadFile->typeBinary))
		    {
				ReadFileLength = ReadFile->GetLength();
	            
	            //  avoid sending no data.
	            if (ReadFileLength == 0)
	            {
	            	MessageBox(_T("Empty file, not sent."), _T("File Error"),MB_ICONERROR);
					ReadFile->Close();
		        	
		        	delete ReadFile;
	            	
	            	((CProgressCtrl*)(g_pxferctrl->GetDlgItem(IDC_FILEOUTPROGRESS)))->SetPos(0);
	            	
	            	return;
	            }

	            //  warn the transmission thread that we're sending a file, by sending it zero
	            //  length data packet.
	            //  The boolean sets the file_being_sent flag in the worker thread..
	            
//TO DO			// channel->send_data(NULL,0,true);
				HCISendData->ConnectionHandle		= AclConnectionCompleteEventData->ConnectionHandle;
				HCISendData->PacketBoundaryFlag		= 1;
				HCISendData->BroadcastFlag			= 0;
				HCISendData->DataStart				= NULL;
				HCISendData->DataLength				= 0;
				SendHCIMessage();

	            //  following the NULL packet, the next packet will be a filename and file size.
	            //  The protocol for this transfer is a simplified L2CAP, described in the function OnHCIData.


	        	//  filename, without the full path, but with the extension.
				int StringLen = WideCharToMultiByte(CP_ACP,0,ReadFile->GetFileName(),-1,NULL,0,NULL,NULL);
				LLCAPpacketLength = StringLen + 1 + sizeof(uint32);  // Terminating NULL + uint32 for file length.
				Length = LLCAPpacketLength + 4; // 4 bytes, two for packet length, two for channel.
				FileBuffer = new char[Length];
				memset(FileBuffer, '\0', Length);
				// Put filename into FileBuf
				WideCharToMultiByte(CP_ACP,0,ReadFile->GetFileName(),-1,(FileBuffer + 4 + sizeof(uint32)),StringLen + 1,NULL,NULL);

				//  four bytes for the filelength (assumes file is smaller than 4194304k, ie 4 giga bytes)
				*((uint32 *)(FileBuffer + 4)) = ReadFileLength;

	        	//  length of the L2CAP packet, is in that case, just 4 less than the HCI packet.
	        	FileBuffer[1] = LLCAPpacketLength / 256;
	        	FileBuffer[0] = LLCAPpacketLength % 256;
	        	
	        	//  File transfer packet, so channel is 0x0002.
				FileBuffer[2] = 2;
	        	FileBuffer[3] = 0;

				// channel->send_data(FileBuffer,Length, true);
				HCISendData->DataStart				= (uint8*)FileBuffer;
				HCISendData->DataLength				= Length;
				SendHCIMessage();
				
				delete FileBuffer;

	        	//  initialise a position counter (mostly for the display bar), record the start time in seconds,
	        	//  and set the flag so we don't try and send any more files until this one is complete.
				FilePositionCounter = 0;
	        	FileStartTime 		= ::GetTickCount();
	        	PacketCounter 		= 0;
				FileBeingSent 		= true;

    			// Start timer to send rest of file
//    			SetTimer(TIMER_EVENT_ID_SEND_FILE_DATA, SEND_FILE_DATA_TIME, NULL);
               OutputDebugString (_T("Starting\n"));
                OnHCIFileMore (0, 0);
				
    			// Start timer to Update progress bar
//    			SetTimer(TIMER_EVENT_ID_UPDATE_SENT_PROGRESS_BAR, UPDATE_SENT_PROGESS_TIME, NULL);


#if 0
#ifdef _INTERNAL
	            //  Set up the file stats window,
	            FTD_STUFF * data = new FTD_STUFF;
	            data->channel = channel;
	            ::AfxBeginThread ( createFileTransferDisplay , data );
#endif
#endif
		    }
		    else
		    {
				nResponse = MessageBox(_T("File not found"), _T("File Error"), MB_ICONERROR);
				// catch errors from message box?


				pButton2->EnableWindow(false);
		    }
		}
    }
}

void CBlueChat2Dlg::OnTimer(UINT nIDEvent) 
{

	switch(nIDEvent)
	{
		case TIMER_EVENT_ID_RESET_CASIRA:

			    KillTimer(TIMER_EVENT_ID_RESET_CASIRA);

                if ( !CommsStarted )
                    MessageBox(TxtPleaseResetCasira, TxtCommunicationError, MB_ICONERROR);
			break;

		case TIMER_EVENT_ID_ENABLE_AUDIO_CHECK:
			((CButton*)GetDlgItem(IDC_AUDIO))->EnableWindow(true);

			break;

		case TIMER_EVENT_ID_ENABLE_DATA_CHECK:
		((CButton*)GetDlgItem(IDC_DATA))->EnableWindow(true);

			break;

    			
    	case TIMER_EVENT_ID_SEND_FILE_DATA:
			
			//PostMessage(UDM_HCI_FILE_MORE, 0, 0);
            OnHCIFileMore (0, 0);
			
			break;
			
		case TIMER_EVENT_ID_UPDATE_SENT_PROGRESS_BAR:
			
			//PostMessage(UDM_HCI_FILE_PROGRESS, 0, 0);
            UpdateProgressBar (0, 0);
			
			break;
			
        case CONNECTION_TIMER :
            KillTimer ( CONNECTION_TIMER );
            if ( !mEngine->connected() )
                SetTimer ( SUBSEQUENT_CONNECTION_TIMER , 1000 , NULL );
        	//****************************
            //  Note:	Real drop through.
        	//****************************
        case SUBSEQUENT_CONNECTION_TIMER :
            if ( mEngine->connected() )
            {
                KillTimer ( SUBSEQUENT_CONNECTION_TIMER );
                CommsStarted = true;
                
                AppendHCIDisplay ( "Found Bluetooth Device." );
                
                SendInitialCommands ();
                SetTimer ( WAITING_FOR_BUFFER_SIZES_TIMER , 1000 , NULL );
            }
            else
                AppendHCIDisplay ( "Cannot find device." );
            break;
        
        case WAITING_FOR_BUFFER_SIZES_TIMER:
            if ( this->HCICmdCompReadBufferSizeEventData->HcAclDataPacketLength == 0 )
            {
                PARAMETER_VALUE RBS[2] = { 2 , 0x1005 };
                mEngine->SendHCICommand ( RBS );

                PARAMETER_VALUE RBA[2] = { 2 , 0x1009 };
                mEngine->SendHCICommand ( RBA );
                OutputDebugString (_T("Resent RBS and RBA\n"));
            }
            else
                KillTimer ( WAITING_FOR_BUFFER_SIZES_TIMER );
            break;

        default:	
			
			break;
	}

	CDialog::OnTimer(nIDEvent);
}




void CBlueChat2Dlg::OnSelchangeRemoteBdaddr() 
{
	CComboBox * pCBoxItem;

	pCBoxItem = (CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR);

	HCIInquiryResultEventData = (HCI_INQUIRY_RESULT_EVENT*)pCBoxItem->GetItemDataPtr(pCBoxItem->GetCurSel());
}


void CBlueChat2Dlg::OnData() 
{
    // Convert from audio to data mode.
    if(Audio)
    {
		if(Connected)
		{
		    //  Some code to remove SCO link
    		
    		PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_DISCONNECT_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
		    
		    AppendHCIDisplay ("Removing SCO...");

			HCICommandArray[0]  = HCI_DISCONNECT_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
			HCICommandArray[1]	= HCI_DISCONNECT;
			HCICommandArray[2]	= ScoConnectionCompleteEventData->ConnectionHandle;
			HCICommandArray[3]	= HCI_DISCONNECT_REASON_OTHER_END_TERMINATED;
			
			// Send HCI Command
			ProcessHCICommandRequest(HCICommandArray);

    		// Audio = false;
			
			// Disable Other check
			((CButton*)GetDlgItem(IDC_AUDIO))->EnableWindow(false);
			
			delete [] HCICommandArray;
		}
    	else
    		Audio = false;
    }
    return;
}


void CBlueChat2Dlg::OnDisconnect() 
{
    // Break a connection to another bluetooth device.
    if(Connected)
    {
    	PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_DISCONNECT_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];

    	TryingToDisconnect = true;
	
		HCICommandArray[0]  = HCI_DISCONNECT_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
		HCICommandArray[1]	= HCI_DISCONNECT;
		

		DisconnectReset(HCI_DISCONNECT_REASON_HOST_TERMINATED);

		// If we have a SCO link disconnect this before the ACL link
		if(Audio)
		{
			//  Some code to remove SCO link
			AppendHCIDisplay (TxtRemovingSCO);
			
			// HCI_Disconnect(ConnectionHandle,0x13);
			HCICommandArray[2]	= ScoConnectionCompleteEventData->ConnectionHandle;
			HCICommandArray[3]	= HCI_DISCONNECT_REASON_OTHER_END_TERMINATED;
			ProcessHCICommandRequest(HCICommandArray);
    	}

		AppendHCIDisplay("Trying to Disconnect...");
		(GetDlgItem(IDC_CONNECTTO))->SetWindowText(TxtDisconnecting);
		//channel->HCI_Disconnect(ConnectionHandle,0x13);
		HCICommandArray[2]	= AclConnectionCompleteEventData->ConnectionHandle;
		HCICommandArray[3]	= HCI_DISCONNECT_REASON_OTHER_END_TERMINATED;
		
		ProcessHCICommandRequest(HCICommandArray);
	
		delete [] HCICommandArray;
	}
	else
	{
    	//  Reset after being a slave.
    	GetDlgItem(IDC_MASTER)				->EnableWindow(true);
    	GetDlgItem(IDC_SLAVE) 				->EnableWindow(true);
    	GetDlgItem(IDC_DISCONNECT2)			->EnableWindow(false);
    	GetDlgItem(IDC_CONNECT)				->EnableWindow(false);

		((CButton*)GetDlgItem(IDC_MASTER))	->SetCheck(0);
		((CButton*)GetDlgItem(IDC_SLAVE))	->SetCheck(0);

		// Only reset if you were a slave
		if(!Master)
		{
			// Reset so that user can start again
			PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_SET_EVENT_FILTER_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
	
			// Set Event Filter(0, -, -)
			HCICommandArray[0]  = HCI_SET_EVENT_FILTER_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA - 2; // Only send One of the normal 3 parameters
			HCICommandArray[1]	= HCI_SET_EVENT_FILTER;
			HCICommandArray[2]	= 0;	// Reset filters, No filters set!

			ProcessHCICommandRequest(HCICommandArray);

			// HCI_Write_Scan_Enable(0);
			HCICommandArray[0]  = HCI_WRITE_SCAN_ENABLE_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
			HCICommandArray[1]	= HCI_WRITE_SCAN_ENABLE;
			HCICommandArray[2]	= 0; // Switch off Write Scan

			ProcessHCICommandRequest(HCICommandArray);

			delete [] HCICommandArray;
		}
		else
		{
			Master = false;
    		GetDlgItem(IDC_INQUIRE)->EnableWindow(false);
		}
	}
}


void CBlueChat2Dlg::OnAudio() 
{
	if( !Audio && ((CButton*)GetDlgItem(IDC_AUDIO))->GetCheck() )
	{

//		GetDlgItem(IDC_BROWSE)	->EnableWindow(false);
//		GetDlgItem(IDC_FILENAME)->EnableWindow(false);
		
		
		if(Connected)
		{
	    	PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_ADD_SCO_CONNECTION_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];

			// Disable Other check
			((CButton*)GetDlgItem(IDC_DATA))->EnableWindow(false);
			
			HCICommandArray[0]  = HCI_ADD_SCO_CONNECTION_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
			HCICommandArray[1]	= HCI_ADD_SCO_CONNECTION ;
			HCICommandArray[2]	= AclConnectionCompleteEventData->ConnectionHandle;
			
			//  Some code to add SCO link
	    	AppendHCIDisplay ("Initialising SCO...");

            if (   FileBeingSent || 
                (  currentL2CAPPacket != NULL
                && currentL2CAPPacket->channel == CHANNEL_2_FILE_FRAGMENTS ) )
                HCICommandArray[3]	= HCI_PKT_HV3;
            else
                HCICommandArray[3]	= HCI_PKT_HV1;
			
			// Send HCI Command
			ProcessHCICommandRequest(HCICommandArray);

			delete [] HCICommandArray;
		}
		
		Audio = true;
	}
}



void CBlueChat2Dlg::OnConnect() 
{
    //  Only available if "Master".  
	//	Actually set up a connection to another bluetooth device,
    //  and create the SCO link if in audio mode.

    if (!Connected)
    {
		if(HCIInquiryResultEventData != NULL)
        {
			PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_CREATE_CONNECTION_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
			
			// CreateConnection(...)
			HCICommandArray[0]  = HCI_CREATE_CONNECTION_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
			HCICommandArray[1]	= HCI_CREATE_CONNECTION;
			HCICommandArray[2]	= HCIInquiryResultEventData->BTDeviceAddress.Lap;
			HCICommandArray[3]	= HCIInquiryResultEventData->BTDeviceAddress.Uap;
			HCICommandArray[4]	= HCIInquiryResultEventData->BTDeviceAddress.Nap;
			HCICommandArray[5]	= (HCI_PKT_DH1|HCI_PKT_DH3|HCI_PKT_DH5|HCI_PKT_DM1|HCI_PKT_DM3|HCI_PKT_DM5);
			HCICommandArray[6]	= 0;
			HCICommandArray[7]	= 0;                                         
			
			HCIInquiryResultEventData->ClockOffset |= HCI_CLOCK_OFFSET_VALID;
			
			HCICommandArray[8]	= HCIInquiryResultEventData->ClockOffset;
			HCICommandArray[9]	= DISABLE_ALL_LM_MODES;
			
			GetDlgItem(IDC_MASTER)			->EnableWindow(false);
			GetDlgItem(IDC_SLAVE)			->EnableWindow(false);
			GetDlgItem(IDC_INQUIRE)			->EnableWindow(false);
			GetDlgItem(IDC_CONNECT)			->EnableWindow(false);
			GetDlgItem(IDC_CONNECTTO)		->SetWindowText(_T("Connecting to:"));
			GetDlgItem(IDC_REMOTE_BDADDR)	->EnableWindow(false);

			AppendHCIDisplay(TxtTryingToConnect);
			
			ProcessHCICommandRequest(HCICommandArray);
			
			delete [] HCICommandArray;
        }
        else
            MessageBox(TxtPleaseEnterValAddress, NULL,MB_ICONERROR);
    }
	
	
}
void CBlueChat2Dlg::OnSlave() 
{

	PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_SET_EVENT_FILTER_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
	
    //  Set up to be a slave.  One way process.
    //  Grey out connect, and prepare to be boarded!
    GetDlgItem(IDC_CONNECT)		  ->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE)		  ->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE_CANCEL2)		  ->EnableWindow(false);
	GetDlgItem(IDC_DISCONNECT2)	  ->EnableWindow(true);
    GetDlgItem(IDC_MASTER)		  ->EnableWindow(false);
    GetDlgItem(IDC_SLAVE)		  ->EnableWindow(false);
    GetDlgItem(IDC_REMOTE_BDADDR) ->EnableWindow(true);

    ((CComboBox*)GetDlgItem(IDC_REMOTE_BDADDR))->ResetContent();
    ((CComboBox*)GetDlgItem(IDC_REMOTE_BDADDR))->EnableWindow(false);

    Master = false;


	// Set Event Filter(2,0,2)
	HCICommandArray[0]  = HCI_SET_EVENT_FILTER_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
	HCICommandArray[1]	= HCI_SET_EVENT_FILTER;
	HCICommandArray[2]	= EVENT_FILTER_TYPE_CONNECTION_SETUP;
	HCICommandArray[3]	= CONNECTION_SETUP_FILTER_CONDITION_TYPE_ALLOW_FROM_ALL_DEVICES;
	HCICommandArray[4]	= CONNECTION_SETUP_FILTER_CONDITION_AUTO_ACCEPT;

	ProcessHCICommandRequest(HCICommandArray);


	// HCI_Write_Page_Scan_Activity(0x0040,0x0020);
	HCICommandArray[0]  = HCI_WRITE_PAGE_SCAN_ACTIVITY_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
	HCICommandArray[1]	= HCI_WRITE_PAGESCAN_ACTIVITY;
	HCICommandArray[2]	= 0x0040;
	HCICommandArray[3]	= 0x0020;

	ProcessHCICommandRequest(HCICommandArray);


	// HCI_Write_Inquiry_Scan_Activity(0x0040,0x0020);
	HCICommandArray[0]  = HCI_WRITE_INQUIRY_SCAN_ACTIVITY_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
	HCICommandArray[1]	= HCI_WRITE_INQUIRYSCAN_ACTIVITY;

	ProcessHCICommandRequest(HCICommandArray);
	
	// HCI_Write_Scan_Enable(3);
	HCICommandArray[0]  = HCI_WRITE_SCAN_ENABLE_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
	HCICommandArray[1]	= HCI_WRITE_SCAN_ENABLE;
	HCICommandArray[2]	= 3;

	ProcessHCICommandRequest(HCICommandArray);

	delete [] HCICommandArray;

    return;
}

void CBlueChat2Dlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CBlueChat2Dlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}


void CBlueChat2Dlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}
BOOL CBlueChat2Dlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}
void CBlueChat2Dlg::SortOutFileName ( L2CAP_PACKET_T * todo )
{
	int 			nResponse;


	NewFileName.Empty();

    //  This is the beginning of an L2CAP packet, so the length is non-zero.
    //  make sure we have at least the uint32 file length.
	if( todo->length >= sizeof(uint32) )
	{
        //  Get the filename length
        newFileNameLength = todo->length - sizeof ( uint32 );
        //  Get the file length.
        NewFileTotalLength = * (( uint32 * ) todo->Data ) ;
		TRACE(_T("\n\rNewFileTotalLength %lx"), NewFileTotalLength);

        //  Start the name.  Copy the data into a null terminated string.
        char * buffer = new char[ todo->length - sizeof (uint32) + 1 ];
        memcpy ( buffer , todo->Data + sizeof (uint32) , todo->length - sizeof ( uint32 ) );
        buffer [ todo->length - sizeof ( uint32 ) ] = 0;
        //  add it to the name.
        NewFileName = buffer;
        //  and how much do we have.
        newFileNameRecvedLength = todo->length - sizeof (uint32);
        delete[] buffer;
    }
    else
        MessageBox ( _T("File preamble too short." ));
	if( !NewFileName.IsEmpty() )
	{
		//  Check to see if that filename is used already. 
		//	If we can open the file then it must exist
	    FILE * TestFile = NULL;
		if(!NewFileName.IsEmpty())
		{
			if(TestFile = _tfopen(NewFileName,_T("r")))
			{
				nResponse = fclose(TestFile);
				TestFile  = NULL;
				NewFileName.Empty();
				nResponse++; // DEBUG
			}
		}

		// File already exists so lets make a new name based on current time
		if(NewFileName.IsEmpty())
		{
			do
			{
				if(TestFile)
				{
					fclose(TestFile);
					TestFile = NULL;
					::Sleep(1000); // allow the time to click forward a second
				}
				NewFileName.Format(_T("BC%u.tmp"), gettimet());
			}
			while (TestFile = _tfopen(NewFileName,_T("r")));
		}

		if ((TestFile = _tfopen(NewFileName,_T("w"))) == ( FILE* )( NULL ))
		{
			this->MessageBox(_T("Write Permission denied on current directory"), _T("File Error"),MB_ICONERROR);
			
			//  Allow the file to be processed and discarded.
			DiscardFileData = true;
			return;
		}
		
		(void) fclose(TestFile);
#ifndef _WINCE
		(void) unlink(NewFileName);
#else
//		(void) _wunlink(NewFileName.GetBuffer);
#endif
		
		//  Set the global variables, and tidy up memory usage.
		NewFileLength = 0;

		NewFile = new CStdioFile;
		NewFile->Open(NewFileName, NewFile->modeCreate | NewFile->modeWrite | NewFile->shareExclusive | NewFile->typeBinary );
		
//		this->MessageBox(_T("File sorted"),_T("File Sorted"),MB_ICONERROR);
		
		
	}
}






// Returns 1 if File Transfer is complete.
int CBlueChat2Dlg::WriteToFile(char *Message, int Length)
{
    int Status = 0;

	if ( DiscardFileData == true )
        return Status;
    
	//  Just in case we couldn't open the file, discard the file being sent.
    if (NewFile != NULL)
    {
        // a packet in an already open file.
		// Assume that we keep a single file open.
		NewFileLength += Length;
		
    	// do progress bar
    	if (NewFileTotalLength != 0)
    	{
   			uint16 Position = (uint16)(100 * ((float)NewFileLength / NewFileTotalLength));
//    		((CProgressCtrl*)(g_pxferctrl->GetDlgItem(IDC_FILEINPROGRESS)))->SetPos(Position);
			((CProgressCtrl*)GetDlgItem(IDC_FILEINPROGRESS2))->SetPos(Position);
		}


    	NewFile->Write( (char*) Message, Length);
    	WaitingForFirstPacket = false;
		
		
		if(NewFileLength >= NewFileTotalLength)
		{
		    NewFile->Flush();
		    NewFile->Close();
    	    
    	    delete NewFile;
    	    
   			NewFile 			= NULL;
		    NewFileTotalLength 	= NewFileLength = 0;
		    
			Status = 1;
		}

    } // NewFile not NULL

	return Status;
}


/*******************************************************************************************/
//	Event Data Handlers
/*******************************************************************************************/


void CBlueChat2Dlg::OnDisconnectComplete(WPARAM Dummy, void * DisconnectionCompleteEventData)
{
	// See if we are trying to disconnect a SCO link or an ACL
	if(((HCI_DISCONNECTION_COMPLETE_EVENT*)DisconnectionCompleteEventData)->ConnectionHandle == ScoConnectionCompleteEventData->ConnectionHandle)
	{
		// Disconnect SCO
		if(((HCI_DISCONNECTION_COMPLETE_EVENT*)DisconnectionCompleteEventData)->Status == 0)
		{
			AppendHCIDisplay("SCO disconnected");
			
			// Enable check
    		SetTimer(TIMER_EVENT_ID_ENABLE_AUDIO_CHECK, CHECK_SUSPEND_TIME, NULL);
			
			((CButton*)GetDlgItem(IDC_AUDIO))->EnableWindow(false);
			((CButton*)GetDlgItem(IDC_AUDIO))->SetCheck(0);
			((CButton*)GetDlgItem(IDC_DATA))->SetCheck(1);
			
			Audio = false;

			//  Set the focus to the write window.
			(void)InputWindow.SetFocus();

//			GetDlgItem(IDC_FILENAME)->EnableWindow(true);
//			GetDlgItem(IDC_BROWSE)->EnableWindow(true);
		}
		else
		{
			//reset?
			//TRACE("\n\rReset?");
			// TO DO.....Need to process error to determine what we should do
		}
	}
	else
	{
		// Disconnect ACL
		
		// Enable check
    	SetTimer(TIMER_EVENT_ID_ENABLE_AUDIO_CHECK, CHECK_SUSPEND_TIME, NULL);
    	SetTimer(TIMER_EVENT_ID_ENABLE_DATA_CHECK, CHECK_SUSPEND_TIME, NULL);
		
		
		if(((HCI_DISCONNECTION_COMPLETE_EVENT*)DisconnectionCompleteEventData)->Status == 0)
			AppendHCIDisplay("Disconnect successful");
		else
			AppendHCIDisplay("Disconnect failed.");

		// if there is a file currently in flight, then stop the receipt/transmission.
		if(FileBeingSent)
		{
			if(ReadFile)
    		{
    		    ReadFile->Close();
    			delete ReadFile;
    		    ReadFile = NULL;
    		}
			
//			((CProgressCtrl*)GetDlgItem(IDC_FILEOUTPROGRESS))->SetPos(0);





// to add			if (p_xferctrl != NULL)
//				((CProgressCtrl*)(g_pxferctrl->GetDlgItem(IDC_FILEOUTPROGRESS)))->SetPos(Position);
			
			FileBeingSent = false;

			// Kill Timers
//			KillTimer(TIMER_EVENT_ID_SEND_FILE_DATA);
		
//			if(!FileSent)	KillTimer(TIMER_EVENT_ID_UPDATE_SENT_PROGRESS_BAR);
		}

		
		if( currentL2CAPPacket != NULL && currentL2CAPPacket->channel == CHANNEL_2_FILE_FRAGMENTS )
		{
			if(NewFile)
    		{
    		    NewFile->Close();
    			delete NewFile;
    		    NewFile = NULL;
    		}
			

			((CProgressCtrl*)GetDlgItem(IDC_FILEINPROGRESS2))->SetPos(0);
            DiscardFileData = true;
		}

		GetDlgItem(IDC_DISCONNECT2)	->EnableWindow(false);
		GetDlgItem(IDC_CONNECT)		->EnableWindow(false);
		GetDlgItem(IDC_INQUIRE)		->EnableWindow(false);
//		GetDlgItem(IDC_FILENAME)	->EnableWindow(false);
//		GetDlgItem(IDC_BROWSE)		->EnableWindow(false);
		GetDlgItem(IDC_MASTER)		->EnableWindow(true);
		GetDlgItem(IDC_SLAVE)		->EnableWindow(true);

		((CButton*)GetDlgItem(IDC_MASTER))	->SetCheck(0);
		((CButton*)GetDlgItem(IDC_SLAVE))	->SetCheck(0);
		(GetDlgItem(IDC_CONNECTTO))			->SetWindowText(_T("Connect to:"));
		(GetDlgItem(IDC_REMOTE_BDADDR))		->EnableWindow(false);
		
		Connected = false;
		TryingToDisconnect = false;
    	(GetDlgItem(IDC_CONNECTTO))->SetWindowText(TxtDisconnected);

    	GetDlgItem(IDCHAT)				->EnableWindow(false);				
    	GetDlgItem(IDFILE)				->EnableWindow(false);





	}

	delete (HCI_DISCONNECTION_COMPLETE_EVENT*)DisconnectionCompleteEventData;
}







void CBlueChat2Dlg::ProcessHCICommandRequest(PARAMETER_ARRAY HCICommandArray)
{
	unsigned short		ArrayLength;
	bool				Status;
	unsigned short		i;
	PARAMETER_ARRAY		HCICommandArrayLocal = new PARAMETER_VALUE[HCICommandArray[0]];
	CString				TempString;


	ArrayLength = (unsigned short)HCICommandArray[0];

	// This looks mad but it allows users to create a PARAMETER_ARRAY larger than required and then only part fill it
	// Not sure if Adam's code copes with sending larger than required arrays, so do this for now.
	// If Adam's code does cope then this can be removed.....
	for(i = 0; i < ArrayLength; i++) HCICommandArrayLocal[i] = HCICommandArray[i];
	TempString.Format(_T("Send HCI Command: "), HCICommandArrayLocal[1]);

	HCIDisplay.AddText(TempString.GetBuffer(TempString.GetLength()));	
	switch(HCICommandArrayLocal[1])
	{
		/******************************************************************************
		OCF opcode defines - Link Control Commands
		*****************************************************************************/
		case  HCI_INQUIRY:						TempString = "hci_inquiry";						break;
		case  HCI_INQUIRY_CANCEL:				TempString = "hci_inquiry_cancel";				break;
		case  HCI_PERIODIC_INQUIRY_MODE:		TempString = "hci_periodic_inquiry_mode";		break;
		case  HCI_EXIT_PERIODIC_INQUIRY_MODE:	TempString = "hci_exit_periodic_inquiry_mode";	break;
		case  HCI_CREATE_CONNECTION:			TempString = "hci_create_connection";			break;
		case  HCI_DISCONNECT:					TempString = "hci_disconnect";					break;
		case  HCI_ADD_SCO_CONNECTION:			TempString = "hci_add_sco_connection";			break;
		case  HCI_ACCEPT_CONNECTION_REQ:		TempString = "hci_accept_connection_req";		break;
		case  HCI_REJECT_CONNECTION_REQ:		TempString = "hci_reject_connection_req";		break;
		case  HCI_LINK_KEY_REQ_REPLY:			TempString = "hci_link_key_req_reply";			break;
		case  HCI_LINK_KEY_REQ_NEG_REPLY:		TempString = "hci_link_key_req_neg_reply";		break;
		case  HCI_PIN_CODE_REQ_REPLY:			TempString = "hci_pin_code_req_reply";			break;
		case  HCI_PIN_CODE_REQ_NEG_REPLY:		TempString = "hci_pin_code_req_neg_reply";		break;
		case  HCI_CHANGE_CONN_PKT_TYPE:			TempString = "hci_change_conn_pkt_type";		break;
		case  HCI_AUTH_REQ:						TempString = "hci_auth_req";					break;
		case  HCI_SET_CONN_ENCRYPTION:			TempString = "hci_set_conn_encryption";			break;
		case  HCI_CHANGE_CONN_LINK_KEY:			TempString = "hci_change_conn_link_key";		break;
		case  HCI_MASTER_LINK_KEY:				TempString = "hci_master_link_key";				break;
		case  HCI_REMOTE_NAME_REQ:				TempString = "hci_remote_name_req";				break;
		case  HCI_READ_REMOTE_SUPP_FEATURES:	TempString = "hci_read_remote_supp_features";	break;
		case  HCI_READ_REMOTE_VER_INFO:			TempString = "hci_read_remote_ver_info";		break;
		case  HCI_READ_CLOCK_OFFSET:			TempString = "hci_read_clock_offset";			break;
		case  HCI_MAX_LINK_OCF:					TempString = "hci_max_link_ocf";				break;

		/******************************************************************************
		OP CODE defines - Link Policy Commands
		*****************************************************************************/
		case HCI_HOLD_MODE:						TempString = "hci_hold_mode";					break;
		case HCI_SNIFF_MODE:					TempString = "hci_sniff_mode";					break;
		case HCI_EXIT_SNIFF_MODE:				TempString = "hci_exit_sniff_mode";				break;
		case HCI_PARK_MODE:						TempString = "hci_park_mode";					break;
		case HCI_EXIT_PARK_MODE:				TempString = "hci_exit_park_mode";				break;
		case HCI_QOS_SETUP:						TempString = "hci_qos_setup";					break;
		case HCI_ROLE_DISCOVERY:				TempString = "hci_role_discovery";				break;
		case HCI_SWITCH_ROLE:					TempString = "hci_switch_role";					break;
		case HCI_READ_LINK_POLICY_SETTINGS:		TempString = "hci_read_link_policy_settings";	break;
		case HCI_WRITE_LINK_POLICY_SETTINGS:	TempString = "hci_write_link_policy_settings";	break;
		case HCI_MAX_POLICY_OCF:				TempString = "hci_max_policy_ocf";				break;

		/******************************************************************************
		OP CODE defines - Host Controller and Baseband commands
		*****************************************************************************/
		case HCI_SET_EVENT_MASK:				TempString = "hci_set_event_mask";				break;
		case HCI_RESET:							TempString = "hci_reset";						break;
		case HCI_SET_EVENT_FILTER:				TempString = "hci_set_event_filter";			break;
		case HCI_FLUSH:							TempString = "hci_flush";						break;
		case HCI_READ_PIN_TYPE:					TempString = "hci_read_pin_type";				break;
		case HCI_WRITE_PIN_TYPE:				TempString = "hci_write_pin_type";				break;
		case HCI_CREATE_NEW_UNIT_KEY:			TempString = "hci_create_new_unit_key";			break;
		case HCI_READ_STORED_LINK_KEY:			TempString = "hci_read_stored_link_key";		break;
		case HCI_WRITE_STORED_LINK_KEY:			TempString = "hci_write_stored_link_key";		break;
		case HCI_DELETE_STORED_LINK_KEY:		TempString = "hci_delete_stored_link_key";		break;
		case HCI_CHANGE_LOCAL_NAME:				TempString = "hci_change_local_name";			break;
		case HCI_READ_LOCAL_NAME:				TempString = "hci_read_local_name";				break;
		case HCI_READ_CONN_ACCEPT_TIMEOUT:		TempString = "hci_read_conn_accept_timeout";	break;
		case HCI_WRITE_CONN_ACCEPT_TIMEOUT:		TempString = "hci_write_conn_accept_timeout";	break;
		case HCI_READ_PAGE_TIMEOUT:				TempString = "hci_read_page_timeout";			break;
		case HCI_WRITE_PAGE_TIMEOUT:			TempString = "hci_write_page_timeout";			break;
		case HCI_READ_SCAN_ENABLE:				TempString = "hci_read_scan_enable";			break;
		case HCI_WRITE_SCAN_ENABLE:				TempString = "hci_write_scan_enable";			break;
		case HCI_READ_PAGESCAN_ACTIVITY:		TempString = "hci_read_pagescan_activity";		break;
		case HCI_WRITE_PAGESCAN_ACTIVITY:		TempString = "hci_write_pagescan_activity";		break;
		case HCI_READ_INQUIRYSCAN_ACTIVITY:		TempString = "hci_read_inquiryscan_activity";	break;
		case HCI_WRITE_INQUIRYSCAN_ACTIVITY:	TempString = "hci_write_inquiryscan_activity";	break;
		case HCI_READ_AUTH_ENABLE:				TempString = "hci_read_auth_enable";			break;
		case HCI_WRITE_AUTH_ENABLE:				TempString = "hci_write_auth_enable";			break;
		case HCI_READ_ENC_MODE:					TempString = "hci_read_enc_mode";				break;
		case HCI_WRITE_ENC_MODE:				TempString = "hci_write_enc_mode";				break;
		case HCI_READ_CLASS_OF_DEVICE:			TempString = "hci_read_class_of_device";		break;
		case HCI_WRITE_CLASS_OF_DEVICE:			TempString = "hci_write_class_of_device";		break;
		case HCI_READ_VOICE_SETTING:			TempString = "hci_read_voice_setting";			break;
		case HCI_WRITE_VOICE_SETTING:			TempString = "hci_write_voice_setting";			break;
		case HCI_READ_AUTO_FLUSH_TIMEOUT:		TempString = "hci_read_auto_flush_timeout";		break;
		case HCI_WRITE_AUTO_FLUSH_TIMEOUT:		TempString = "hci_write_auto_flush_timeout";	break;
		case HCI_READ_NUM_BCAST_RETXS:			TempString = "hci_read_num_bcast_retxs";		break;
		case HCI_WRITE_NUM_BCAST_RETXS:			TempString = "hci_write_num_bcast_retxs";		break;
		case HCI_READ_HOLD_MODE_ACTIVITY:		TempString = "hci_read_hold_mode_activity";		break;
		case HCI_WRITE_HOLD_MODE_ACTIVITY:		TempString = "hci_write_hold_mode_activity";	break;
		case HCI_READ_TX_POWER_LEVEL:			TempString = "hci_read_tx_power_level";			break;
		case HCI_READ_SCO_FLOW_CON_ENABLE:		TempString = "hci_read_sco_flow_con_enable";	break;
		case HCI_WRITE_SCO_FLOW_CON_ENABLE:		TempString = "hci_write_sco_flow_con_enable";	break;
		case HCI_SET_HCTOHOST_FLOW_CONTROL:		TempString = "hci_set_hctohost_flow_control";	break;
		case HCI_HOST_BUFFER_SIZE:				TempString = "hci_host_buffer_size";			break;
		case HCI_HOST_NUM_COMPLETED_PACKETS:	TempString = "hci_host_num_completed_packets";	break;
		case HCI_READ_LINK_SUPERV_TIMEOUT:		TempString = "hci_read_link_superv_timeout";  	break;
		case HCI_WRITE_LINK_SUPERV_TIMEOUT:		TempString = "hci_write_link_superv_timeout"; 	break;
		case HCI_READ_NUM_SUPPORTED_IAC:		TempString = "hci_read_num_supported_iac";	  	break;
		case HCI_READ_CURRENT_IAC_LAP:			TempString = "hci_read_current_iac_lap";	  	break;
		case HCI_WRITE_CURRENT_IAC_LAP:			TempString = "hci_write_current_iac_lap";	  	break;
		case HCI_READ_PAGESCAN_PERIOD_MODE:		TempString = "hci_read_pagescan_period_mode"; 	break;
		case HCI_WRITE_PAGESCAN_PERIOD_MODE:	TempString = "hci_write_pagescan_period_mode";	break;
		case HCI_READ_PAGESCAN_MODE:			TempString = "hci_read_pagescan_mode";			break;
		case HCI_WRITE_PAGESCAN_MODE:			TempString = "hci_write_pagescan_mode";			break;
		case HCI_MAX_HOST_BB_OCF:				TempString = "hci_max_host_bb_ocf";				break;

		/******************************************************************************
		OP CODE defines - Informational Parameters
		*****************************************************************************/
		case HCI_READ_LOCAL_VER_INFO:			TempString = "hci_read_local_ver_info";			break;
		case HCI_READ_LOCAL_SUPP_FEATURES:		TempString = "hci_read_local_supp_features";  	break;
		case HCI_READ_BUFFER_SIZE:				TempString = "hci_read_buffer_size";		  	break;
		case HCI_READ_COUNTRY_CODE:				TempString = "hci_read_country_code";		  	break;
		case HCI_READ_BD_ADDR:					TempString = "hci_read_bd_addr";			  	break;
		case HCI_MAX_INFO_OCF:					TempString = "hci_max_info_ocf";			  	break;

		/******************************************************************************
		OP CODE defines - Status Parameters
		*****************************************************************************/
		case HCI_READ_FAILED_CONTACT_COUNT:		TempString = "hci_read_failed_contact_count"; 	break;
		case HCI_RESET_FAILED_CONTACT_COUNT:	TempString = "hci_reset_failed_contact_count";	break;
		case HCI_GET_LINK_QUALITY:				TempString = "hci_get_link_quality";			break;
		case HCI_READ_RSSI:						TempString = "hci_read_rssi";					break;
		case HCI_MAX_STATUS_OCF:				TempString = "hci_max_status_ocf";				break;

		/******************************************************************************
		OP CODE defines - Testing Parameters
		*****************************************************************************/
		case HCI_READ_LOOPBACK_MODE:			TempString = "hci_read_loopback_mode";			break;
		case HCI_WRITE_LOOPBACK_MODE:			TempString = "hci_write_loopback_mode";			break;
		case HCI_ENABLE_DUT_MODE:				TempString = "hci_enable_dut_mode";				break;
		case HCI_MAX_TEST_OCF:					TempString = "hci_max_test_ocf";				break;

		/******************************************************************************
		OP CODE defines - VENDOR SPECIFIC DEBUG parameters
		*****************************************************************************/
		case HCI_DEBUG_STATS:					TempString = "hci_debug_stats";					break;
		case HCI_DEBUG_STATS_ACL:				TempString = "hci_debug_stats_acl";				break;
		case HCI_DEBUG_STATS_SCO:				TempString = "hci_debug_stats_sco";				break;
		case HCI_DEBUG_MEM:						TempString = "hci_debug_mem";					break;
		case HCI_DEBUG_RAND:					TempString = "hci_debug_rand";					break;
		case HCI_DEBUG_KEY:						TempString = "hci_debug_key";					break;
		case HCI_DEBUG_SRES:					TempString = "hci_debug_sres";					break;
				
		default:								break;
	}

	HCIDisplay.AddText(TempString.GetBuffer(TempString.GetLength()));
	HCIDisplay.AddText(_T("   "));
	
	for(i = 0; i < ArrayLength; i++)
	{
		TempString.Format(_T(" 0x%x "), HCICommandArrayLocal[i]);
		HCIDisplay.AddText(TempString.GetBuffer(TempString.GetLength()));
	}
	
	AppendHCIDisplay(" "); // Set to next line

	Status = mEngine->SendHCICommand(HCICommandArrayLocal);

	delete [] HCICommandArrayLocal;
}

void CBlueChat2Dlg::OnMaster() 
{
	CComboBox	   *pCBoxItem;
	
	pCBoxItem = (CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR);
	
	// Enable connect button only if there is someone out there...
	if(pCBoxItem->GetCount())	GetDlgItem(IDC_CONNECT)->EnableWindow(true);
	
    //  Set up to be master.  One way process.
    //  Simply allow the connection button to the pressed
    GetDlgItem(IDC_REMOTE_BDADDR)->EnableWindow(true);
    GetDlgItem(IDC_INQUIRE)		 ->EnableWindow(true);
    GetDlgItem(IDC_DISCONNECT2)	 ->EnableWindow(true);
    GetDlgItem(IDC_MASTER)		 ->EnableWindow(false);
    GetDlgItem(IDC_SLAVE)		 ->EnableWindow(false);

    Master = true;
}

void CBlueChat2Dlg::OnHCIInquiryResultEvent(WPARAM dummy, void * InquiryEventData)
{
	CComboBox * pCBoxItem;
	CString		Address;
	CString		EventDataText;

#ifdef _WINCE	
	Address.Format(_T("LAP:%06x  UAP:%02x  NAP:%04x"),	((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Lap,
													((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Uap,
													((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Nap);
#else
	Address.Format("LAP:%06x  UAP:%02x  NAP:%04x",	((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Lap,
													((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Uap,
													((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->BTDeviceAddress.Nap);
#endif
	AppendHCIDisplay(Address);
	
	pCBoxItem = (CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR);
	
	pCBoxItem->InsertString(-1, Address);
//	pCBoxItem->AddString(Address);

	pCBoxItem->SetItemDataPtr((pCBoxItem->GetCount() - 1), InquiryEventData);

	pCBoxItem->SetCurSel(0);

	HCIInquiryResultEventData = (HCI_INQUIRY_RESULT_EVENT*)pCBoxItem->GetItemDataPtr(0);

	// Display in HCI List box Inquiry Results
#ifdef _WINCE
   	EventDataText.Format(_T("Page Scan Rep Mode: %d  Period: %d  Mode: %d  Class: %d  ClockOffset: %d"), ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->PScanRepititionMode,
#else																									 ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->PScanPeriodMode,
   	EventDataText.Format("Page Scan Rep Mode: %d  Period: %d  Mode: %d  Class: %d  ClockOffset: %d", ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->PScanRepititionMode,
#endif																									 ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->PScanMode,
																									 ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->ClassOfDevice,
																									 ((HCI_INQUIRY_RESULT_EVENT*)InquiryEventData)->ClockOffset);
	AppendHCIDisplay(EventDataText);
}

void CBlueChat2Dlg::OnPaint() 
{
#ifndef _WINCE
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
#else
	CDialog::OnPaint();
#endif

}

void CBlueChat2Dlg::SetFactory(BlueCoreControllerFactory *Factory)
{
    this->mFactory = Factory;
}



void CBlueChat2Dlg::OnInquire() 
{
	PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_INQUIRY_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];

	// Remove Current List box Contents and free memory held
	ResetAddressListBox();

    // Disable inquiry and connect buttons
    GetDlgItem(IDC_CONNECT)   		->EnableWindow(false);
    GetDlgItem(IDC_DISCONNECT2)		->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE)   		->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE)   		->ShowWindow(SW_HIDE);
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->EnableWindow(true);
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->ShowWindow(SW_SHOWNOACTIVATE);

	HCICommandArray[0]  = HCI_INQUIRY_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA; 
	HCICommandArray[1]	= HCI_INQUIRY; 
	HCICommandArray[2]	= HCI_INQUIRY_LAP; 
	HCICommandArray[3]	= HCI_INQUIRY_LENGTH_DEFAULT;
	HCICommandArray[4]	= HCI_INQUIRY_RESPONSES_DEFAULT;

	ProcessHCICommandRequest(HCICommandArray);

	delete [] HCICommandArray;

//SipShowIM(SIPF_ON);

}

////void CBlueChat2Dlg::OnBrowse() 
////{
	//  Summon a windows standard filename finder, and then put the result into IDC_FILENAME
////	CString filename = "";
////	int nResponse;

////	GetDlgItem(IDC_FILENAME)->GetWindowText(filename);
////#ifdef _WINCE	
////	CFileDialog filehandler(true, _T("txt"), filename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, this);
////#else
////	CFileDialog filehandler(true, "txt", filename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, this);
////#endif	
////	nResponse = filehandler.DoModal();

////	if(nResponse == IDOK)
////	{
 ////		GetDlgItem(IDC_FILENAME)->SetWindowText( filehandler.GetPathName() );

////		if(Connected & !Audio) GetDlgItem(IDC_SEND)->EnableWindow(true);
////	}
////	else if (nResponse = IDCANCEL)
////	{
		// Can't think of any useful errors, so just assume the user cancelled...
////	}
////}



void CBlueChat2Dlg::OnConnectionComplete(WPARAM Dummy, void * ConnectionCompleteEventData)
{
	PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_SET_EVENT_FILTER_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
	
	AppendHCIDisplay("Connection Complete");




	if(!((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData)->Status)
	{
		if(((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData)->LinkType == CONNECTION_EVENT_LINK_TYPE_SCO)
			StoreConnectionEventData(ScoConnectionCompleteEventData, ((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData));
		else
		{
			StoreConnectionEventData(AclConnectionCompleteEventData, ((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData));
		}

		if(((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData)->LinkType == CONNECTION_EVENT_LINK_TYPE_ACL)
		{
        	if(!Master)
        	{
				// switch off page scan HCI_Write_Scan_Enable(0);
				HCICommandArray[0]  = HCI_WRITE_SCAN_ENABLE_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
				HCICommandArray[1]	= HCI_WRITE_SCAN_ENABLE;
				HCICommandArray[2]	= 0;

				ProcessHCICommandRequest(HCICommandArray);
        	}

			if(Audio)
        	{
	    		// Add a SCO link to connection.
	    		AppendHCIDisplay ("Initialising SCO...");
				HCICommandArray[0]  = HCI_ADD_SCO_CONNECTION_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
				HCICommandArray[1]	= HCI_ADD_SCO_CONNECTION ;
				HCICommandArray[2]	= AclConnectionCompleteEventData->ConnectionHandle;
        	    HCICommandArray[3]	= HCI_PKT_HV1;
				
				// Send HCI Command
				ProcessHCICommandRequest(HCICommandArray);
        	}
        	else
        	{
//	    		GetDlgItem(IDC_FILENAME)->EnableWindow(true);
//	    		GetDlgItem(IDC_BROWSE)	->EnableWindow(true);
        	}
        }

        GetDlgItem(IDC_DISCONNECT2)->EnableWindow(true);

     	GetDlgItem(IDCHAT)				->EnableWindow(true);				
    	GetDlgItem(IDFILE)				->EnableWindow(true);
       
    	(GetDlgItem(IDC_CONNECTTO))->SetWindowText(TxtConnected);

        Connected = true;

		// Write Link Policy Settings
		HCICommandArray[0]  = HCI_WRITE_LINK_POLICY_SETTINGS_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
		HCICommandArray[1]	= HCI_WRITE_LINK_POLICY_SETTINGS;
		HCICommandArray[2]	= AclConnectionCompleteEventData->ConnectionHandle;
		HCICommandArray[3]	= 15;

		ProcessHCICommandRequest(HCICommandArray);
		
        //  clear out file transfer stuff.
        //while (channel->DataFromChip->GetEvent());
        //channel->ACLDataCount = 0;
	}
	else
	{
		// Connection Failed, Process Error Code
		// TO Do
		// Send Error Code to error handler
	}
	
	
	delete [] HCICommandArray;
	
	// Delete Copy in Engine
	delete ((HCI_CONNECTION_COMPLETE_EVENT*)ConnectionCompleteEventData);
}


void CBlueChat2Dlg::AppendHCIDisplay(CString Message)
{
	//  Write stuff to the second window.
	Message += _T("\n");
	HCIDisplay.AddText(Message.GetBuffer(Message.GetLength()));
	Message.ReleaseBuffer();
	
	return;
}


void CBlueChat2Dlg::processPacket ( L2CAP_PACKET_T * todo )
{
//	char	Buffer[100];
	int		Status = 0;
#ifdef _WINCE
//	TCHAR widestr[100];
#endif

	switch( todo->channel )
	{
		case CHANNEL_1_CHARS:				
		
			if ( todo->Data[0] == 8 ) // Delete key!
				InputWindow.DeleteLastChar();
			else
			{
#ifdef _WINCE
				TCHAR ws[200];
				MultiByteToWideChar(CP_ACP,0,(char *)(todo->Data),-1,ws,200);
				InputWindow.AddText ( ws );	
#else
				InputWindow.AddText ( todo->Data );	
#endif

				if (g_pTestDlg != NULL)
				{
#ifdef _WINCE
					TCHAR ws[200];
					MultiByteToWideChar(CP_ACP,0,(char *)(todo->Data),-1,ws,200);
					g_pTestDlg->ChatWindow.AddText(ws);
#else
					g_pTestDlg->ChatWindow.AddText(todo->Data);
#endif
				}
			}
			break;

		case CHANNEL_2_FILE_FRAGMENTS:		

			// Check to see if we are already receiveing a file
			if( NewFile != NULL )
			{
				// We are so send data to Write to file handler
				Status = WriteToFile ( (char*)todo->Data, todo->length );
			}
			else
			{
				// Else we have the start of a new file, 
				// so sort out name and Length stuff

                SortOutFileName ( todo );
//				OnXfer();
			}
			break;
	}
    
	
	delete todo->Data;
    delete todo;
    
	currentL2CAPPacket = NULL;

	// Check to see if file transfer is complete, is yes display completed message 
	if(Status)
	{
//		swprintf(widestr,_T("Created File") %s",NewFileName.GetBuffer); //,(LPCTSTR)(NewFileName));
		CString str = "Created File ";
		str.Format(_T("%s%s"), (LPCTSTR)str, (LPCTSTR)NewFileName);   // Attention: str is also used in the parameter list.



		MessageBox(str,_T("bc01 File Transfer Complete"), MB_ICONINFORMATION);

		((CProgressCtrl*)GetDlgItem(IDC_FILEINPROGRESS2))->SetPos(0);
	}
}

void CBlueChat2Dlg::OnDestroy()
{
#ifndef _WINCE
	WinHelp(0L, HELP_QUIT);
#endif	

	// Add Memory clean up on exit here
	// Sort out list box
	ResetAddressListBox();

	delete ScoConnectionCompleteEventData;
	delete AclConnectionCompleteEventData;
	delete HCISendData;                   
	delete HCISendDataMessage;            
	delete HCIReceivedData;               
	delete HCICmdCompReadBufferSizeEventData;
	delete HCICmdCompReadBdAddrEventData;
	
	// Delete the engine and all that it stands for....
	delete this->mEngine;


	CDialog::OnDestroy();
}
void CBlueChat2Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
////	if((nID & 0xFFF0) == IDM_ABOUTBOX)
////	{
////		CAboutDlg dlgAbout;
////		dlgAbout.DoModal();
////	}
////	else if((nID & 0xFFF0) == IDM_HCICMD)
////	{
////		CHCICmdDialog dlgHCICMD;
////        dlgHCICMD.setChannel((mEngine->getDC())->getTransport());
////		dlgHCICMD.DoModal();
////	}

////#ifdef _DEBUG
////	else if((nID & 0xFFF0) == IDM_TRACEOPTIONS)
////	{
////		CTraceDialog dlg;
 ////       dlg.traceMask 	= traceMask;
////        dlg.filename 	= traceFile;
////        dlg.pEngine 	= mEngine;

////        if ( traceFile.IsEmpty() )
////            dlg.changeFileName = true;
////        else
////            dlg.changeFileName = false;

////        int nResponse = dlg.DoModal();

////        if (nResponse == IDOK)
////        {
////            traceFile = dlg.filename;
////            traceMask = dlg.traceMask;
////        }
////	}
////#endif
////	else
////	{
////		CDialog::OnSysCommand(nID, lParam);
////	}
}

void CBlueChat2Dlg::checkStatusOfPacket ( L2CAP_PACKET_T * todo )
{
    //  If there is nothing there, that is good!
    if ( todo == NULL )
        return;

    //  What went wrong??
    TCHAR buffer[200];
    _stprintf ( buffer , 
              _T("Packet Boundary received with last packet still incomplete.\n")
              _T("Channel 0x%x. Length %u bytes. Expecting Byte %u.") ,
              todo->channel , todo->length , todo->nextByteToRecv );
    MessageBox ( buffer );
    if ( todo->length != 0 )
        delete todo->Data;

    delete todo;
}



void CBlueChat2Dlg::DisconnectReset(unsigned short Reason)
{
//    if(Status == 0)
       	AppendHCIDisplay(TxtDisconnectSuccessfull);
//    else
//        AppendHCIDisplay(TxtDisconnectFailed);


    // if there is a file currently in flight, then stop the receipt/transmission.
    if(FileBeingSent)
    {
        // clear the outgoing data queue.
        //while (channel->DataToChip->GetEvent());

// can't do this as it is on another sheet        ((CProgressCtrl*)GetDlgItem(IDC_FILEOUTPROGRESS))->SetPos(0);
        
        FileBeingSent = false;

        //  force the GUI to tell the worker thread to stop.
        //PostMessage(BCM_HCI_FILE_MORE,0,0);
    }
    if( currentL2CAPPacket != NULL && currentL2CAPPacket->channel == CHANNEL_2_FILE_FRAGMENTS )
    {
        //  clear all the incoming data from the queue.
        //while (channel->DataFromChip->GetEvent());

        ((CProgressCtrl*)GetDlgItem(IDC_FILEINPROGRESS2))->SetPos(0);
        DiscardFileData = true;
    }

    GetDlgItem(IDC_DISCONNECT2)			->EnableWindow(false);
    GetDlgItem(IDC_CONNECT)				->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE)				->EnableWindow(false);
//    GetDlgItem(IDC_FILENAME)			->EnableWindow(false);
 //   GetDlgItem(IDC_BROWSE)			->EnableWindow(false);
    GetDlgItem(IDC_MASTER)				->EnableWindow(true);
    GetDlgItem(IDC_SLAVE)				->EnableWindow(true);
    ((CButton*)GetDlgItem(IDC_MASTER))	->SetCheck(0);
    ((CButton*)GetDlgItem(IDC_SLAVE))	->SetCheck(0);
    (GetDlgItem(IDC_CONNECTTO))			->SetWindowText(_T("Connect to:"));
    (GetDlgItem(IDC_REMOTE_BDADDR))		->EnableWindow(false);
    
    Connected 			= false;
    TryingToDisconnect 	= false;

//	if (about_to_close)
//		ReallyClose();

	if(Reason == HCI_DISCONNECT_REASON_OTHER_END_TERMINATED)
		TRACE(_T("\n\rDisconnect Complete, link terminated by other end"));
	else
		TRACE(_T("\n\rHost Terminating Link"));
}


void CBlueChat2Dlg::StoreConnectionEventData(HCI_CONNECTION_COMPLETE_EVENT * LocalConnectionData, HCI_CONNECTION_COMPLETE_EVENT * ConnectionData)
{

	// Copy new data into Local Copy
	LocalConnectionData->Status					= ConnectionData->Status;             
	LocalConnectionData->ConnectionHandle		= ConnectionData->ConnectionHandle;   
	LocalConnectionData->BTDeviceAddress.Lap	= ConnectionData->BTDeviceAddress.Lap;
	LocalConnectionData->BTDeviceAddress.Uap	= ConnectionData->BTDeviceAddress.Uap;
	LocalConnectionData->BTDeviceAddress.Nap	= ConnectionData->BTDeviceAddress.Nap;
	LocalConnectionData->LinkType				= ConnectionData->LinkType;           
	LocalConnectionData->EncryptionMode			= ConnectionData->EncryptionMode;     


	// Check to see what link type has been established and set radio buttons accordingly
    switch(LocalConnectionData->LinkType)
	{
		case CONNECTION_EVENT_LINK_TYPE_SCO:
			
			Audio = true;
			
			// Enable check
    		SetTimer(TIMER_EVENT_ID_ENABLE_DATA_CHECK, CHECK_SUSPEND_TIME, NULL);
			((CButton*)GetDlgItem(IDC_DATA))  ->EnableWindow(false);
			((CButton*)GetDlgItem(IDC_DATA))  ->SetCheck(0);
			((CButton*)GetDlgItem(IDC_AUDIO)) ->SetCheck(1);
			
			break;

		case CONNECTION_EVENT_LINK_TYPE_ACL:
			
			Connected = true;
			
			GetDlgItem(IDC_DISCONNECT2)->EnableWindow(true);

    		SetTimer(TIMER_EVENT_ID_ENABLE_AUDIO_CHECK, CHECK_SUSPEND_TIME, NULL);
			
			((CButton*)GetDlgItem(IDC_AUDIO)) ->EnableWindow(false);
			((CButton*)GetDlgItem(IDC_AUDIO)) ->SetCheck(0);
			((CButton*)GetDlgItem(IDC_DATA))  ->SetCheck(1);
			
			break;
	}
}



void CBlueChat2Dlg::ResetAddressListBox()
{
	unsigned short	i;
	unsigned short	NumItems;
	CComboBox	   *pCBoxItem;
	
	AppendHCIDisplay("Reset Address List");

	// Remove Memory held by CCombo List Box
	pCBoxItem = (CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR);
	
	NumItems = pCBoxItem->GetCount();
	for(i = 0; i < NumItems; i++)
	{
		HCIInquiryResultEventData = (HCI_INQUIRY_RESULT_EVENT*)pCBoxItem->GetItemDataPtr(i);
		delete [] HCIInquiryResultEventData;
	}

	pCBoxItem->ResetContent();
}
BOOL CBlueChat2Dlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	
	if (wParam == IDC_TROJAN)  // If the command is to do the "default button"...
    {
		if (GetFocus() == &InputWindow)  // but we're actually in the Input Window...
		{
		    //  This collects "enter" keystrokes from the input window.
		    InputWindow.AddText(_T("\n"));

		    if (Connected && !Audio && !FileBeingSent)
		    {
				//  And send data to the other bluetooth device.
				//  It's a character, length = 2, so channel = 1.
				HCISendDataMessage[0] = (char) 2;
				HCISendDataMessage[1] = (char) 0;
				HCISendDataMessage[2] = (char) 1;
				HCISendDataMessage[3] = (char) 0;
				HCISendDataMessage[4] = (char) '\n';  // 13 Enter Key
				HCISendDataMessage[5] = (char) 0;

				HCISendData->ConnectionHandle		= AclConnectionCompleteEventData->ConnectionHandle;
				HCISendData->PacketBoundaryFlag		= 1;
				HCISendData->BroadcastFlag			= 0;
				HCISendData->DataStart				= HCISendDataMessage;
				HCISendData->DataLength				= 6;

				SendHCIMessage();
		    }
		    return true;
		}
    }
	return CDialog::OnCommand(wParam, lParam);
}

void  CBlueChat2Dlg::ProcessHciEvConnectionRequest(HCI_CONNECTION_REQUEST_EVENT * HCIEventDataPacket)
{
	
	switch(HCIEventDataPacket->LinkType)
	{
		case CONNECTION_EVENT_LINK_TYPE_SCO:
			if(!Audio)
			{
				// For now accept any old connection request
				PARAMETER_ARRAY	HCICommandArray = new PARAMETER_VALUE[HCI_ACCEPT_CONNECTION_REQUEST_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];
			
				// CreateConnection(...)
				HCICommandArray[0]  = HCI_ACCEPT_CONNECTION_REQUEST_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
				HCICommandArray[1]	= HCI_ACCEPT_CONNECTION_REQ;
				HCICommandArray[2]	= HCIEventDataPacket->BTDeviceAddress.Lap;
				HCICommandArray[3]	= HCIEventDataPacket->BTDeviceAddress.Uap;
				HCICommandArray[4]	= HCIEventDataPacket->BTDeviceAddress.Nap;
				HCICommandArray[5]	= 0; // Not used for SCO connection accepts
			
				ProcessHCICommandRequest(HCICommandArray);
			
				delete [] HCICommandArray;
			}
			
			break;

		case CONNECTION_EVENT_LINK_TYPE_ACL:
			// We should not get here as Auto Connection is enabled at the moment
			TRACE(_T("\n\rERROR.. Should have auto connect enabled, why are we here?"));
			break;
	}
	delete HCIEventDataPacket;
}



void CBlueChat2Dlg::SendHCIMessage()
{
	bool Status;

//	mEngine->getSizeOfBufferContent(); // DEBUG
	


	
	if(Connected)
	{
		Status = mEngine->SendHCIData(HCISendData->ConnectionHandle,
									  HCISendData->PacketBoundaryFlag,
									  HCISendData->BroadcastFlag,
									  HCISendData->DataStart,
									  HCISendData->DataLength);
	}
}

void CBlueChat2Dlg::OnInquireCancel() 
{
	PARAMETER_VALUE HCICommandArray [HCI_INQUIRY_CANCEL_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA];

	HCICommandArray[0]  = HCI_INQUIRY_CANCEL_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA; 
	HCICommandArray[1]	= HCI_INQUIRY_CANCEL; 

	ProcessHCICommandRequest(HCICommandArray);

    //  enable inquiry and connect buttons
    GetDlgItem(IDC_INQUIRE)   		->EnableWindow(true);
    GetDlgItem(IDC_INQUIRE)   		->ShowWindow( SW_SHOWNOACTIVATE );
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->EnableWindow(false);
    GetDlgItem(IDC_INQUIRE_CANCEL2)  ->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_DISCONNECT2)		->EnableWindow(true);

	//re-enable connect button only if there is someone out there...
    if ( ((CComboBox *)GetDlgItem(IDC_REMOTE_BDADDR))->GetCount() != 0 )
        GetDlgItem(IDC_CONNECT)   ->EnableWindow(true);
}

void CBlueChat2Dlg::SendInitialCommands ()
{
	if(CommsStarted)
	{
		PARAMETER_VALUE	HCICommandArray[3];						

    	// Send HCI Command HCI_Read_BD_ADDR();
		HCICommandArray[0]  = HCI_READ_BD_ADDR_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
		HCICommandArray[1]	= HCI_READ_BD_ADDR;

		ProcessHCICommandRequest(HCICommandArray);

    	// Send HCI Command HCI_Read_Buffer_Size();
		HCICommandArray[0]  = HCI_READ_BUFFER_SIZE_CMD_LEN + ARRAY_LENGTH_AND_CMD_DATA;
		HCICommandArray[1]	= HCI_READ_BUFFER_SIZE;

		ProcessHCICommandRequest(HCICommandArray);

    	// Set up initial status of dialog items
		GetDlgItem(IDC_MASTER)			 ->EnableWindow(true);
		GetDlgItem(IDC_SLAVE)			 ->EnableWindow(true);
    	((CButton*)GetDlgItem(IDC_DATA)) ->EnableWindow(true);
    	((CButton*)GetDlgItem(IDC_AUDIO))->EnableWindow(true);
     	GetDlgItem(IDCHAT)				->EnableWindow(false);				
    	GetDlgItem(IDFILE)				->EnableWindow(false);


	}
}


void CBlueChat2Dlg::BoxDone()
{
	// this function is called by the modeless dialog as it terminates
	// just reset our pushbutton to be enabled again.
	// I _don't_ delete the MFC CDialog object because the dialog's own
	// code will do that.
	
	m_pModeless = NULL;
	// don't delete m_pModeless; !
	GetDlgItem(IDDEBUGSCREEN)->EnableWindow();
}



extern "C"
{
time_t gettimet(void)
{
	CTime t;
	time_t osBinaryTime = t.GetTime(); // time_t defined in <time.h>
	return osBinaryTime;
}
}

