// bluechat2Dlg.h : header file
//

#if !defined(AFX_BLUECHAT2DLG_H__5D79643A_71FE_47C0_B803_B1D3AB2F1618__INCLUDED_)
#define AFX_BLUECHAT2DLG_H__5D79643A_71FE_47C0_B803_B1D3AB2F1618__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "BlueChatEngine.h"
#include "BlueChat2HciDefs.h"
#include "console.h"
#include "DlgProxy.h"
#include "hci/Packer_parameters.h"
#include "Morechat.h"
//#include "adderdlg.h"
#include "hcidebug.h"

class CBlueChatDlgAutoProxy;

/////////////////////////////////////////////////////////////////////////////
// CBlueChat2Dlg dialog

class CBlueChat2Dlg : public CDialog
{
	DECLARE_DYNAMIC(CBlueChat2Dlg);
	friend class CBlueChatDlgAutoProxy;


// Construction
public:
	CBlueChat2Dlg(CWnd* pParent = NULL);	// standard constructor

	void SetFactory(BlueCoreControllerFactory * Factory);

	virtual ~CBlueChat2Dlg();

	void BoxDone();


// Dialog Data
	//{{AFX_DATA(CBlueChat2Dlg)
	enum { IDD = IDD_BLUECHAT2_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBlueChat2Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CBlueChatDlgAutoProxy* m_pAutoProxy;
//	CMoreChat* m_pModeless;
//	CAddDialog* m_pModeless;
	Chcidebug* m_pModeless;

	BOOL CanExit();

    CBlueChatEngine 							* mEngine;
    BlueCoreControllerFactory 					* mFactory;
	HCI_INQUIRY_RESULT_EVENT 					* HCIInquiryResultEventData;
	HCI_CONNECTION_COMPLETE_EVENT 				* AclConnectionCompleteEventData;
	HCI_CONNECTION_COMPLETE_EVENT 				* ScoConnectionCompleteEventData;
	HCI_SEND_DATA								* HCISendData;
	HCI_SEND_DATA								* HCIReceivedData;
	uint8 										* HCISendDataMessage;
	HCI_CMD_COMPLETE_READ_BUFFER_SIZE_EVENT		* HCICmdCompReadBufferSizeEventData;
	HCI_CMD_COMPLETE_READ_BD_ADDR_EVENT			* HCICmdCompReadBdAddrEventData;

	Console InputWindow;
    Console HCIDisplay;	





	// Generated message map functions
	//{{AFX_MSG(CBlueChat2Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnMore();
	afx_msg void OnMore2();
	afx_msg void OnAboutcsr();
	afx_msg void OnXfer();
	afx_msg void OnInquire();
	afx_msg void OnMaster();
	afx_msg void OnSlave();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnAudio();
	afx_msg void OnData();
	afx_msg void OnSelchangeRemoteBdaddr();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBrowse();
	afx_msg void OnSend();
	afx_msg void OnInquireCancel();
	//}}AFX_MSG

	
	afx_msg void OnHCIInquiryResultEvent(	WPARAM 		 Dummy, 	void * InquiryEventData);
	afx_msg void OnConnectionComplete(		WPARAM 		 Dummy, 	void * ConnectionCompleteEventData);
	afx_msg void OnDisconnectComplete(		WPARAM 		 Dummy, 	void * DisconnectionCompleteEventData);
	afx_msg void SendChar(					WPARAM 		 nChar,		LPARAM dummy);
	afx_msg void ReceiveHCIDataPacket(		WPARAM 		 Dummy,		void * HCIDataPacket);
	afx_msg void OnInquiryComplete(			WPARAM 		 dummy, 	void * HCIDataPacket);
	afx_msg void OnCommandComplete(			unsigned int Opcode, 	void * HCIDataPacket);
	afx_msg void OnHCIEvent(				unsigned int EventCode, void * HCIDataPacket);
    afx_msg void OnHCIFileMore(				WPARAM 		 dummy, 	LPARAM ldummy);
    afx_msg void UpdateProgressBar(			WPARAM 		 dummy, 	LPARAM ldummy);
	
	
	
	
	
	
	DECLARE_MESSAGE_MAP()

	void AppendHCIDisplay(CString Message);

private:

	void ProcessHciEvConnectionRequest(HCI_CONNECTION_REQUEST_EVENT * HCIEventDataPacket);

	void ProcessHciEvCommandStatus(HCI_COMMAND_STATUS_EVENT * HCICmdStatusEvent);
	void ProcessHCICommandRequest(PARAMETER_ARRAY HCICommandArray);
	void SendHCIMessage();
    void SendInitialCommands ();	

	void StoreConnectionEventData(HCI_CONNECTION_COMPLETE_EVENT * LocalConnectionData, HCI_CONNECTION_COMPLETE_EVENT * ConnectionData);
	void DisconnectReset(unsigned short Reason);
	void ResetAddressListBox();


    void processPacket ( L2CAP_PACKET_T * todo );
    void checkStatusOfPacket ( L2CAP_PACKET_T * todo );
    void SortOutFileName ( L2CAP_PACKET_T * todo );
    int  WriteToFile(char *Message, int Length);	

    bool DiscardFileData;	
	bool Audio;
	bool CommsStarted;
	bool Connected;
    L2CAP_PACKET_T * currentL2CAPPacket;
    uint16 newFileNameLength;
    uint16 newFileNameRecvedLength;
	bool FileBeingSent;
	bool FileSent;
	bool Master;
	bool TryingToDisconnect;
    bool AboutToClose;
    bool FirstPacket;
    bool HiResClock;
    bool InquiryScanAllowed;
    bool PageScanAllowed;
    bool ReallyCloseComplete;
    bool Scanning;
    bool WaitingForFirstPacket;
    bool WaitOnInit;
	
    CStdioFile *NewFile;
    CStdioFile *ReadFile;

    unsigned long int 	NewFileLength;
    unsigned long int 	NewFileTotalLength;
    unsigned long int 	FilePositionCounter;
    unsigned long int 	ReadFileLength;
	unsigned int 	  	HCIpacketsPerL2CAPpacket;
	unsigned int 	  	PacketCounter; 			
    unsigned int 		WaitCounter;

    DWORD 				FileStartTime;
    CString 			NewFileName;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLUECHAT2DLG_H__5D79643A_71FE_47C0_B803_B1D3AB2F1618__INCLUDED_)
