// BlueChatEngine.h: interface for the CBlueChatEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BLUECHATENGINE_H__39A5EF39_6702_4121_B398_C40E4C4CAF5D__INCLUDED_)
#define AFX_BLUECHATENGINE_H__39A5EF39_6702_4121_B398_C40E4C4CAF5D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "common/types.h"
#include "HCI/HCIDeviceController.h"
#include "HCI/packer_parameters.h"
#include "BlueChat2HciDefs.h"

class BlueCoreDeviceController; 
class BlueCoreControllerFactory;


class CBlueChatEngine  
{

public:
    //  AJH HACKING //
    BlueCoreDeviceController * getDC ();

	uint32 getSizeOfBufferContent();
	
	bool SendHCIData(uint16 ConnectionHandle, bool PacketBoundaryFlag, uint8 BroadcastFlag, uint8 * DataStart, uint16 DataLength);

#if 0
	void setOnString( void (*onString) ( bool verboseNotConcise , char * aString , void * aParameters ) , void * aParameters );
#endif

	HCI_INQUIRY_RESULT_EVENT  * HCIInquiryResultEventData;
	HWND						BC2Dialog;

		
	bool SendHCICommand(PARAMETER_ARRAY parameters);
	
	CBlueChatEngine();

	virtual ~CBlueChatEngine();

    
	//  Set the factory.
    void setFactory(BlueCoreControllerFactory * aFactory);

    
	//  Set up BCSP and talk to the chip
    bool startChip();


    //  Hard reset over bccmd, and take down BCSP.
    void resetChip(void);

 
	//  Is there a chip?
    bool connected(void);


    //  Generate a bccmd sequence number.
    uint16 nextSequence ( void );


    //  Provide stubs for callbacks.
    static void __stdcall onHCIData(	uint16	connectionHandle , 
							bool	packetBoundaryFlag , 
							uint8	broadcastFlag , 
							uint8  *dataStart , 
							uint16	dataLength, 
							void   *aThis);

    
	static void __stdcall onHCIEvent( uint8				EventCode, 
                            PARAMETER_ARRAY		EventParameters ,
                            void			   *aThis);


    static void onBCCMD(PARAMETER_ARRAY eventParameters, void * aThis);


    void processBCCMD(PARAMETER_ARRAY eventParameters);


    static void onLinkFail(void * aThis);

    static void onDebugData(uint8* aBuffer, uint32 aLength, void * aThis);

	TCHAR * ComPortID;

private:
    
	BlueCoreControllerFactory * mFactory;
    BlueCoreDeviceController  * mChip;

    CRITICAL_SECTION			sequenceProtection;
    uint16						sequenceNumber;

#if 0

	void * mStringCallBackParameters;
	void (*mStringCallBackFn) ( bool , char* , void* );

	void report ( bool verboseNotConcise , char * aString );
    void report ( bool verboseNotConcise , uint8 aStringNumber , char * aString );

#endif

    friend class CTraceDialog;

};

#endif // !defined(AFX_BLUECHATENGINE_H__39A5EF39_6702_4121_B398_C40E4C4CAF5D__INCLUDED_)
