// cconsole.cpp : implementation file - child console
//

#include "cconsole.h"
#include "BlueChat2HciDefs.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Console

CConsole::CConsole()
{
	MaxLines = 200;
	ContinueLine = 0 ;
	writeable = false;
}

CConsole::~CConsole()
{
}


BEGIN_MESSAGE_MAP(CConsole, CListBox)
	//{{AFX_MSG_MAP(CConsole)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_WM_CHAR()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConsole message handlers


BOOL CConsole::Initialise(UINT nID, CWnd* pParent, HWND *set_window)
{
    dlg = set_window;
    BOOL retval = SubclassDlgItem(nID, pParent);
    return retval ;
}

void CConsole::Clear(void)
{
	ResetContent() ;
	SetHorizontalExtent(0) ;
}
void CConsole::AddText(TCHAR * text)
{
	if (!text) return ;
	CString line;
	TCHAR * ptr = text ;
	while (*ptr)
	{
		if (ContinueLine)
		{
			int lastline = GetCount() -1 ;
			if (lastline >=0)
			{
				GetText(lastline,line) ;
				DeleteString(lastline) ; //we'll rewrite it later
			}
		}
		
		while ( (*ptr) && (*ptr  != 13) && (*ptr != 10)) 
		{
			ContinueLine = 1 ;
			line+= *ptr ;
			ptr ++ ;
		}
		if (*ptr) 
		{
			ptr ++ ; //skip over newlines
			ContinueLine = 0 ;
		}
		
		int retval = AddString(line) ;
		while (retval == LB_ERRSPACE) 
		{
			DeleteString(0) ;
			retval = AddString(line) ;
		}
		line.Empty() ;
	}	
	
	//now scroll to end ...
	int numlines = GetCount() ;
	while (numlines > MaxLines) 
	{
		DeleteString(0) ;
		numlines -- ;
	}
	if (numlines <=0) return ;
	SetTopIndex(numlines-1) ;
	
	//now ensure that width is sufficient ... assume average5 pixels
	//per char 
	int scrollwidth = GetHorizontalExtent() ;
	int linechars = GetTextLen(numlines-1) ;
	if (linechars * 15 > scrollwidth) 
		SetHorizontalExtent(linechars *15 ) ;
}

void CConsole::SetWriteable(bool yn)
{
	writeable = yn;
	return;
}

void CConsole::DeleteLastChar()
{
	CString line;
	if (ContinueLine) // if we are half way along a line
	{
		int lastline = GetCount() - 1 ;
		if (lastline >=0)
		{
			GetText(lastline,line) ;
			DeleteString(lastline) ;
			unsigned int length = line.GetLength();
			AddString(line.Left(length - 1));
			if (length == 1)
				ContinueLine = false;
		}
	}
	else // if we are at the beginning of a line
	{
		int lastline = GetCount() - 1 ;
		if (lastline >= 0)
		{
			DeleteString(lastline) ;  //  delete the empty line, and 
			ContinueLine = true;      //  put the continuation marker on the line above
		}
	}
	return;
}

void CConsole::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (writeable)
	{
		if (nChar == 8) // Delete key!
		{
			DeleteLastChar();
		}
		else
		{
			TCHAR a[5];
			a[0] = (TCHAR)nChar;
			a[1] = 0;
			AddText(a);
		}
		//  Functionality only for BCTEF applications - sends a character to the parent
		//  window to be sent to the other end of a bluetooth connection.
		(void) ::PostMessage(HWND_BROADCAST, UDM_SEND_CHAR, nChar, NULL); // bad Adam
	}
	return;
}
