// TraceDialog.cpp : implementation file
//

#include "stdafx.h"
#include "unicode/ichar.h"
//#include "bluechat.h"
#include "bcsp/bcspstack.h"
#include "BlueChat2.h"
#include "TraceDialog.h"
#include "BlueChatEngine.h"
#include "HCI/bc01DeviceController.h"
#include "hci/Win32BCSPTransport.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



#include "bcsp/BTRACE.h"

/////////////////////////////////////////////////////////////////////////////
// CTraceDialog dialog


CTraceDialog::CTraceDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTraceDialog::IDD, pParent)
{
#ifdef _DEBUG
	BCSPdebugMask = 0xffffffff;  // Set the mask in BCSP.DLL
#endif
    changeFileName = true;
	//{{AFX_DATA_INIT(CTraceDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
} 


void CTraceDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTraceDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTraceDialog, CDialog)
	//{{AFX_MSG_MAP(CTraceDialog)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTraceDialog message handlers

uint32 ButtonIds[32] = {IDC_SLIP,IDC_REQROUTER,IDC_SEQ,IDC_MUX,IDC_SLIPSND,IDC_SLIPSNDRAW,IDC_IO,IDC_SLIPRCV,
                        IDC_RCV,IDC_LINKEST,IDC_PKTMNG,IDC_PKTDLVR,IDC_DATAINTEGRITY,IDC_WINERR,IDC_BIT14,IDC_BIT15,
                        IDC_USER0,IDC_USER1,IDC_USER2,IDC_USER3,IDC_USER4,IDC_USER5,IDC_USER6,IDC_USER7,
                        IDC_BIT24,IDC_BIT25,IDC_BIT26,IDC_BIT27,IDC_BIT28,IDC_BIT29,IDC_BIT30,IDC_SCHEDULER};
uint32 Masks[32]     = {SLIP    ,REQROUTER    ,SEQ    ,MUX    ,SLIPSND    ,SLIPSNDRAW    ,IO    ,SLIPRCV    ,
                        RCV    ,LINKEST    ,PKTMNG    ,PKTDLVR    ,DATAINTEGRITY    ,WINERR    ,(1<<14)  ,(1<<15)  ,
                        USER0    ,USER1    ,USER2    ,USER3    ,USER4    ,USER5    ,USER6    ,USER7    ,
                        (1<<24)  ,(1<<25)  ,(1<<26)  ,(1<<27)  ,(1<<28)  ,(1<<29)  ,(1<<30)  ,SCHEDULER    };


void CTraceDialog::OnOK() 
{
    traceMask = 0;
    for (uint8 i = 0 ; i < 32 ; i ++ )
        if (((CButton*)GetDlgItem(ButtonIds[i]))->GetCheck() == 1)
            traceMask |= Masks[i];

    GetDlgItem(IDC_FILENAME)->GetWindowText(filename);
#ifndef _WINCE
    BTRACELOG ( filename.GetBuffer(0) );
#endif
    filename.ReleaseBuffer();
    BTRACEDISABLE ( -1 );
    BTRACEENABLE ( traceMask );

	CDialog::OnOK();
}

void CTraceDialog::OnBrowse() 
{
    //  Summon a windows standard filename finder, and then put the result into IDC_FILENAME
    CFileDialog * filehandler;
#ifndef _WINCE
    filehandler = new CFileDialog(true, "txt",
					    filename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "All Files|*.*|Text Files|*.txt||" , this);

#else

    filehandler = new CFileDialog(true, _T("txt"),
					    filename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("All Files|*.*|Text Files|*.txt||") , this);
#endif   
    int nResponse = filehandler->DoModal();
    if (nResponse == IDOK)
    {
 	GetDlgItem(IDC_FILENAME)->SetWindowText( filehandler->GetPathName() );
    }
    else if (nResponse = IDCANCEL)
    {
	// Can't think of any useful errors, so just assume the user cancelled...
    }
    return;
}

BOOL CTraceDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
    if (filename.IsEmpty())
        filename = "logfile.txt";
    GetDlgItem(IDC_FILENAME)->SetWindowText(filename);
    GetDlgItem(IDC_FILENAME)->EnableWindow(changeFileName);
    GetDlgItem(IDC_BROWSE)->EnableWindow(changeFileName);


    if (traceMask != 0)
    {
        //  Want to set these to 1 if the bit is set, or 0 otherwise.
        //  x OR (1<<n) sets the nth bit.  (x OR (1<<n)) XOR x is zero if the nth bit of x was set,
        //  and 2^n otherwise.
        //  The boolean evaluates to 1 if the bit was set or 0 if it wasn't.
        for (uint8 i = 0 ; i < 32 ; i ++ )
            ((CButton*)GetDlgItem(ButtonIds[i]))->SetCheck( ( ( traceMask | Masks[i] ) ^ traceMask ) == 0 );  
    }
	
    if ( CString(pEngine->mChip->getTransport()->getName()) != CString(II("Win32BCSPTransport")) )
        trans = (Win32BCSPTransport *) pEngine->mChip->getTransport();
    else
    {
        PostMessage ( WM_CLOSE );
#ifdef _WINCE
        MessageBox ( _T("Can only be used on BCSP.") , _T("Error") , MB_ICONERROR );
#else
        MessageBox ( "Can only be used on BCSP." , "Error" , MB_ICONERROR );
#endif
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
