// BlueTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlueTest.h"
#include "BlueTestDlg.h"
#include "resource.h"
#include "PSSetDlg.h"
#include "testNames.h"
#include "initialValues.h"
#include "fileFilter.h"
#include "DebugFile.h"

#ifdef _WINCE
#include <windows.h>
#include <tchar.h>
#include <olectl.h>
#include <ctype.h>
#include <dbgapi.h>

#endif


#ifdef _WINCE
#include <afxwin.h>
#include <windef.h>
#include <winuser.h>
#include <stdlib.h>
#endif


#ifdef _WINCE
//double atof(const char *);
//uint32 strtoulreplacement(char *,char **, int);
//int isvalidhex(char);
//int isvalidoct(char);
//int isvalidbin(char);
//int isvaliddec(char);

#endif

#define CONNECTION_TIMER (1)
#define WORK_TIMER (2)
#define SUBSEQUENT_CONNECTION_TIMER (3)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CDebugFile * g_pDbgDlg=NULL;
CAboutDlg * g_pAboutBox=NULL;

/////////////////////////////////////////////////////////////////////////////
// CBlueTestDlg dialog

CBlueTestDlg::CBlueTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlueTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlueTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CBlueTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlueTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBlueTestDlg, CDialog)
	//{{AFX_MSG_MAP(CBlueTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SENDCOMMAND, OnSendcommand)
	ON_BN_CLICKED(IDC_COLDRESET, OnColdreset)
	ON_LBN_SELCHANGE(IDC_COMMANDS, OnSelchangeCommands)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_ARG_VALUE, OnChangeArgValue)
	ON_EN_CHANGE(IDC_ARG_VALUE2, OnChangeArgValue2)
	ON_EN_CHANGE(IDC_ARG_VALUE3, OnChangeArgValue3)
	ON_EN_CHANGE(IDC_ARG_VALUE4, OnChangeArgValue4)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_VERBOSE, OnVerbose)
	ON_BN_CLICKED(IDC_PS, OnPs)
	ON_BN_CLICKED(IDC_CONCISE, OnConcise)
	ON_EN_CHANGE(IDC_ARG_VALUE2_1, OnChangeArgValue2)
	ON_EN_CHANGE(IDC_ARG_VALUE2_2, OnChangeArgValue2)
	ON_BN_CLICKED(IDC_DEBUGFILE, OnDebugfile)
	ON_BN_CLICKED(IDC_ABOUTCSR, OnAboutcsr)
	//}}AFX_MSG_MAP
        ON_MESSAGE ( BLUETEST_MESSAGE_OUTPUT_STRING , OnOutputString )
		ON_MESSAGE(UDM_DEBUG_FILE, GettheDebugFile)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlueTestDlg message handlers

BOOL CBlueTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
#ifndef _WINCE
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
#endif
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////

		debugfileon = FALSE;
		debugfilename = "debug1.txt";

        sMessageWindow.Initialise(IDC_MESSAGEWINDOWING1 , this , &m_hWnd );
        sConciseMessageWindow.Initialise(IDC_MESSAGEWINDOWING2 , this , &m_hWnd );
        ::InitializeCriticalSection( &protectFile );
        pOutFile = NULL;
        ::InitializeCriticalSection( &protectOutputStringList );
        this->OutputStringListHead = NULL;
        initState();

        mEngine = new CBluetestEngine;
		mEngine->setOnString ( acceptOutputString , this );
        mEngine->setFactory ( mFactory );
        mEngine->startChip();

        SetTimer ( CONNECTION_TIMER , 50 , NULL );
        
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBlueTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBlueTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
#ifndef _WINCE
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
#endif
//    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);





		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBlueTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////

void CBlueTestDlg::setFactory ( BlueCoreControllerFactory * Factory )
{
    this->mFactory = Factory;
}

void CBlueTestDlg::acceptOutputString ( bool verboseNotConcise , TCHAR * aString , void * aThis )
{
    ( (CBlueTestDlg*)aThis )->queueOutputString ( verboseNotConcise , aString );
}

void CBlueTestDlg::queueOutputString ( bool verboseNotConcise , TCHAR * aString )
{
    COutputStringQueueEntry * entry = new COutputStringQueueEntry;

    int length = _tcsclen ( aString );
    TCHAR * output = new TCHAR[length + 3];
    memcpy ( output , aString , length * sizeof(TCHAR));
    memcpy ( output + length , _T("\n") , 3 * sizeof(TCHAR));

    entry->string = output ;
    entry->verboseNotConcise = verboseNotConcise;
    entry->next = NULL;

    ::EnterCriticalSection ( &protectOutputStringList );

    if ( this->OutputStringListHead == NULL )
    {
        OutputStringListHead = entry;
        OutputStringListTail = entry;
    }
    else
    {
        OutputStringListTail->next = entry;
        OutputStringListTail = entry;
    }

    ::LeaveCriticalSection ( &protectOutputStringList );
    PostMessage ( BLUETEST_MESSAGE_OUTPUT_STRING );
}

void CBlueTestDlg::OnOutputString (WPARAM dummy, LPARAM ldummy)
{
    ::EnterCriticalSection ( &protectOutputStringList );


//#ifndef _WINCE
    while ( OutputStringListHead != NULL )
    {
        //  unhitch the first message;
        COutputStringQueueEntry * tbd = OutputStringListHead;
        OutputStringListHead = OutputStringListHead->next;
        outputString ( tbd->verboseNotConcise , tbd->string );
        delete tbd->string;
        delete tbd;
    }
//#else
//    while ( uOutputStringListHead != NULL )
//    {
//        //  unhitch the first message;
//        uCOutputStringQueueEntry * tbd = uOutputStringListHead;
//        uOutputStringListHead = uOutputStringListHead->next;
//        outputString ( tbd->verboseNotConcise , tbd->string );
//        delete tbd->string;
//        delete tbd;
//    }
//#endif





    ::LeaveCriticalSection ( &protectOutputStringList );
}


void CBlueTestDlg::GettheDebugFile (WPARAM dummy, LPARAM ldummy)
{

	pOutFile = (CStdioFile *)g_pDbgDlg->pOutFile;

}


void CBlueTestDlg::BoxDone (void)
{
	organiseFile();
}









void CBlueTestDlg::outputString ( bool verboseNotConcise , TCHAR * aString )
{
    //  The difference between the two screens is that the concise deletes that last row
    //  when it prints the next.
    if ( verboseNotConcise )
        sMessageWindow.AddText( aString );
    else
    {
        int lastline = sConciseMessageWindow.GetCount() - 1;
        sConciseMessageWindow.DeleteString (lastline);
        sConciseMessageWindow.AddText( aString );
    }

    //  If this is the currently displayed version, then put it in the file.
    if ( mVerboseNotConcise == verboseNotConcise )
    {
        ::EnterCriticalSection( &protectFile );
        if ( pOutFile != NULL )
            pOutFile->Write ( aString, _tcsclen(aString) * sizeof(TCHAR) );
        ::LeaveCriticalSection( &protectFile );
    }
}

void CBlueTestDlg::initState()
{
    //  Initialise the dialog box.
    ( (CButton * ) GetDlgItem ( IDC_VERBOSE ) ) -> SetCheck ( 1 );
    mVerboseNotConcise = true ;
    setState ( mVerboseNotConcise );

    //  Clear the messages
    sMessageWindow.Clear();
    sConciseMessageWindow.Clear();

    //  Clear and repopulate the test list box
    CListBox * lListBox = (CListBox*)GetDlgItem(IDC_COMMANDS);
    lListBox->ResetContent();
    for (uint8 lCommandCounter = 0 ; lCommandCounter < TESTNAMES_SIZE ; lCommandCounter ++ )
    {
        lListBox->InsertString ( lCommandCounter , testNames[lCommandCounter].string);
        lListBox->SetItemData ( lCommandCounter , testNames[lCommandCounter].test );
    }

    //  reset the values in mTestParameters
    initTestParams();

    //  Hide and clear the arguments
    GetDlgItem(IDC_ARG_NAME)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_NAME2)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_NAME3)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_NAME4)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE2_1)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE2_2)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( NULL );
    GetDlgItem(IDC_ARG_VALUE)->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_ARG_VALUE3)->ShowWindow( SW_HIDE );
    GetDlgItem(IDC_ARG_VALUE4)->ShowWindow( SW_HIDE );

    //  Set the delfault filename and uncheck the box.
//#ifndef _WINCE    moved to new window
//    GetDlgItem(IDC_FILENAME)->SetWindowText( ".\\logfile.txt" );
//#else
//
//    GetDlgItem(IDC_FILENAME)->SetWindowText( _T(".\\logfile.txt") );
//#endif

//    moved to new window ((CButton*)GetDlgItem(IDC_SAVE))->SetCheck(0);
//    if ( pOutFile != NULL )
 //   {
//        delete pOutFile;
//        pOutFile = NULL;
//    }
}

void CBlueTestDlg::initTestParams()
{
    //  Current test "NONE".
    mCurrentTest = &mTestParameters[RADIOTEST_PAUSE];

    memset ( mTestParameters , 0 , sizeof( CTestParams ) * TEST_COUNT ) ;
    memcpy ( mTestParameters , initialTestParams , sizeof( CTestParams ) * TEST_COUNT ) ;
}




////void CBlueTestDlg::OnBrowse() 
////{
    //  Summon a windows standard filename finder, and then put the result into IDC_FILENAME
 ////   CFileDialog * filehandler;
////    CString filename = "";
////    GetDlgItem(IDC_FILENAME)->GetWindowText(filename);
////#ifndef _WINCE
////    filehandler = new CFileDialog ( true , "txt" , filename , OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, fileFilter , this);
////#else
////    filehandler = new CFileDialog ( true , _T("txt") , filename , OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, ufileFilter , this);
////#endif    
////    int nResponse = filehandler->DoModal();
////    if (nResponse == IDOK)
////    {
//// 	GetDlgItem(IDC_FILENAME)->SetWindowText( filehandler->GetPathName() );
////    }
////    else if (nResponse = IDCANCEL)
 ////   {
	// Can't think of any useful errors, so just assume the user cancelled...
 ////   }
////    return;
////}

void CBlueTestDlg::OnSendcommand() 
{
    switch ( mCurrentTest->test )
    {
    case NOT_RADIOTEST_NOTHING:
        break;
    case NOT_RADIOTEST_SET_PIO:
        mEngine->setPIOLines ( mCurrentTest->d[ 0 ].value , mCurrentTest->d[ 1 ].value );
        break;
    case NOT_RADIOTEST_READ_PIO:
        mEngine->readPIOLines();
        break;
    case NOT_RADIOTEST_PROVOKE_FAULT:
        mEngine->provokeFault( mCurrentTest->d[0].value );
        break;
    case NOT_RADIOTEST_READ_FW_VERSION:
        mEngine->readFWVersion();
        break;
    default:

        uint16 lTest[TEST_SIZE];
        lTest[0] = mCurrentTest->test ;

        for ( uint8 i = 1 ; i < TEST_SIZE ; i ++ )
            if ( mCurrentTest->parameterCount >= i )
                lTest[i] = mCurrentTest->d[ i - 1 ].value;
            else
                lTest[i] = 0;
        
        mEngine->runTest( lTest );
        break;
    }
}

void CBlueTestDlg::OnColdreset() 
{

   
	mEngine->resetChip();
    Sleep (100);
    mEngine->startChip();

    SetTimer ( CONNECTION_TIMER , 1000 , NULL );
}

void CBlueTestDlg::OnSelchangeCommands() 
{
    CListBox * lListBox = (CListBox*)GetDlgItem(IDC_COMMANDS);

    int lCurrentRow = lListBox->GetCurSel();
	mCurrentTest = mTestParameters + lListBox->GetItemData(lCurrentRow);
    setState ( mCurrentTest );
}

void CBlueTestDlg::setState( CTestParams * aTest )
{
    //  set the dialog box for the current command.
#ifndef _WINCE
    char word[10] = "0";
    char word2[10] = "0";
#else
    TCHAR word[10] = _T("0");
    TCHAR word2[10] = _T("0");
	int inttmp;
#endif
    int32 bits_count;
    int32 lap;
    CTestParameterInfo * data = aTest->d;

    //  Hide and clear or show and set the arguments
    switch (aTest->test)
    {
    //  Special cases first
    case RADIOTEST_CFG_BIT_ERR:
        // uint32 bits_count, bool reset;
#ifndef _WINCE
        GetDlgItem(IDC_ARG_NAME)->SetWindowText( "Bits Count" );
        GetDlgItem(IDC_ARG_NAME2)->SetWindowText( "Reset" );
#else
        GetDlgItem(IDC_ARG_NAME)->SetWindowText( _T("Bits Count") );
        GetDlgItem(IDC_ARG_NAME2)->SetWindowText( _T("Reset") );
#endif
        GetDlgItem(IDC_ARG_NAME3)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_NAME4)->SetWindowText( NULL );

        //  use the first two arguments to make the first value.
        bits_count = ((uint32)data[0].value << 16) + data[1].value;
#ifndef _WINCE
        sprintf (word , "%d" , bits_count);
#else
        wsprintf (word , _T("%d") , bits_count);
#endif
        GetDlgItem(IDC_ARG_VALUE)->SetWindowText( word );

        //  put the third argument in the second value.
        this->fillWord( word , &data[2] );




        GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( word );

        GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_VALUE)->ShowWindow( SW_SHOWNOACTIVATE );
        GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_SHOWNOACTIVATE );
        GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE3)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE4)->ShowWindow( SW_HIDE );
        break;
    case RADIOTEST_CFG_UAP_LAP:
        // uint16 UAP, uint32 LAP;
#ifndef _WINCE
        GetDlgItem(IDC_ARG_NAME)->SetWindowText( "UAP (hex)" );
        GetDlgItem(IDC_ARG_NAME2)->SetWindowText( "LAP (hex)" );
#else
        GetDlgItem(IDC_ARG_NAME)->SetWindowText( _T("UAP (hex)") );
        GetDlgItem(IDC_ARG_NAME2)->SetWindowText( _T("LAP (hex)") );       
#endif		
		GetDlgItem(IDC_ARG_NAME3)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_NAME4)->SetWindowText( NULL );

        //  put the first argument in the first value.
        this->fillWord( word , &data[0] );
        GetDlgItem(IDC_ARG_VALUE)->SetWindowText( word );

        //  use the final two arguments to make the first value.
        lap = ((uint32)data[1].value << 16) + data[2].value;
#ifndef _WINCE
        sprintf (word , "%06x" , lap);
#else
        wsprintf (word , _T("%06x") , lap);
#endif
        GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( word );

        GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( NULL );
        GetDlgItem(IDC_ARG_VALUE)->ShowWindow( SW_SHOWNOACTIVATE );
        GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_SHOWNOACTIVATE );
        GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE3)->ShowWindow( SW_HIDE );
        GetDlgItem(IDC_ARG_VALUE4)->ShowWindow( SW_HIDE );
        break;
    default:
        if ( aTest->parameterCount >= 1 )
        {
            GetDlgItem(IDC_ARG_VALUE)->ShowWindow( SW_SHOWNOACTIVATE );
#ifndef _WINCE
            GetDlgItem(IDC_ARG_NAME)->SetWindowText( aTest->d[0].name );
#else
			inttmp = strlen(aTest->d[0].name) + 1;
			TCHAR * unicodetext = new TCHAR[inttmp]; 

			MultiByteToWideChar(CP_ACP,0,aTest->d[0].name,-1,unicodetext,(strlen(aTest->d[0].name)+1));
            GetDlgItem(IDC_ARG_NAME)->SetWindowText( unicodetext );       
			delete unicodetext;

#endif



            fillWord ( word , data );
            GetDlgItem(IDC_ARG_VALUE)->SetWindowText( word );
        }
        else
        {
            GetDlgItem(IDC_ARG_VALUE)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_NAME)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE)->SetWindowText( NULL );
        }

        if ( aTest->parameterCount >= 2 )
        {
#ifndef _WINCE
            GetDlgItem(IDC_ARG_NAME2)->SetWindowText( aTest->d[1].name );

#else
			inttmp = strlen(aTest->d[1].name) + 1;
			TCHAR * unicodetext = new TCHAR[inttmp]; 

			MultiByteToWideChar(CP_ACP,0,aTest->d[1].name,-1,unicodetext,(strlen(aTest->d[1].name) + 1));
            GetDlgItem(IDC_ARG_NAME2)->SetWindowText( unicodetext );       
			delete unicodetext;

#endif



            if ( aTest->d[1].type != p )
            {
                GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_SHOWNOACTIVATE );
                GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_HIDE );
                GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_HIDE );
                fillWord ( word , data + 1 );
                GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( word );
                GetDlgItem(IDC_ARG_VALUE2_1)->SetWindowText( NULL );
                GetDlgItem(IDC_ARG_VALUE2_2)->SetWindowText( NULL );
            }
            else
            {
                GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_HIDE );
                GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_SHOWNOACTIVATE );
                GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_SHOWNOACTIVATE );
                GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( NULL );
                fillWord ( word , data + 1 , word2 );
                GetDlgItem(IDC_ARG_VALUE2_1)->SetWindowText( word );
                GetDlgItem(IDC_ARG_VALUE2_2)->SetWindowText( word2 );
            }
        }
        else
        {
            GetDlgItem(IDC_ARG_VALUE2)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_VALUE2_1)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_VALUE2_2)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_NAME2)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE2_1)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE2_2)->SetWindowText( NULL );
        }

        if ( aTest->parameterCount >= 3 )
        {
            GetDlgItem(IDC_ARG_VALUE3)->ShowWindow( SW_SHOWNOACTIVATE );
#ifndef _WINCE
            GetDlgItem(IDC_ARG_NAME3)->SetWindowText( aTest->d[2].name );
#else
			inttmp = strlen(aTest->d[2].name) + 1;
			TCHAR * unicodetext = new TCHAR[inttmp]; 

			MultiByteToWideChar(CP_ACP,0,aTest->d[2].name,-1,unicodetext,(strlen(aTest->d[2].name) + 1));
            GetDlgItem(IDC_ARG_NAME3)->SetWindowText( unicodetext );       
			delete unicodetext;
#endif
            fillWord ( word , data + 2 );
            GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( word );
        }
        else
        {
            GetDlgItem(IDC_ARG_VALUE3)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_NAME3)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( NULL );
        }

        if ( aTest->parameterCount >= 4 )
        {
            GetDlgItem(IDC_ARG_VALUE4)->ShowWindow( SW_SHOWNOACTIVATE );
#ifndef _WINCE
            GetDlgItem(IDC_ARG_NAME4)->SetWindowText( aTest->d[3].name );
#else
			inttmp = strlen(aTest->d[3].name) + 1;
			TCHAR * unicodetext = new TCHAR[inttmp]; 

			MultiByteToWideChar(CP_ACP,0,aTest->d[3].name,-1,unicodetext,(strlen(aTest->d[3].name)+1));
            GetDlgItem(IDC_ARG_NAME4)->SetWindowText( unicodetext );       
			delete unicodetext;
#endif





            fillWord ( word , data + 3 );
            GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( word );
        }
        else
        {
            GetDlgItem(IDC_ARG_VALUE4)->ShowWindow( SW_HIDE );
            GetDlgItem(IDC_ARG_NAME4)->SetWindowText( NULL );
            GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( NULL );
        }
        break;
    }

}

void CBlueTestDlg::setState( bool verboseNotConcise )
{
    mVerboseNotConcise = verboseNotConcise ;

    GetDlgItem ( IDC_VERBOSE )->ShowWindow ( SW_SHOWNOACTIVATE ) ;
    GetDlgItem ( IDC_MESSAGEWINDOWING2 )->ShowWindow ( verboseNotConcise? SW_HIDE : SW_SHOWNOACTIVATE ) ;

    GetDlgItem ( IDC_CONCISE )->ShowWindow ( SW_SHOWNOACTIVATE ) ;
    GetDlgItem ( IDC_MESSAGEWINDOWING1 )->ShowWindow ( verboseNotConcise? SW_SHOWNOACTIVATE : SW_HIDE ) ;
}
void CBlueTestDlg::fillWord ( TCHAR * aWord , CTestParameterInfo * data , TCHAR * aWord2 )
{
    switch (data->type)
    {
    case b:
        if (data->value)
            _stprintf ( aWord , _T("true") );
        else
            _stprintf ( aWord , _T("false") );
        break;
    case bin:
        {
            const uint8 numberOfBits = 8;
            uint8 b[numberOfBits];
            for ( uint8 counter = 0 ; counter < numberOfBits ; counter ++ )
                b[counter] = ( data->value >> counter ) & 1;
            _stprintf ( aWord , _T("%1x%1x%1x%1x%1x%1x%1x%1x") , b[0], b[1] , b[2] , b[3] , b[4], b[5], b[6] , b[7] );
        }
        break;
    case x:
        _stprintf ( aWord , _T("%x") , data->value );
        break;
    case u:
        _stprintf ( aWord , _T("%u") , data->value );
        break;
    case s:
        _stprintf ( aWord , _T("%d") , data->value );
        break;
    case f:
        _stprintf ( aWord , _T("%1.3f") , ((double)data->value)/(0x1000) );
        break;
    case p:
        _stprintf ( aWord  , _T("%u"), ( data->value >> 8 )  );
        _stprintf ( aWord2 , _T("%u"), ( data->value & 0xFF ) );
        break;
    default:
        _stprintf (aWord , _T("Bad Type.") );
        break;
    }
}


///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////

void CBlueTestDlg::OnTimer(UINT nIDEvent) 
{
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////
    if ( nIDEvent == CONNECTION_TIMER )
    {
        KillTimer ( CONNECTION_TIMER );
        if ( !mEngine->connected() )
            SetTimer ( SUBSEQUENT_CONNECTION_TIMER , 1000 , NULL );
    }
    else if ( nIDEvent == SUBSEQUENT_CONNECTION_TIMER )
    {
        if ( mEngine->connected() )
            KillTimer ( SUBSEQUENT_CONNECTION_TIMER );
    }
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////
	CDialog::OnTimer(nIDEvent);
}

///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////

bool CBlueTestDlg::readWord( TCHAR * aWord , CTestParameterInfo *data , TCHAR * aWord2 )
{
    bool ok = true;
    uint16 value;
    int16 svalue;
    double fvalue;
    switch (data->type)
    {
    case b:
        value = _ttoi(aWord);
        data->value = (value != 0);
        break;
    case bin:
        {
            TCHAR * stopped;
            unsigned long ulvalue = _tcstoul ( aWord , &stopped , 2 );
            if ( stopped < aWord + _tcsclen(aWord) )
                ok = false;
            else
                data->value = (uint16) ulvalue;
        }
        break;
    case x:
        {
            TCHAR * stopped;
            unsigned long ulvalue = ::_tcstoul( aWord , &stopped , 16 );
            if ( stopped < aWord + _tcsclen (aWord) )
                ok = false;
            else
                data->value = (uint16) ulvalue;
        }
        break;
    case u:
        value = _ttoi(aWord);
        data->value = value;
        break;
    case s:
        svalue = _ttoi(aWord);
        data->value = (uint16) svalue;
        break;
    case f:
        fvalue = _ttoi(aWord);
        if ( fvalue <= 3.0 && fvalue >= 0.0)
        {
            data->value = (uint16)(fvalue * 0x1000);
        }
        else
            ok = false;
        break;
    case p:
        //  now, two values in two boxes, packed into one word....
        {
            TCHAR * stopped;
            unsigned long ulvalue1 = ::_tcstoul( aWord , &stopped , 0 );
            if ( stopped < aWord + _tcsclen (aWord) )
                ok = false;
            else
            {
                unsigned long ulvalue2 = ::_tcstoul( aWord2 , &stopped , 0 );
                if ( stopped < aWord2 + _tcsclen (aWord2) )
                    ok = false;
                else
                    data->value = ( ( (uint16)ulvalue1 ) << 8 ) + (uint16)ulvalue2;
            }
        }
        break;
    default:
        ok = false;
        break;
    }

    if (!ok)
        fillWord( aWord , data , aWord2 );

    return ok;
}



void CBlueTestDlg::OnChangeArgValue() 
{
    const int size = 20;
	TCHAR text[size];
	int inttmp;
    int realSize = GetDlgItem(IDC_ARG_VALUE)->GetWindowText( text , size );
    switch ( mCurrentTest->test )
    {
    case RADIOTEST_CFG_BIT_ERR:
        mCurrentTest->d[1].value = _ttoi(text) & 0xFFFF ;
        mCurrentTest->d[0].value = ( _ttoi(text) & 0xFFFF0000 ) >> 16 ;

        break;
    default:
        if ( realSize != 0 )
            if ( !readWord ( text , mCurrentTest->d ) )
//			{

                GetDlgItem(IDC_ARG_VALUE)->SetWindowText( text );


    }
}

void CBlueTestDlg::OnChangeArgValue2() 
{
    const int size = 20;
    TCHAR text[size];
    TCHAR text2[size];

    int realSize = 0;
    int realSize2 = 0;
    if ( mCurrentTest->d[1].type != p )
        realSize = GetDlgItem(IDC_ARG_VALUE2)->GetWindowText( text , size );
    else
    {
        realSize = GetDlgItem(IDC_ARG_VALUE2_1)->GetWindowText( text , size );
        realSize2 = GetDlgItem(IDC_ARG_VALUE2_2)->GetWindowText( text2 , size );
    }
    if ( realSize != 0 )
    {

        switch ( mCurrentTest->test )
        {
        case RADIOTEST_CFG_BIT_ERR:
            if ( *text == 't' || *text == _T('T') || (_ttoi (text) != 0) )
                mCurrentTest->d[2].value = 1;
            else
                mCurrentTest->d[2].value = 0;
            break;
        case RADIOTEST_CFG_UAP_LAP:
            {
                TCHAR * stopped;
                unsigned long ulvalue = ::_tcstoul( text , &stopped , 16 );
                if ( stopped < text + _tcslen (text) )
                {
                    _stprintf ( text , _T("%x") , ( mCurrentTest->d[1].value << 16 ) + mCurrentTest->d[2].value );
                    GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( text );
                }
                else
                {
                    mCurrentTest->d[2].value = (uint16) ( ulvalue & 0xFFFF ) ;
                    mCurrentTest->d[1].value = (uint16) ( ( ulvalue & 0xFFFF0000 ) >> 16 );
                }
            }
            break;
        default:
            if ( mCurrentTest->d[1].type != p )
            {
                if ( !readWord ( text , mCurrentTest->d+1 ) )
                    GetDlgItem(IDC_ARG_VALUE2)->SetWindowText( text );
            }
            else
            {
                if ( !readWord ( text , mCurrentTest->d+1 , text2 ) )
                {
                    GetDlgItem(IDC_ARG_VALUE2_1)->SetWindowText( text );
                    GetDlgItem(IDC_ARG_VALUE2_2)->SetWindowText( text2 );
                }
            }
        }

    }
}



void CBlueTestDlg::OnChangeArgValue3() 
{
    const int size = 20;
    TCHAR text[size];
    int realSize = GetDlgItem(IDC_ARG_VALUE3)->GetWindowText( text , size );

    if ( mCurrentTest->test != RADIOTEST_CFG_BIT_ERR )
    {

        if ( realSize != 0 )
            if ( !readWord ( text , mCurrentTest->d+2 ) )
                GetDlgItem(IDC_ARG_VALUE3)->SetWindowText( text );
    }
}




void CBlueTestDlg::OnChangeArgValue4() 
{
    const int size = 20;
    TCHAR text[size];
    int realSize = GetDlgItem(IDC_ARG_VALUE4)->GetWindowText( text , size );
    if ( mCurrentTest->test != RADIOTEST_CFG_BIT_ERR )
    {
        if ( realSize != 0 )
            if ( !readWord ( text , mCurrentTest->d+3 ) )

                GetDlgItem(IDC_ARG_VALUE4)->SetWindowText( text );
    }
}

void CBlueTestDlg::OnChangeFilename() 
{
    organiseFile();
}

void CBlueTestDlg::OnSave() 
{
    organiseFile();
}


void CBlueTestDlg::organiseFile()
{
    CButton * saveButton = (CButton*)(g_pDbgDlg->GetDlgItem ( IDC_SAVE ));
    CEdit * fileEditBox  = (CEdit*)  (g_pDbgDlg->GetDlgItem ( IDC_FILENAME ));


    bool openANewFile = false , closeTheOldFile = false;

    //  0 is unchecked, 1 is checked, 2 is don't know...  only 1 counts.
    bool toSave = ( saveButton->GetCheck() == 1 );
	debugfileon = ( saveButton->GetCheck() == 1 );
    //  Get the filename
    CString fileName ;
    fileEditBox->GetWindowText( fileName );
    fileEditBox->GetWindowText( debugfilename );

    if ( pOutFile == NULL )
    {
        //  We don't have a file open.
        if ( toSave == true )
        {
            //  and we want one.
            if ( fileName.IsEmpty() )
            {
                //  but there's no file name so we can't
            }
            else
            {
                openANewFile = true;
            }
        }
        else
        {
            //  and we don't want one.
            //  do nothing.
        }
    }
    else
    {
        //  So we have a file open at the moment
        if ( toSave == true )
        {
            //  and we want one open
            if ( fileName.IsEmpty() )
            {
                //  but the file name is blank.
                //  so stop it.
                closeTheOldFile = true;
            }
            else
            {
                //  what is the filename of the currently open file?
                if ( fileName == pOutFile->GetFilePath() )
                {
                    //  same file, so do nothing.
                }
                else
                {
                    //  change the file.
                    closeTheOldFile = true;
                    openANewFile = true;
               }
            }
        }
        else
        {
            //  but we don't want one open
            closeTheOldFile = true;
        }
    }

	CStdioFile * lNewFile = NULL;
	CStdioFile * lOldFile = pOutFile;

    if ( openANewFile == true )
    {
        lNewFile = new CStdioFile;
        if ( !lNewFile->Open( fileName , CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite ) )
       {
            //  failed to open the file.
            this->MessageBox( _T("Could not open File"),_T("File Error"),MB_ICONERROR );
            delete lNewFile;
            lNewFile = NULL;
        }
    }

    if ( openANewFile || closeTheOldFile )
    {
        ::EnterCriticalSection ( &protectFile );
        pOutFile = lNewFile;
        ::LeaveCriticalSection ( &protectFile );
    }

    if ( closeTheOldFile == true )
    {
        lOldFile->Flush();
        delete lOldFile;
    }

////	(void) ::PostMessage(HWND_BROADCAST, UDM_DEBUG_FILE, NULL, NULL); // bad Adam

}





void CBlueTestDlg::OnClose() 
{
    cleanUpMemory();
    CDialog::OnClose();
}

void CBlueTestDlg::OnOK() 
{
    cleanUpMemory();
    CDialog::OnOK();
}

void CBlueTestDlg::cleanUpMemory()
{
    //  memory management.
    delete this->mEngine;
    delete this->pOutFile;
    ::DeleteCriticalSection ( &protectFile );
    ::DeleteCriticalSection ( &protectOutputStringList );
}

void CBlueTestDlg::OnVerbose() 
{
    setState ( true );
}

void CBlueTestDlg::OnConcise() 
{
    setState ( false );
}

void CBlueTestDlg::OnPs() 
{
    CPSSetDlg psdlg;
    psdlg.setEngine ( mEngine );
    psdlg.DoModal();
}
#ifdef _WINCE

uint32 CBlueTestDlg::strtoulreplacement(char *chinptr, char ** chstopptr, int base)
{

/* convert the string to a long until the character can not be converted - in which case 
   set the csstopptr to the location of non convertable character */

	uint32 uitmp = 0;
	uint32 uitmp2 = 0;
	int isnegative = 0;
	char chin;

	/* remove any white space */
	chin = *chinptr;

	while (((chin > 0x09) && (chin < 0x0d)) || (chin == 0x20))
	{
		chinptr++;
		chin = *chinptr;
	}

	if (*chinptr++ == '-')	/* we would need to return a signed int32 for this */
		isnegative = 1;
	else
		chinptr--;

	if (base == 0) /* try to decipher ?*/
	{
		if (!(strncmp(chinptr,"0x",2)) || !(strncmp(chinptr,"0X",2)))
		{
			base = 16;
			chinptr+=2;
		}
		else if (!(strncmp(chinptr,"0",1)))
		{
			base = 8;
			chinptr+=1;
		}
		else
			base = 10;
	}





	*chstopptr = chinptr;
	switch (base)	/* only supports 16,2,8,10 */
	{
	case 16:

		while (isvalidhex(*chinptr)) /* ok to carry on */
		{
			uitmp <<=4;
			if ((*chinptr >= '0') && (*chinptr <= '9'))
			{
				uitmp |= ((*chinptr) - '0');
			}
			else
			if ((*chinptr >= 'A') && (*chinptr <= 'F'))
			{
				uitmp |= (((*chinptr) - 'A') + 10);
			}
			else if ((*chinptr >= 'a') && (*chinptr <= 'f'))
			{
				uitmp |= (((*chinptr) - 'a') + 10);
			}
			chinptr++;
		}
		break;

	case 10:
		while (isvaliddec(*chinptr)) /* ok to carry on */
		{
			uitmp *= 10;
			uitmp += ((*chinptr) - '0');
			chinptr++;
		}

		break;



	case 8:
		while (isvalidoct(*chinptr)) /* ok to carry on */
		{
			uitmp <<=3;

			uitmp |= ((*chinptr) - '0');


			chinptr++;
		}
		break;
	case 2:
		while (isvalidbin(*chinptr)) /* ok to carry on */
		{
			uitmp <<=1;

			uitmp |= ((*chinptr) - '0');


			chinptr++;
		}
		break;

	default:
		printf("invalid base\n\r");



	}

	*chstopptr = chinptr;					
	uitmp2 = uitmp;
	if (isnegative == 1)
	{
		uitmp -= uitmp2;
		uitmp -= uitmp2;
	}


	return uitmp;
}
int CBlueTestDlg::isvalidhex(char chin)
{
	if ((chin >= '0') && (chin <= '9'))
		return TRUE;
	if (((chin >= 'a') && (chin <= 'f'))  || ((chin >= 'A') && (chin <= 'F')))
		return TRUE;
	else
		return FALSE;
}


int CBlueTestDlg::isvalidoct(char chin)
{
	if ((chin >= '0') && (chin <= '7'))
		return TRUE;
	else
		return FALSE;
}



int CBlueTestDlg::isvalidbin(char chin)
{
	if ((chin >= '0') && (chin <= '1'))
		return TRUE;
	else
		return FALSE;
}
int CBlueTestDlg::isvaliddec(char chin)
{
	if ((chin >= '0') && (chin <= '9'))
		return TRUE;
	else
		return FALSE;
}
#endif
/////////////////////////////////////////////////////////////////////////////
// CBluetestDlg dialog

//CBluetestDlg::CBluetestDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CBluetestDlg::IDD, pParent)
//{
	//{{AFX_DATA_INIT(CBluetestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
//	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
//}

//void CBluetestDlg::DoDataExchange(CDataExchange* pDX)
//{
//	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBluetestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
//}

//BEGIN_MESSAGE_MAP(CBluetestDlg, CDialog)
	//{{AFX_MSG_MAP(CBluetestDlg)
	//}}AFX_MSG_MAP
//END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBluetestDlg message handlers

//BOOL CBluetestDlg::OnInitDialog()
//{
//	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
//	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
//	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
//	return TRUE;  // return TRUE  unless you set the focus to a control
//}


void CBlueTestDlg::OnDebugfile() 
{
	// TODO: Add your control notification handler code here
	g_pDbgDlg = new CDebugFile(this);
	if(g_pDbgDlg->DoModal() == IDOK)
	{

	}
	delete g_pDbgDlg;
	g_pDbgDlg=NULL;	
}

void CBlueTestDlg::OnAboutcsr() 
{
	g_pAboutBox = new CAboutDlg();
	if(g_pAboutBox->DoModal() == IDOK)
	{

	}
	delete g_pAboutBox;
	g_pAboutBox=NULL;
}

