// BlueTestDlg.h : header file
//

#if !defined(AFX_BLUETESTDLG_H__EAD94C08_6C71_4E36_BC79_98ECEF23FB80__INCLUDED_)
#define AFX_BLUETESTDLG_H__EAD94C08_6C71_4E36_BC79_98ECEF23FB80__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "console.h"
#include "bccmd/bccmdpdu.h"
#include "CBluetestEngine.h"


#define UDM_DEBUG_FILE							(WM_USER + 2)

//  Pause zero, and then 1 thru 34, and then 2 pio line commands,
//  1 provoke fault, 1 dummy and 1 read frimware version.
#define TEST_COUNT (RADIOTEST_LAST_COMMAND + 6)

/////////////////////////////////////////////////////////////////////////////
// CBluetestDlg dialog

enum eDataType
{
    z, //  nothing
    b, // boolean
    bin, // 8 bit binary
    x, // hex
    u, // uint16
    s, // int16
    f, //  fancy... input in MHz, convert that float into uint16, where 1 -> 0x1000
    p  //  power level...  two uint8s packed into uint16.  Only work in position 2 at the moment.
};

typedef struct
{
    char * name;
    uint16 value;
    eDataType type;
}
CTestParameterInfo;

typedef struct
{
    uint16 test;
    uint8 parameterCount;
    CTestParameterInfo d[TEST_SIZE];
}
CTestParams;

#define BLUETEST_MESSAGE_OUTPUT_STRING (WM_USER + 1)

typedef struct _COutputStringQueueEntry
{
    struct _COutputStringQueueEntry * next ;
    bool verboseNotConcise ;
    TCHAR * string ;
}
COutputStringQueueEntry;







/////////////////////////////////////////////////////////////////////////////
// CBlueTestDlg dialog

class CBlueTestDlg : public CDialog
{
// Construction
public:
	CBlueTestDlg(CWnd* pParent = NULL);	// standard constructor
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////
        void setFactory ( BlueCoreControllerFactory * factory );
        static void acceptOutputString ( bool verboseNotConcise , TCHAR * aString , void * aThis );
        void outputString ( bool verboseNotConcise , TCHAR * aString );
        void queueOutputString ( bool verboseNotConcise , TCHAR * aString );
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////
		void BoxDone();
		CString debugfilename;
		bool debugfileon;
// Dialog Data
	//{{AFX_DATA(CBlueTestDlg)
	enum { IDD = IDD_BLUETEST_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBlueTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
//	DDX_Text(pDX, IDC_FILENAME, m_strFilename);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code starts here
///////////////////////////////////////////////////////////////////////////////
        Console sMessageWindow;
        Console sConciseMessageWindow;
        bool mVerboseNotConcise;
        COutputStringQueueEntry * OutputStringListHead ;
        COutputStringQueueEntry * OutputStringListTail ;
        CRITICAL_SECTION protectOutputStringList ;

        CBluetestEngine * mEngine;
        BlueCoreControllerFactory * mFactory;

        void initState ();
        void initTestParams();

        void setState ( CTestParams * aTest );
        void setState ( bool verboseNotConcise );
        void fillWord ( TCHAR * aWord , CTestParameterInfo * data , TCHAR * aWord2 = 0 );

        bool readWord ( TCHAR * aWord , CTestParameterInfo * data , TCHAR * aWord2 = 0 );

        CTestParams * mCurrentTest;
        CTestParams mTestParameters [ TEST_COUNT ] ;

        void organiseFile ( void );
        CStdioFile * pOutFile;
		CRITICAL_SECTION protectFile;

        void cleanUpMemory();
///////////////////////////////////////////////////////////////////////////////
//      Hand crafted code ends here
///////////////////////////////////////////////////////////////////////////////
	// Generated message map functions
	//{{AFX_MSG(CBlueTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSendcommand();
	afx_msg void OnColdreset();
	afx_msg void OnSelchangeCommands();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnChangeArgValue();
	afx_msg void OnChangeArgValue2();
	afx_msg void OnChangeArgValue3();
	afx_msg void OnChangeArgValue4();
	afx_msg void OnChangeFilename();
	afx_msg void OnPs();
	afx_msg void OnSave();
	afx_msg void OnClose();
	virtual void OnOK();
	afx_msg void OnVerbose();
	afx_msg void OnConcise();
	afx_msg void OnDebugfile();
	afx_msg void OnAboutcsr();
	//}}AFX_MSG
        afx_msg void OnOutputString (WPARAM dummy, LPARAM ldummy);
        afx_msg void GettheDebugFile (WPARAM dummy, LPARAM ldummy);
	DECLARE_MESSAGE_MAP()
#ifdef _WINCE
private:
	uint32 strtoulreplacement(char *,char**, int);
	int isvaliddec(char);
	int isvalidbin(char);
	int isvalidoct(char);
	int isvalidhex(char);
#endif

};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLUETESTDLG_H__EAD94C08_6C71_4E36_BC79_98ECEF23FB80__INCLUDED_)
