// PSSetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "bluetest.h"
#include "PSSetDlg.h"
#include "bccmd/bccmdpdu.h"
#include "unicode/ichar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPSSetDlg dialog


CPSSetDlg::CPSSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPSSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPSSetDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    mLength = 0;
    Carls_code_works = false;
}


void CPSSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPSSetDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPSSetDlg, CDialog)
	//{{AFX_MSG_MAP(CPSSetDlg)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_CHANGE, OnChange)
	ON_CBN_EDITUPDATE(IDC_PSKEY, OnEditupdatePskey)
	ON_WM_CLOSE()
	ON_EN_CHANGE(IDC_PSLEN, OnChangePslen)
	ON_EN_CHANGE(IDC_PSVALUE, OnChangePsvalue)
	//}}AFX_MSG_MAP
        ON_MESSAGE ( BLUETEST_PSSET_RESPONSE , bccmdWaiting )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSSetDlg message handlers

void CPSSetDlg::OnRead() 
{
    bool ok = true;

    ok = readValue ();

    if (ok)
    {
        if ( Carls_code_works )
        {
            int size = 1 + 3 + 1;
            PARAMETER_ARRAY req = new PARAMETER_VALUE[size];
            req[0] = size;
            req[1] = BCCMDPDU_GETREQ;
            req[2] = mEngine->nextSequence();
            req[3] = BCCMDVARID_PSSIZE;
            req[4] = mKey;

            ok = mEngine->sendChipMgtHostToChip ( req );

            delete req;

            if ( !ok )
                MessageBox ( II("Failed to request size if PS.") , II("Error") , MB_ICONERROR );
        }
        else
            readPS();
    }
}

void CPSSetDlg::readPS()
{
    if (mLength == 0 )
        return ;

    bool ok = true;

    if ( ok )
    {
        int size = 1 + 3 + 3 + mLength;
        PARAMETER_ARRAY req = new PARAMETER_VALUE [ size ];
        memset ( req , 0 , sizeof(PARAMETER_VALUE ) * size );

        req[0] = size;
        req[1] = BCCMDPDU_GETREQ;
        req[2] = mEngine->nextSequence();
        req[3] = BCCMDVARID_PS;
        req[4] = mKey;
        req[5] = mLength;
        req[6] = PS_STORES_IFR;
        ok = mEngine->sendChipMgtHostToChip ( req );

        delete[] req;
    }

    if ( !ok )
        MessageBox ( II("Failed to request read from PS.") , II("Error") , MB_ICONERROR );
}

void CPSSetDlg::OnChange() 
{
    bool ok = haveReadValue;
    //  Just make sure we are dealing with a real key here.

    if ( ok )
    {
        int size = 1 + 3 + 3 + mLength;
        PARAMETER_ARRAY req = new PARAMETER_VALUE [ size ];
        req[0] = size;
        req[1] = BCCMDPDU_SETREQ;
        req[2] = mEngine->nextSequence();
        req[3] = BCCMDVARID_PS;
        req[4] = mKey;
        req[5] = mLength;
        req[6] = PS_STORES_IFR;

        //  Strip the values from the buffer
        ichar * textvalue = new ichar [1024];
        GetDlgItem ( IDC_PSVALUE )->GetWindowText ( textvalue , 1024 );
        ichar * stopped = textvalue;

        ichar * readHere;
        unsigned long ulvalue;
        for ( int counter = 7 ; counter < size ; counter ++ )
        {
            readHere = stopped;
            ulvalue = ::istrtoul( readHere , &stopped , 16 );
            if ( readHere == stopped )
            {
                if ( mKey == /* PSKEY_USB_PIO_PULLUP */ 0x02D0 )
                {
                    //  Set the length of the key to be zero.
                    req[5] = 0;
                    req[7] = 0;
                    GetDlgItem ( IDC_PSVALUE )->SetWindowText ( II("MISSING") );
                }
                else
                {
                    MessageBox ( II("Can't read enough data from Value box.") , II("Error") , MB_ICONERROR );
                    ok = false;
                    break;
                }
            }
            else
            {
                req[counter] = (uint16) ulvalue;
            }
        }

        if ( ok )
            ok = mEngine->sendChipMgtHostToChip ( req );
        delete req;
    }

    if ( !ok )
        MessageBox ( II("Failed to request change in PS.") , II("Error") , MB_ICONERROR );
}

bool CPSSetDlg::readValue ()
{
    bool ok = true;

    ichar * text = new ichar [20];
    //  get the key
    GetDlgItem ( IDC_PSKEY )->GetWindowText ( text , 20 );
    ichar * stopped = text;
    unsigned long ulvaluekey = ::istrtoul( text , &stopped , 16 );

    if ( stopped == text )
        ok = false;

    delete text;

    if ( ok )
    {
        mKey = (uint16) ulvaluekey;
    }

    return ok;
}

void CPSSetDlg::setEngine( CBluetestEngine * aEngine)
{
   mEngine = aEngine;
   mEngine->setPSSetFunction ( onBCCMDResponse , this );
}

void CPSSetDlg::refreshState()
{
    GetDlgItem(IDC_PSVALUE)->EnableWindow (haveReadValue);
    GetDlgItem(IDC_CHANGE)->EnableWindow (haveReadValue);
    ( (CEdit *) GetDlgItem(IDC_PSLEN) )->SetReadOnly (true);
    if ( mLength != 0 )
    {
        ichar text[10];
        isprintf ( text , II("%04x") , mLength );
        GetDlgItem(IDC_PSLEN)->SetWindowText (text);
    }
    else
        GetDlgItem(IDC_PSLEN)->SetWindowText (II(""));
}

void CPSSetDlg::onBCCMDResponse ( PARAMETER_ARRAY aAnswer , void * aObject)
{
    //  Should implement a queue and set message here.
    ((CPSSetDlg *)aObject)->processBCCMDResponse ( aAnswer );
}

void CPSSetDlg::processBCCMDResponse ( PARAMETER_ARRAY aAnswer )
{
    //  Sanity check (6 is the minimum size of the aAnswer).
    if ( aAnswer != NULL && aAnswer[0] >= 6 )
    {
        switch (aAnswer[1])
        {
        case BCCMDVARID_PS:
            switch ( aAnswer[3] )
            {
            case BCCMDPDU_STAT_OK:
                {
                    //  change the GUI state
                    haveReadValue = true;
                    refreshState();

                    //  Add the retrieved PSkey to the ComboBox
                    ichar * key = new ichar[5];
                    isprintf ( key , II("%04x") , aAnswer[4] );
                    CComboBox * keyList = (CComboBox*) GetDlgItem (IDC_PSKEY);

                    //  If the string isn't in the box already
                    if ( keyList->FindStringExact ( -1 , key ) == CB_ERR )
                    {
                        //  Add it
                        keyList->AddString ( key );
                    }
                    delete key;

                    //  Display the right values in the Length and Value Boxes.
                    mLength = (uint16) aAnswer[5];
                    ichar * length = new ichar[5];
                    isprintf ( length , II("%04x") , mLength );
                    GetDlgItem (IDC_PSLEN) -> SetWindowText ( length );
                    delete length;

                    if ( aAnswer[4] == /* PSKEY_LC_POWER_TABLE */ 0x001E )
                        ( ( CEdit * ) GetDlgItem (IDC_PSLEN) ) -> SetReadOnly ( false );
                    else
                        ( ( CEdit * ) GetDlgItem (IDC_PSLEN) ) -> SetReadOnly ( true );

                    //  values start at 7.
                    ichar * value;
                    if ( mLength == 0 )
                    {
                        value = new ichar[8];
                        memcpy ( value , II("MISSING") , 8 );
                    }
                    else
                    {
                        PARAMETER_VALUE * lValue = aAnswer + 7;
                        value = new ichar[ mLength * 5 + 1 ];
                        for ( int counter = 0 ; counter < mLength ; counter ++ )
                        {
                            isprintf ( value+(5*counter) , II("%04x ") , lValue[counter] );
                        }
                    }
                    GetDlgItem (IDC_PSVALUE) -> SetWindowText ( value );
                    delete value;
                }
                break;
            case BCCMDPDU_STAT_PERMISSION_DENIED:
                MessageBox ( II("Permission denied.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_NO_SUCH_VARID:
                MessageBox ( II("No such VARID.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_ERROR:
                if ( aAnswer[4] == /* PSKEY_USB_PIO_PULLUP */ 0x02D0 )
                {
                    //  change the GUI state
                    haveReadValue = true;
                    refreshState();

                    //  Add the retrieved PSkey to the ComboBox
                    ichar * key = new ichar[5];
                    isprintf ( key , II("%04x") , aAnswer[4] );
                    CComboBox * keyList = (CComboBox*) GetDlgItem (IDC_PSKEY);

                    //  If the string isn't in the box already
                    if ( keyList->FindStringExact ( -1 , key ) == CB_ERR )
                    {
                        //  Add it
                        keyList->AddString ( key );
                    }
                    delete key;

                    //  Display the right values in the Length and Value Boxes.
                    mLength = 1;
                    ichar * length = new ichar[5];
                    isprintf ( length , II("%04x") , mLength );
                    GetDlgItem (IDC_PSLEN) -> SetWindowText ( length );
                    delete length;

                    ( ( CEdit * ) GetDlgItem (IDC_PSLEN) ) -> SetReadOnly ( true );

                    //  values start at 5.
                    ichar value[] = II("MISSING");
                    GetDlgItem (IDC_PSVALUE) -> SetWindowText ( value );
                }
                else
                    MessageBox ( II("Chip Management (Host to Chip) Error.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_WRITE_ONLY:
                MessageBox ( II("Write Only Error.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_READ_ONLY:
                MessageBox ( II("Read Only Error.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_TOO_BIG:
                MessageBox ( II("Too Much Data In PS.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_NO_VALUE:
                MessageBox ( II("No Value.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_BAD_PDU:
                MessageBox ( II("Malformed PDU.") , II("Error") , MB_ICONERROR );
                break;
            case BCCMDPDU_STAT_NO_ACCESS:
                MessageBox ( II("No Access.\nUnknown PS key or attempted Security Breach.") , II("Error") , MB_ICONERROR );
                break;
            default:
                MessageBox ( II("Unknown BCCMD Error.") , II("Meta-error") , MB_ICONERROR );
                break;
            }
            break;
        case BCCMDVARID_PSSIZE:
            if ( aAnswer[3] == BCCMDPDU_STAT_OK )
            {
                mLength = (uint16)aAnswer[4];
                readPS ();
            }
            break;
        default:
            break;
        }
    }
}

void CPSSetDlg::OnEditupdatePskey() 
{
    haveReadValue = false;
    if ( Carls_code_works )
        mLength = 0;
    else
        mLength = 54;
    mKey = 0;
    refreshState();
}

BOOL CPSSetDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();

    haveReadValue = false;
    refreshState();
    
    return TRUE;  // return TRUE unless you set the focus to a control
	          // EXCEPTION: OCX Property Pages should return FALSE
}

void CPSSetDlg::queueBCCMD ( PARAMETER_ARRAY aResponse )
{
    bccmdListEntry * entry = new bccmdListEntry;

    entry->next = NULL;
    entry->response = aResponse;

    ::EnterCriticalSection ( &protectBCCMDList );

    if ( bccmdListHead == NULL )
    {
        bccmdListHead = entry;
        bccmdListTail = entry;
    }
    else
    {
        bccmdListTail->next = entry;
        bccmdListTail = entry;
    }

    ::LeaveCriticalSection ( &protectBCCMDList );
    PostMessage ( BLUETEST_PSSET_RESPONSE );
}

void CPSSetDlg::bccmdWaiting (WPARAM dummy, LPARAM ldummy)
{
    ::EnterCriticalSection ( &protectBCCMDList );

    while ( bccmdListHead != NULL )
    {
        //  unhitch the first message;
        bccmdListEntry * tbd = bccmdListHead;
        bccmdListHead = bccmdListHead->next;
        this->processBCCMDResponse ( tbd->response );
        delete tbd;
    }
 
    ::LeaveCriticalSection ( &protectBCCMDList );
}

void CPSSetDlg::OnClose() 
{
    mEngine->setPSSetFunction ( NULL , NULL );
    CDialog::OnClose();
}

void CPSSetDlg::OnChangePslen() 
{
    if ( mKey == 0x001E )
    {
        ichar text [10];
        GetDlgItem ( IDC_PSLEN ) -> GetWindowText ( text , 10 );
        ichar * stopped;
        int sLength = istrtoul (text , &stopped , 16 );
        //  if it is zero make it odd.
        if (sLength == 0 )
            sLength ++;
        //  if it is odd, add one. (so infact 0 -> 2)
        if ( sLength & 1 )
        {
            sLength ++;
            isprintf ( text , II("%u") , sLength );
            GetDlgItem ( IDC_PSLEN ) -> SetWindowText ( text );
        }
        mLength = sLength;
    }
}

void CPSSetDlg::OnChangePsvalue() 
{
    if ( mKey == 0x2D0 )
    {
        ichar text[] = II("1");
        mLength = 1;
        GetDlgItem ( IDC_PSLEN ) -> SetWindowText ( text );
    }
}
