///////////////////////////////////////////////////////////////////////
//
//  FILE   :  initialValues.h
//
//  AUTHOR :  Adam Hughes
//
//  PURPOSE:  Contains the initialisation values for the tests
//            as displayed in the GUI.
//
///////////////////////////////////////////////////////////////////////

#ifndef __BLUETEST_INITIAL_VALUES_H__
#define __BLUETEST_INITIAL_VALUES_H__

CTestParams initialTestParams[TEST_COUNT] =
{
    //  Pause Testing (0)
    { RADIOTEST_PAUSE , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  TXSTART (1)
    { 
        RADIOTEST_TXSTART ,
        3 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { "Modulat'n Freq." , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  RXSTART1 (2)
    {
        RADIOTEST_RXSTART1 ,
        3 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  RXSTART2 (3)
    {
        RADIOTEST_RXSTART2 ,
        3 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  TXDATA1	(4)
    {
        RADIOTEST_TXDATA1,
        2,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  TXDATA2	(5)
    {
        RADIOTEST_TXDATA2 ,
        2,
        {
            { "Country Code" , 0 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  TXDATA3	(6)
    {
        RADIOTEST_TXDATA3 ,
        2 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  TXDATA4	(7)
    {
        RADIOTEST_TXDATA4 ,
        2,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  RXDATA1	(8)
    {
        RADIOTEST_RXDATA1 ,
        3 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  RXDATA2	(9)
    {
        RADIOTEST_RXDATA2 ,
        3 ,
        {
            { "Country Code" , 0 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  DEEP_SLEEP	(10)
    { RADIOTEST_DEEP_SLEEP , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  PCM_LB	(11)
    {
        RADIOTEST_PCM_LB ,
        1 ,
        {
            { "PCM Mode" , 1 , u } ,
            { 0 , 0 , z } ,
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  SETTLE	(12)
    {
        RADIOTEST_SETTLE ,
        2 ,
        {
            { "Start Channel" , 0 , u } ,
            { "Finish Channel" , 78 , u } ,
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  IF_RESP	(13)
    {
        RADIOTEST_IF_RESP ,
        3 ,
        {
            { "No. of Samples" , 10 , u } ,
            { "Start (MHz)" , 0x0004 , f } ,  //  0x1000 = 1MHz
            { "Finish (MHz)" , 0x3000 , f } ,
            { 0 , 0 , z }
        }
    },
    //  VCOTRIM	(14)
    {
        RADIOTEST_VCOTRIM ,
        1 ,
        {
            { "Country Code" , 0 , u } ,
            { 0 , 0 , z } ,
            { 0 , 0 , z } ,
            { 0 , 0 , z }
        }
    },
    //  RF_IQ_MATCH	(15)
    { RADIOTEST_RF_IQ_MATCH , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  IF_IQ_MATCH	(16)
    { RADIOTEST_IF_IQ_MATCH , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  BUILD_LUT	(17)
    { RADIOTEST_BUILD_LUT , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  READ_LUT	(18)
    { RADIOTEST_READ_LUT , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  BER1		(19)
    {
        RADIOTEST_BER1 ,
        3 ,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  BER2		(20)
    {
        RADIOTEST_BER2 ,
        3 ,
        {
            { "Country Code" , 0 , u } ,
            { "hi-side" , 0 , b } , 
            { "RX Attenuation" , 0 , u } ,
            { 0 , 0 , z }
        }
    },
    //  LOOP_BACK	(21)
    {
        RADIOTEST_LOOP_BACK ,
        2,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CFG_FREQ	(22)
    {
        RADIOTEST_CFG_FREQ ,
        3 ,
        {
            { "TX/RX Int (us)" , 1250 , u } ,
            { "Loopback (us)" , 1875 , u } , 
            { "Report Int (s)" , 1 , u } ,
            { 0 , 0 , z }
        }
    },
    //  CFG_PKT	(23)
    {
        RADIOTEST_CFG_PKT ,
        2,
        {
            { "Packet Type" , 4 , u } ,
            { "Packet Size" , 27 , u } , 
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CFG_BIT_ERR	(24)
    {
        RADIOTEST_CFG_BIT_ERR ,
        3 ,
        {
            { "upper word of unit32" , 0x18 , u } ,
            { "lower owrd of uint32" , 0x6a00 , u } , //  1600000 = 0x186a00, split between two words...
            { "bool reset" , 0 , b } ,
            { 0 , 0 , z }
        }
    },
    //  RX_LOOP_BACK  (25)
    {
        RADIOTEST_RX_LOOP_BACK ,
        2,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  BER_LOOP_BACK (26)
    {
        RADIOTEST_BER_LOOP_BACK ,
        2,
        {
            { "LO Freq. (MHz)" , 2432 , u } ,
            { "Power (Ext,Int)" , 0xFF32 , p } , 
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CONFIG_TX_IF  (27)
    {
        RADIOTEST_CONFIG_TX_IF ,
        1 ,
        {
            { "IF Offset" , 0 , u } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  PCM_EXT_LOOP_BACK (28)
    {
        RADIOTEST_PCM_EXT_LB ,
        1 ,
        {
            { "PCM Mode" , 1 , u } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  XTAL_TRIM (29)
    {
        RADIOTEST_CFG_XTAL_FTRIM ,
        1 ,
        {
            { "Crystal Trim (hex)" , 0x20 , x } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CFG_UAP_LAP (30)
    {
        RADIOTEST_CFG_UAP_LAP ,
        3 ,
        {
            { "uint16 UAP" , 0x6b , x } ,
            { "upper word of unit32 LAP" , 0xc6 , x } ,
            { "lower owrd of uint32 LAP" , 0x967e , x } ,
            { 0 , 0 , z }
        }
    },
    //  CFG_ACC_ERRS (31)
    {
        RADIOTEST_CFG_ACC_ERRS ,
        1 ,
        {
            { "# of Errors" , 10 , u } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CFG_IQ_TRIM (32)
    {
        RADIOTEST_CFG_IQ_TRIM ,
        1 ,
        {
            { "IQ Trim (hex)" , 0x149 , x } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  CFG_TX_TRIM (33)
    {
        RADIOTEST_CFG_TX_TRIM,
        1,
        {
            {"Trim (0-7)" , 7 , u },
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  RADIO_STATUS (34)
    { RADIOTEST_RADIO_STATUS ,0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  Set PIO (35)
    {
        NOT_RADIOTEST_SET_PIO ,
        2,
        {
            { "Mask (binary)" , 0xFF , bin } ,
            { "Values (binary)" , 0x0 , bin } , 
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  Read PIO (36)
    { NOT_RADIOTEST_READ_PIO , 0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  Provoke fault (37)
    {
        NOT_RADIOTEST_PROVOKE_FAULT ,
        1,
        {
            { "Fault (hex)" , 0x00 , x } ,
            { 0 , 0 , z },
            { 0 , 0 , z },
            { 0 , 0 , z }
        }
    },
    //  Do Nothing (38)
    { NOT_RADIOTEST_NOTHING ,0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
    //  get firmware version (39)
    { NOT_RADIOTEST_READ_FW_VERSION ,0 ,
    { {0,0,z} , {0,0,z} , {0,0,z} , {0,0,z} } },
};

#endif//__BLUETEST_INITIAL_VALUES_H__
