///////////////////////////////////////////////////////////////////////
//
//  FILE   :  reportStrings.h
//
//  AUTHOR :  Adam Hughes
//
//  TABLE  :  reportStrings
//
//  PURPOSE:  Provide changeable strings interface.
//
///////////////////////////////////////////////////////////////////////

TCHAR * reportStrings[] =
{
    // 0
    _T("Radio Test PAUSE %s"),
    // 1
    _T("Radio Test TXSTART %s"),
    // 2
    _T("Radio Test RXSTART1 %s"),
    // 3
    _T("Radio Test RXSTART2 %s"),
    // 4
    _T("Radio Test TXDATA1 %s"),
    // 5
    _T("Radio Test TXDATA2 %s"),
    // 6
    _T("Radio Test TXDATA3 %s"),
    // 7
    _T("Radio Test TXDATA4 %s"),
    // 8
    _T("Radio Test RXDATA1 %s"),
    // 9
    _T("Radio Test RXDATA2 %s"),
    // 10
    _T("Radio Test Deep Sleep %s"),
    // 11
    _T("Radio Test PCM LB %s"),
    // 12
    _T("Radio Test SETTLE %s"),
    // 13
    _T("Radio Test IF RESP %s"),
    // 14
    _T("Radio Test VCOTRIM %s"),
    // 15
    _T("Radio Test RF IQ MATCH %s"),
    // 16
    _T("Radio Test IF IQ MATCH %s"),
    // 17
    _T("Radio Test BUILD LUT %s"),
    // 18
    _T("Radio Test READ LUT %s"),
    // 19
    _T("Radio Test BIT ERR1 %s"),
    // 20
    _T("Radio Test BIT ERR2 %s"),
    // 21
    _T("Radio Test LOOP BACK %s"),
    // 22
    _T("Radio Test CFG FREQ %s"),
    // 23
    _T("Radio Test CFG PKT %s"),
    // 24
    _T("Radio Test CFG BIT ERR %s"),
    // 25
    _T("Radio Test RX LOOP BACK %s"),
    // 26
    _T("Radio Test BER LOOP BACK %s"),
    // 27
    _T("Radio Test CFG TX IF %s"),
    // 28
    _T("Unrecognised Radio Test %s"),
    // 29
    _T("Unrecognised Chip Management Request: varid %04x."),
    // 30
    _T("Unrecognised Chip Management Response: varid %04x."),
    // 31
    _T("Chip Management Notice: Chip Booted."),
    // 32
    _T("Chip Management Notice: Delayed Panic, %04x."),
    // 33
    _T("RSSI: %u."),
    // 34
    _T("Chip Management Notice: Fault %04x at time %08x, %04x occurences."),
    // 35
    _T("RXPKTSTATS: NP: %u, NGP: %u, NCP: %u, RSSI: %u,%s."),
    // 36
    _T("LUTENTRY[%u] = %x."),
    // 37
    _T("SYNTH SETTLE[%u] = %u."),
    // 38
    _T("FILTER RESP: [%u] = ( %u , %u )."),
    // 39
    _T("IQ MATCH: [%u] = ( %u , %u , %u )."),
    // 40
    _T("%s Period: %8u, Total: %10u."),
    // 41
    _T("Opening %s."),
    // 42
    _T("Failed to open %s."),
    // 43
    _T("Link has failed."),
    // 44
    _T("Timeout waiting for Test Response."),
    // 45
    _T("Building pdu failed."),
    // 46
    _T("Sent Command Varid %04x, parameters: %04x, %04x, %04x, %04x."),
    // 47
    _T("Found BC01."),
    // 48
    _T("Cannot find BC01."),
    // 49
    _T("PIO Mask: %08x"),
    // 50
    _T("PIO Lines: %08x"),
    // 51
    _T("Radio Test CFG UAP/LAP %s"),
    // 52
    _T("Radio Test PCM EXT LB %s"),
    // 53
    _T("Radio Test CFG XTAL FTRIM %s"),
    // 54
    _T("Data for Radio Test %s incoming.  Please see Standard report."),
    // 55
    _T("%% Bit Error for Last Period: %5.3f"),
    // 56
    _T("%% Bit Error in Current Cumulation: %5.3f"),
    // 57
    _T("---------------------------------------"),
    // 58
    _T("Statistics for current cumulation\n")
    _T("%BER             #Bit       #EPkt      #RPkt     #Sync    #Hdr    #CRC    #Uncorr\n"),
    // 59
    _T("%7.4f %12u %10u %10u %10u %10u %10u %10u"),
    // 60
    _T("%7.4f %12u %10u %10u %10u %10u %10u %10u\n"),
    // 61
    _T("Persistent Store Access.  Key %04x.  Access %s."),
    // 62
    _T("Persistent Store Size returned %s."),
    // 63
    _T("Radio Test CFG IQ TRIM %s"),
    // 64
    _T("Radio Test CFG ACC ERRS %s"),
    // 65
    _T("Provoked fault %x, %s."),
    // 66
    _T("Chip Mgt Notice: Fault: %s at time %08x, %04x occurences."),
    // 67
    _T("Radio Test CFG TX TRIM %s"),
    // 68
    _T("BC01 firmware version %u.")
};

TCHAR * BitErrorReportTypes[9] =
{
    // 0
    _T("Bits received                    "),
    // 1
    _T("Bits in error                       "),
    // 2
    _T("Access code bit errors     "),
    // 3
    _T("Packets received             "),
    // 4
    _T("Packets expected            "),
    // 5
    _T("Packets w/ header error  "),
    // 6
    _T("Packets w/ CRC error      "),
    // 7
    _T("Packets w/ uncorr errors "),
    // 8
    _T("Sync timeouts                  ")
};

#define FAULT_COUNT (0x13)

TCHAR * faultString[FAULT_COUNT] =
{
	  _T("No Fault"),                     // = 0x00,	Do not use.
	  _T("Mystery"),                      // = 0x01,	The useless catch-all.
	  _T("No BDADDR"),                    // = 0x02,	No bluetooth address.
	  _T("No country code"),              // = 0x03,	No country code.
	  _T("No class of device"),           // = 0x04,	No class-of-device.
	  _T("Flash full"),                   // = 0x05,	Flash memory has filled.
	  _T("RSM Event"),                    // = 0x06,	radio state machine.
	  _T("in Interupt block"),            // = 0x07,	interrupt blocking fault
      _T("buf_unget() failed."),          // = 0x08,    buf_unget() failure.
      _T("Bad ACL Id"),                   // = 0x09,    Invalid aclid.
      _T("hostio missing HDR"),           // = 0x0a,    Missing hdr in uint PHB.
	  _T("hostio checksum"),              // = 0x0b,	Unexpected checksum err
      _T("hostio internal"),              // = 0x0c,    Internal error in uint.
      _T("hostio bad ack"),               // = 0x0d,    Duff ACK val from host
      _T("hostio link failed"),           // = 0x0e,    Reliable link failure.
      _T("hostio discarded HCI data"),    // = 0x0f,    Reliable link failure.
      _T("hostio convert failure"),       // = 0x10,    r/w format conv failed
	  _T("USB buffer error"),             // = 0x11,    Can't clr frag for tx pkt.
	  _T("Can't calibrate synth")         // = 0x12,	.
//    Handle H4 link sync failure separately
//	  "FAULT_H4_LINK_SYNC_FAILURE",         // = 0x80 	Val def in bc01-s-030.
};