///////////////////////////////////////////////////////////////////////
//
//  FILE   :  LinuxUSBTransport.cpp
//
//            Copyright CSR 2000
//
//  AUTHOR :  Mark Marshall
//
//  CLASS  :  LinuxUSBTransport
//
//  PURPOSE:  transparent class inheriting top API from the
//            HCITransport class, and owning a H4 stack which does
//            all the work.
//
//            This Class also provides BCSP-specific private channels
//            L2CAP etc and puts the debug channel messages to a file
//            in the debug build version.
//
//  MODIFICATION HISTORY:
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Linux/USB/LinuxUSBTransport.cpp#3 $
//
///////////////////////////////////////////////////////////////////////

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <assert.h>

#include "LinuxUSBTransport.h"
#include "LinuxUSB.h"

LinuxUSBTransport::LinuxUSBTransport(const ichar *comPort)
{
    mName = II("LinuxUSBTransport");
    creationInit(comPort);
}

PosixH4Base *LinuxUSBTransport::MakeStack()
{
    return new LinuxUSB;
}
