///////////////////////////////////////////////////////////////////////
//
//  FILE   :  LinuxUSBTransport.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Mark Marshall
//
//  CLASS  :  LinuxUSBTransport
//
//  PURPOSE:  transparent class inheriting top API from the
//            BlueCoreTransport class, and owning a H4Stack which does
//            all the work.
//
//            BlueCoreTransport also provides BCSP-specific private channels
//            L2CAP etc which are tunneled through HCI vendor specific
//            commands and puts the debug channel messages to a file
//            in the debug build version.
//
//  MODIFICATION HISTORY:
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Linux/USB/LinuxUSBTransport.h#2 $
//
///////////////////////////////////////////////////////////////////////

#ifndef LINUXUSBTRANSPORT_H__
#define LINUXUSBTRANSPORT_H__

#include "PosixH4Transport.h"

class DEVICECONTROLLER_API_CLASS LinuxUSBTransport
    : public PosixH4TransportBase
{
 public:
    LinuxUSBTransport(const ichar* comPort);
    
 private:
    virtual PosixH4Base *MakeStack();
};

#endif // LINUXUSBTRANSPORT_H__
