#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include "criticalSectionFunctions.h"

void *InitialiseCS()
{
    pthread_mutex_t *section = (pthread_mutex_t *) malloc (sizeof (pthread_mutex_t));
    if (pthread_mutex_init (section, NULL) != 0)
    {
      fprintf (stderr, "Failed to init CS!\n");
      exit (1);
    }
    return section;
}

void EnterCS(void *section)
{
    if (pthread_mutex_lock ((pthread_mutex_t *) section) != 0)
    {
      fprintf (stderr, "Failed to enter CS!\n");
      exit (1);
    }
}

void LeaveCS(void *section)
{
    if (pthread_mutex_unlock ((pthread_mutex_t *) section) != 0)
    {
      fprintf (stderr, "Failed to leave CS!\n");
      exit (1);
    }
}

void DestroyCS(void *section)
{
    if (pthread_mutex_destroy ((pthread_mutex_t *) section) != 0)
    {
      fprintf (stderr, "Failed to destroy CS!\n");
      exit (1);
    }
    free (section);
}
