///////////////////////////////////////////////////////////////////////
//
//  FILE   :  signalFunctions.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  PURPOSE:  Provide "wait until we get something to do"
//            platform specific functions, wrapped to be general.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Posix/signalFunctions.h#3 $
//
// MODIFICATION HISTORY
//  1.2  13:feb:02  pws      Added S_TIMEOUT return value.
///////////////////////////////////////////////////////////////////////

#ifndef __SIGNALFUNCTIONS_H__
#define __SIGNALFUNCTIONS_H__

#include "common/types.h"

//  Create
void * createSignal();
//  Destroy
void killSignal ( void * Signal );
//  Set
void setSignal ( void * Signal );
//  Unset
void unsetSignal ( void * Signal );

//  Definethe return values for waitOnSignal.
#define S_SIGNALLED  (0)
//  Useless at the moment, but we can extend later.
#define S_ERROR      (1)
// I've just added this... see if it works...
#define S_TIMEOUT    (2)

uint8 waitOnSignal ( void * Signal, unsigned int milliseconds = 0 );

#endif //__SIGNALFUNCTIONS_H__
