@REM ****************************************************************************
@REM NAME
@REM 	result.bat  -  copy output files to the "result" directory
@REM 
@REM DESCRIPTION
@REM	Copy the output files for this project to the "result" directory. This
@REM	batch file should be called with two parameters:
@REM		result <outdir> <resultdir>
@REM
@REM	<outdir> is the Visual Studio output directory, i.e. $(OutDir).
@REM
@REM	<resultdir> is the corresponding sub-directory under "result", usually
@REM	either "debug" or "release".
@REM 
@REM MODIFICATION HISTORY
@REM 	1.1	23:mar:01	at	Created.
@REM 	1.2	28:mar:01	ckl	Added generic HCI headers.
@REM	1.3	04:apr:01	at	Intermediate directories created to
@REM						work on Windows 98.
@REM	1.4	17:apr:01	at	Removed copy of envdefs.h.
@REM	1.3 25:oct:02	doc added copy to MakeDFUCab directory
@REM	1.4 06:dec:02	doc removed copy to MakeDFUCab directory
@REM	1.5 06:dec:02	doc removed copy to MakeDFUCab directory
@REM 
@REM CVS IDENTIFIER
@REM 	$Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Win32/DeviceDriver/DeviceController/resultCE.bat#6 $
@REM 	
@REM ****************************************************************************

@REM Path to the root of the build tree
set TOP=..\..\..\..\..\..

@REM Individual output directories
set RESULT=%TOP%\result
set INCLUDEBASE=%RESULT%\include
set INCLUDE=%INCLUDEBASE%\hci
set BINBASE=%RESULT%\bin
set BIN=%BINBASE%\%2
set LIBBASE=%RESULT%\lib
set LIB=%LIBBASE%\%2

@REM Ensure that the directories exist
if not exist %RESULT% mkdir %RESULT%
if not exist %INCLUDEBASE% mkdir %INCLUDEBASE%
if not exist %INCLUDE% mkdir %INCLUDE%
if not exist %BINBASE% mkdir %BINBASE%
if not exist %BIN% mkdir %BIN%
if not exist %LIBBASE% mkdir %LIBBASE%
if not exist %LIB% mkdir %LIB%

@REM Copy the output files
xcopy /d ..\..\..\generic\driver_types.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\BCPacker\BCPacker.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\packer.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\packer_parameters.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\packer_inline.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\HCIPacker_Interpretation.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\packer\HCIPacker\HCIPacker.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\DeviceDriver\bc01\bc01devicecontroller.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\DeviceDriver\HCIDeviceController.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\TransportLayer\blueCoreTransport.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\TransportLayer\callBack.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\TransportLayer\HCITransport.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\TransportLayer\tunnel.h %INCLUDE% > nul 
xcopy /d ..\..\..\generic\HCI\HCILinkage.h %INCLUDE% > nul 
xcopy /d ..\..\BCSP\Win32BCSPTransport.h %INCLUDE% > nul 
xcopy /d ..\..\H4\Win32H4Transport.h %INCLUDE% > nul 
xcopy /d ..\..\USB\Win32USBTransport.h %INCLUDE% > nul 
xcopy /d %1\HCI.dll %BIN%
xcopy /d %1\HCI.lib %LIB%
