// ProtocolDlg.cpp : implementation file
//
//            (C) CSR 2000
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Win32/DeviceDriver/Factory/ProtocolDlg.cpp#26 $
//  

#include "stdafx.h"
//#include "	\ add additional includes here"
#include "ProtocolDlg.h"
#include "HCIFactory.h"
#include "thread/system_wide_mutex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int MAX_COMM_PORT = 50;
const int MAX_USB_PORT = 20;
/////////////////////////////////////////////////////////////////////////////
// CProtocolDlg dialog


CProtocolDlg::CProtocolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProtocolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProtocolDlg)
	m_H4dataRate = -1;
	m_BCSPdataRate = -1;
	//}}AFX_DATA_INIT
        memset ( mSettings , 0 , sizeof ( mSettings ) );
        defaultsSet = false;
        tunnel = false;
}

CProtocolDlg::~CProtocolDlg ()
{
    delete BCSPSettings->transportDevice;
    delete USBSettings->transportDevice;
    delete H4Settings->transportDevice;
}


void CProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProtocolDlg)
	DDX_Control(pDX, IDC_PORT3, m_USBport);
	DDX_Control(pDX, IDC_PORT2, m_H4port);
	DDX_Control(pDX, IDC_PORT, m_BCSPport);
	DDX_CBIndex(pDX, IDC_RATE2, m_H4dataRate);
	DDX_CBIndex(pDX, IDC_RATE, m_BCSPdataRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProtocolDlg, CDialog)
	//{{AFX_MSG_MAP(CProtocolDlg)
	ON_BN_CLICKED(IDC_BCSP, OnBcsp)
	ON_BN_CLICKED(IDC_H4, OnH4)
	ON_BN_CLICKED(IDC_USB, OnUsb)
	ON_WM_RBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProtocolDlg message handlers

BOOL CProtocolDlg::OnInitDialog() 
{

	CDialog::OnInitDialog();
	
    //  Seek out the existing ports.
    // This code is oncorrect, as the pointer returned by GetDlgItem is
    // a temporary, and is only valid during the processing of this message!
    // Changed to use member variables (of type CComboBox).
    //BCSPport = ((CComboBox*)GetDlgItem(IDC_PORT));
    //USBport = ((CComboBox*)GetDlgItem(IDC_PORT3));
    //H4port = ((CComboBox*)GetDlgItem(IDC_PORT2));
    BCSPValid = false;
    H4Valid = false;
    USBValid = false;

#ifdef _NO_H4
    GetDlgItem ( IDC_H4 )->EnableWindow (false);
#endif

    CString portname;
	ichar devname[100];

    HANDLE test;
    //  validate the entries in the BCSPport and H4port lists
    int length = m_BCSPport.GetCount();
    int row = 0;
    int c;
	
	bool found = 0;
#ifdef _WINCE
	// Try to read the COM port from the registry first
	HKEY handle;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\WIDCOMM\\BtConfig\\SerialTransport"),
		             0, KEY_ALL_ACCESS,
					 &handle)
		== ERROR_SUCCESS)
	{
		// Determine the maximum buffer sizes required
		DWORD maxNameLength;
		DWORD maxDataLength;
		if (RegQueryInfoKey(handle, 0, 0, 0, 0, 0, 0, 0,
			                &maxNameLength, &maxDataLength, 0, 0)
			== ERROR_SUCCESS)
		{
			// Allocate buffer to receive the key data
			unsigned long int lDataType;
			unsigned long int lSize = 20 ;
			unsigned char * buffer = new unsigned char [lSize];
			// retrieve the data if the subkey exists
			if (RegQueryValueEx ( handle , 
								  II("Port") , 
								  NULL , 
								  &lDataType , 
								  buffer , 
								  &lSize )
				== ERROR_SUCCESS && lDataType == REG_DWORD)
			{
				c = (int)( *(unsigned long *)buffer );
        		found = 1;
			}
			// tidy
			delete [] buffer;
		}

		// Close the registry
		RegCloseKey(handle);
	}
	// if we have found a registry setting for the port then use this and ignore all other ports
	if (found)
	{
		CString portname;
		portname.Format(_T("com%d:"), c);
        if ( (test = ::CreateFile(portname, GENERIC_READ | GENERIC_WRITE,
                                        0,0,OPEN_EXISTING,0,0) ) != INVALID_HANDLE_VALUE )
        {
            ::CloseHandle(test);
			m_H4port.ResetContent();
			m_BCSPport.ResetContent();
            m_H4port.AddString ( portname );
            m_BCSPport.AddString( portname );
        }
	}
#endif
    if (!found)
	{
		for ( c = 1 ; c < MAX_COMM_PORT ; c++ )
		{
			CString portname;
#ifdef _WINCE
			portname.Format(_T("com%d:"), c);
#else
			portname.Format(_T("\\\\.\\COM%d"), c);
#endif
			if ( (test = ::CreateFile(portname, GENERIC_READ | GENERIC_WRITE,
											0,0,OPEN_EXISTING,0,0) ) != INVALID_HANDLE_VALUE )
			{
				::CloseHandle(test);
				m_H4port.AddString ( portname );
				m_BCSPport.AddString( portname );
			}
		}
	}
    //  Check that there is something available
	BCSPValid = ( m_BCSPport.GetCount () != 0 );
    H4Valid   = ( m_H4port.GetCount () != 0 );

#ifndef _WINCE

	// Add CSR USB devices to USBport combo box
    for ( c = 0 ; c < MAX_USB_PORT ; c++ )
    {
		_stprintf(devname, II("\\\\.\\CSR%d"), c);

        if ( (test = ::CreateFile(devname,GENERIC_READ | GENERIC_WRITE,
                                        0,0,OPEN_EXISTING,0,0) ) != INVALID_HANDLE_VALUE )
        {
			m_USBport.AddString(devname);
            ::CloseHandle(test);
        }
    }
	// Add Widcomm USB devices to USBport combo box
    for ( c = 0 ; c < MAX_USB_PORT ; c++ )
    {
		_stprintf(devname, II("\\\\.\\BTWUSB-%d"), c);

		if (SystemWideMutex(&devname[4], true).IsAcquired())
		{
			if ( (test = ::CreateFile(devname,GENERIC_READ | GENERIC_WRITE,
								0,0,OPEN_EXISTING,0,0) ) != INVALID_HANDLE_VALUE )
			{
				m_USBport.AddString(devname);
				::CloseHandle(test);
			}
		}
    }
    //  Check that there is something available
    USBValid = ( m_USBport.GetCount () != 0 );
#endif // _WINCE

    if ( !BCSPValid && !H4Valid && !USBValid )
        GetDlgItem( IDOK )->EnableWindow ( false );

    //  If there are defaults set, great, if not make them up.
    if ( !defaultsSet )
        setDefaults ( NULL );

    ichar ldataRateString[20];
    _stprintf ( ldataRateString , II("%u") , BCSPSettings->dataRate );
    ((CComboBox*)GetDlgItem(IDC_RATE))->SelectString(-1, ldataRateString );
    _stprintf ( ldataRateString , II("%u") , H4Settings->dataRate );
    ((CComboBox*)GetDlgItem(IDC_RATE2))->SelectString(-1, ldataRateString );
    if (m_BCSPport.SelectString ( -1 , BCSPSettings->transportDevice ) == CB_ERR )
        m_BCSPport.SetCurSel ( 0 );

    if (m_H4port.SelectString ( -1 , H4Settings->transportDevice ) == CB_ERR )
        m_H4port.SetCurSel ( 0 );
	if (m_USBport.SelectString ( -1 , USBSettings->transportDevice ) == CB_ERR )
        m_USBport.SetCurSel ( 0 );
    refreshState();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

unsigned long int CProtocolDlg::GetDataRate ( void )
{
    return mCurrentSettings->dataRate;
}

ichar * CProtocolDlg::GetPortName ( void )
{
    CComboBox * port;
    switch ( mCurrentSettings->type )
    {
    case H4:
        port = &m_H4port;
        break;
    case BCSP:
        port = &m_BCSPport;
        break;
    case USB:
        port = &m_USBport;
        break;
    default:
        return NULL;
    }
    int size = 15;
    ichar * text = new ichar [size];

    port->GetWindowText( text , size );
    return text;
}

TransportType CProtocolDlg::GetType ()
{
    return mCurrentSettings->type;
}

void CProtocolDlg::OnBcsp() 
{
    mCurrentSettings = BCSPSettings;
    refreshState();
}

void CProtocolDlg::OnH4() 
{
    mCurrentSettings = H4Settings;
    refreshState();
}

void CProtocolDlg::OnUsb() 
{
    mCurrentSettings = USBSettings;
    refreshState();
}

void CProtocolDlg::setDefaults ( ConfigurationSettings * aConfigList )
{
    //  if all the data is null, that doesn't count, fill in the data in that case...
    if ( aConfigList == NULL )
        aConfigList = mSettings;
    //  check out the data and fill in the gaps. check the type is 1-4...
    if ( ( ( ( aConfigList[0].type ) & 0xF8 ) != 0 || aConfigList[0].type == 0 )
      || ( ( ( aConfigList[1].type ) & 0xF8 ) != 0 || aConfigList[1].type == 0 )
      || ( ( ( aConfigList[2].type ) & 0xF8 ) != 0 || aConfigList[2].type == 0 ) )
    {
        //  if anything is wrong, write all over it...
        aConfigList[0].type = BCSP;
        aConfigList[0].transportDevice = new ichar[5];
        istrcpy ( aConfigList[0].transportDevice , II("com1") );
        aConfigList[0].dataRate = 115200;
        aConfigList[0].mostRecent = true;
        aConfigList[1].type = H4;
        aConfigList[1].transportDevice = new ichar[5];
        istrcpy ( aConfigList[1].transportDevice , II("com1") );
        aConfigList[1].dataRate = 115200;
        aConfigList[1].mostRecent = false;
        aConfigList[2].type = USB;
        aConfigList[2].transportDevice = NULL;
        aConfigList[2].dataRate = 0;
        aConfigList[2].mostRecent = true;
    }
    //  write into our local settings.
    if ( aConfigList != mSettings )
        memcpy ( mSettings , aConfigList , sizeof ( mSettings ) );

    for ( ConfigurationSettings * lSettings = mSettings ;
          lSettings - mSettings < 3 ; lSettings++ )
    {
        if ( lSettings->type == BCSP )
            BCSPSettings = lSettings;
        if ( lSettings->type == H4 )
            H4Settings = lSettings;
        if ( lSettings->type == USB )
            USBSettings = lSettings;
        if ( lSettings->mostRecent == true )
            mCurrentSettings = lSettings;
    }
    defaultsSet = true;
}

void CProtocolDlg::refreshState()
{
	if (m_hWnd == 0)
		return;
    switch ( mCurrentSettings->type )
    {
    case BCSP:
        ((CButton*)GetDlgItem(IDC_BCSP))->SetCheck ( 1 );
        if ( BCSPValid )
            GetDlgItem( IDOK )->EnableWindow ( true );
        else
            GetDlgItem( IDOK )->EnableWindow ( false );
        break;
    case USB:
        ((CButton*)GetDlgItem(IDC_USB))->SetCheck ( 1 );
        if ( USBValid )
            GetDlgItem( IDOK )->EnableWindow ( true );
        else
            GetDlgItem( IDOK )->EnableWindow ( false );
        break;
    case H4:
        ((CButton*)GetDlgItem(IDC_H4))->SetCheck ( 1 );
        if ( H4Valid )
            GetDlgItem( IDOK )->EnableWindow ( true );
        else
            GetDlgItem( IDOK )->EnableWindow ( false );
        break;
    }

    m_BCSPport            .ShowWindow ( ( mCurrentSettings->type != BCSP ) ? SW_HIDE : SW_SHOWNOACTIVATE );
    GetDlgItem(IDC_RATE )->ShowWindow ( ( mCurrentSettings->type != BCSP ) ? SW_HIDE : SW_SHOWNOACTIVATE );
    m_H4port              .ShowWindow ( ( mCurrentSettings->type !=  H4  ) ? SW_HIDE : SW_SHOWNOACTIVATE );
    GetDlgItem(IDC_RATE2)->ShowWindow ( ( mCurrentSettings->type !=  H4  ) ? SW_HIDE : SW_SHOWNOACTIVATE );
    m_USBport             .ShowWindow ( ( mCurrentSettings->type !=  USB ) ? SW_HIDE : SW_SHOWNOACTIVATE );
    GetDlgItem(IDC_PANDB)->SetWindowText ( ( ( mCurrentSettings->type !=  USB ) ? II("Port and Baud Rate") : II("USB Device") ) );
    UpdateData();
}

ConfigurationSettings * CProtocolDlg::getSelectedConfiguration ( void )
{
    mCurrentSettings->mostRecent = true;
    return mCurrentSettings;
}

void CProtocolDlg::OnOK() 
{
    UpdateData();
    getData();
    CDialog::OnOK();
}

void CProtocolDlg::OnCancel() 
{
    UpdateData();
    getData();
    CDialog::OnCancel();
}

void CProtocolDlg::getData( void )
{
    
	//  keep the screen and internal data in line.
    if (m_BCSPdataRate >= 0)
    {
        CString value;
	    ((CComboBox*)GetDlgItem(IDC_RATE))->GetLBText(m_BCSPdataRate, value);
        BCSPSettings->dataRate = iatoi(value);
    }
    if (m_H4dataRate >= 0)
    {
        CString value;
	    ((CComboBox*)GetDlgItem(IDC_RATE2))->GetLBText(m_H4dataRate, value);
        H4Settings->dataRate = iatoi(value);
    }
    int size = m_BCSPport.GetWindowTextLength() + 1;
    delete BCSPSettings->transportDevice;
    BCSPSettings->transportDevice = new ichar [size];
    m_BCSPport.GetWindowText( BCSPSettings->transportDevice , size );

    delete H4Settings->transportDevice;
	size = m_H4port.GetWindowTextLength() + 1;
    H4Settings->transportDevice = new ichar [size];
    m_H4port.GetWindowText( H4Settings->transportDevice , size );

    delete USBSettings->transportDevice;
	size = m_USBport.GetWindowTextLength() + 1;
    USBSettings->transportDevice = new ichar [size];
    m_USBport.GetWindowText( USBSettings->transportDevice , size );
}

bool CProtocolDlg::getTunnel ()
{
    return tunnel;
}

void CProtocolDlg::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

    tunnel = ! tunnel ;

    if ( tunnel )
        MessageBox ( II("Switched on Tunnelling") );
    else
        MessageBox ( II("Switched off Tunnelling") );
#ifndef _WINCE
	CDialog::OnRButtonDblClk(nFlags, point);
#endif
}
