///////////////////////////////////////////////////////////////////////////////
//
//  FILE : ProtocolDlg.h
//
//  (C) CSR 2000
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Win32/DeviceDriver/Factory/ProtocolDlg.h#14 $
//
///////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_PROTOCOLDLG_H__B1C00E03_801D_11D4_BA56_00B0D02F393A__INCLUDED_)
#define AFX_PROTOCOLDLG_H__B1C00E03_801D_11D4_BA56_00B0D02F393A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ProtocolDlg.h : header file
//

#include "HCIFactory.h"
#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CProtocolDlg dialog
 
#if defined _WINCE && !defined IDD_SERIALDLG 
#define IDD_SERIALDLG                   170
#endif


class FACTORY_API_CLASS CProtocolDlg : public CDialog
{
// Construction
public:
	CProtocolDlg(CWnd* pParent = 0);   // standard constructor
    virtual ~CProtocolDlg ();

// Dialog Data
	//{{AFX_DATA(CProtocolDlg)
	enum { IDD = IDD_SERIALDLG };
	CComboBox	m_USBport;
	CComboBox	m_H4port;
	CComboBox	m_BCSPport;
	int		m_H4dataRate;
	int		m_BCSPdataRate;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProtocolDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation

public:
        void setDefaults ( ConfigurationSettings * aConfigList );
        ConfigurationSettings * getSelectedConfiguration ( void );
        unsigned long int GetDataRate ( void );
        ichar * GetPortName ( void );
        TransportType GetType ( void );
        bool getTunnel ( void );
protected:

	// Generated message map functions
	//{{AFX_MSG(CProtocolDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnBcsp();
	afx_msg void OnH4();
	afx_msg void OnUsb();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
        ConfigurationSettings mSettings[3];
        bool tunnel;
        ConfigurationSettings * BCSPSettings;
        ConfigurationSettings * H4Settings;
        ConfigurationSettings * USBSettings;
        ConfigurationSettings * mCurrentSettings;
        //CComboBox * BCSPport;
        //CComboBox * USBport;
        //CComboBox * H4port;
        bool BCSPValid;
        bool H4Valid;
        bool USBValid;
        bool defaultsSet ;
        void refreshState();
        void getData();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROTOCOLDLG_H__B1C00E03_801D_11D4_BA56_00B0D02F393A__INCLUDED_)
