/****************************************************************************

FILE

    Driver.h - Declarations for filter driver 



CONTAINS

    This file contains the main declarations



MODIFICATION HISTORY

    0.1   14:Mar:03		jm01		Derived from Walter Oney's filter driver

									distributed with, 'Programming the MS Windows

									Driver Model'



NOTES

	

  Declarations for filter driver

  Copyright (C) 1999 by Walter Oney

  All rights reserved



  Copyright (c) 2003 Cambridge Silicon Radio

  All Rights Reserved

*/





#ifndef DRIVER_H

#define DRIVER_H



#define DRIVERNAME "FILTER"					// for use in messages





typedef struct tagDEVICE_STATISTICS

{

	ULONG	totalTxBytes;

	ULONG	totalRxBytes;

} DEVICE_STATISTICS;



///////////////////////////////////////////////////////////////////////////////

// Device extension structure



typedef struct tagDEVICE_EXTENSION {

	PDEVICE_OBJECT DeviceObject;			// device object this extension belongs to

	PDEVICE_OBJECT LowerDeviceObject;		// next lower driver in same stack

	PDEVICE_OBJECT Pdo;						// the PDO

	IO_REMOVE_LOCK RemoveLock;

	ULONG		   uSequenceNumber;

	LONG		   packet_length;

	bool		   header;

	DEVICE_STATISTICS	stats;

	} DEVICE_EXTENSION, *PDEVICE_EXTENSION;



///////////////////////////////////////////////////////////////////////////////

// Global functions



VOID RemoveDevice(IN PDEVICE_OBJECT fdo);

NTSTATUS CompleteRequest(IN PIRP Irp, IN NTSTATUS status, IN ULONG_PTR info);



extern BOOLEAN win98;

extern UNICODE_STRING servkey;



#endif // DRIVER_H

