///////////////////////////////////////////////////////////////////////
//
//  FILE    : independentDebug.cpp
//
//            (C) CSR 2000
//
//  PURPOSE : The release version isn't working, but the debug version is...
//                       ...call in the independent debugger...
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/Win32/independentDebug.cpp#11 $
//	1.5  26-mar-00 dm  - added windows ce debug includes
//
//
///////////////////////////////////////////////////////////////////////
#ifndef _WINCE
#include <cassert>
#else
#include <windef.h>
#include <winbase.h>
#include <dbgapi.h>
#define assert ASSERT
#endif



#include "independentDebug.h"
#include "thread/critical_section.h"

void unstring ( void * obj , ichar * data )
{
    ( (indebug *)obj )-> unstring( data );
}

void unload ( void * obj , uint8 * data , uint32 length )
{
    ( (indebug *)obj )-> unload( data , length );
}

void unloadPA ( void * obj , uint32 * data )
{
    ( (indebug *)obj )-> unloadPA( data );
}

indebug::indebug()
{
    indebugFile = ::ifopen( II("C:\\indebug.txt") , II("w") );
#ifdef _INDEBUG
    setBCIDO(this);
    setPIDO(this);
    setHIDO(this);
#endif
    cs = new CriticalSection;
}

indebug::~indebug()
{
    {
	CriticalSection::Lock here (cs);
	assert ( ::fflush ( indebugFile ) == 0 ) ;
	::fclose(indebugFile);
    }
    delete cs;
}

void indebug::unload ( uint8*data , uint32 length )
{
    CriticalSection::Lock here (cs);
    ::ifprintf( indebugFile , II("Data") );
    for (uint32 count = 0 ; count < length ; count ++ )
    {
        ::ifprintf( indebugFile , II(" %02x") , data[count] );
    }
    ::ifprintf( indebugFile , II("\n") );
    assert ( ::fflush ( indebugFile ) == 0 ) ;
}

void indebug::unloadPA ( uint32*data )
{
    CriticalSection::Lock here (cs);
    ::ifprintf( indebugFile , II("PA  ") );
    if ( data != NULL )
    {
        for (uint16 count = 0 ; count < data[0] ; count ++ )
        {
            ::ifprintf( indebugFile , II(" %08x") , data[count] );
        }
    }
    else
    {
        ::ifprintf( indebugFile , II(" NULL") );
    }
    ::ifprintf( indebugFile , II("\n") );
    assert ( ::fflush ( indebugFile ) == 0 ) ;
}

void indebug::unstring ( ichar * data )
{
    CriticalSection::Lock here (cs);
    ::ifprintf ( indebugFile , data );
    assert ( ::fflush ( indebugFile ) == 0 ) ;
}
