///////////////////////////////////////////////////////////////////////
//
//  FILE   :  DMHandler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Jiny Bradshaw
//
//  CLASS  :  DMHandler
//
//  PURPOSE:  handle the throughput of DM data.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/DMHandler.h#10 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __DM_HANDLER_H__
#define __DM_HANDLER_H__

#include "common/types.h"
#include "common/bool.h"
#include "common/linkage.h"

#include "handler.h"
#include "pduList.h"

//  include the callback controlling classes
#include "sendPathway.h"
#include "callBack.h"
#include "blueCoreTransport.h"

class PrimConverter;

class DEVICECONTROLLER_API_CLASS DMHandler : public Handler
{
	// Suppress
	DMHandler(const DMHandler &);
	void operator=(const DMHandler &);
public:
    DMHandler();
    ~DMHandler();
    bool queue (uint16 prim_type, void *prim);
	uint8 *getIncomingDMprim();
    void doneSend(Genericpdu *apdu);
	void setup(BlueCoreTransport *aTransport,
			   SignalBox::Item *aOutSignal,
			   SignalBox::Item *aInSignal,
			   SignalBox::Item *aStopSignal);
	void AddPrimToIncomingQueue(uint8 *rx_prim, uint32 len);

private:
    PrimConverter &DM_MyPrimConvert;
	BlueCoreTransport *pTransport;
	
	static void DMPrimFromChip(uint8 *rx_prim, uint32 len, void *thisObj);
    NEXT_PACKET_INFO peekAtNext(void);
    Genericpdu *getpdu(void);
    void send(Genericpdu *apdu);
};


#endif // __DM_HANDLER_H__
