///////////////////////////////////////////////////////////////////////
//
//  FILE   :  L2CAPHandler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Jiny Bradshaw
//
//  CLASS  :  L2CAPHandler
//
//  PURPOSE:  handle the throughput of L2CAP data.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/L2CAPHandler.h#6 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __L2CAP_HANDLER_H__
#define __L2CAP_HANDLER_H__

#include "common/types.h"
#include "common/bool.h"
#include "common/linkage.h"

#include "handler.h"
#include "pduList.h"

//  include the callback controlling classes
#include "sendPathway.h"
#include "callBack.h"
#include "blueCoreTransport.h"

class PrimConverter;
class SignalBox;
class SignalBox::Item;

class DEVICECONTROLLER_API_CLASS L2CAPHandler : public Handler
{
	// Suppress
	L2CAPHandler(const L2CAPHandler &);
	void operator=(const L2CAPHandler &);
public:
    L2CAPHandler();
    ~L2CAPHandler();
    bool queue (uint16 prim_type, void *prim);
	uint8 *getIncomingL2CAPprim();
    void doneSend(Genericpdu *apdu);
	void setup(BlueCoreTransport *aTransport,
		SignalBox::Item *aOutSignal, SignalBox::Item *aInSignal, SignalBox::Item *aStopSignal);
	void AddPrimToIncomingQueue(uint8 *rx_prim, uint32 len);

private:
    PrimConverter &L2CAP_MyPrimConvert;
	BlueCoreTransport *pTransport;
	
	static void L2CAPPrimFromChip(uint8 *rx_prim, uint32 len, void *thisObj);
    NEXT_PACKET_INFO peekAtNext(void);
    Genericpdu *getpdu(void);
    void send(Genericpdu *apdu);
};


#endif // __L2CAP_HANDLER_H__
