///////////////////////////////////////////////////////////////////////
//
//  FILE   :  PCHandler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  PCHandler
//
//  PURPOSE:  handle the private channel commands.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/PCHandler.h#13 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __PCHANDLER_H__
#define __PCHANDLER_H__

#include "common/types.h"
#include "common/bool.h"
#include "common/linkage.h"

#include "handler.h"
#include "pduList.h"
#include "blueCoreTransport.h"

extern "C"
{
#include "BCPacker.h"
}

//  include the callback controlling classes
#include "sendPathway.h"
#include "callBack.h"

class DEVICECONTROLLER_API_CLASS PCHandler : public Handler
{
public:
    PCHandler();
    ~PCHandler();
    void setup( BlueCoreTransport * aTransport ,
                SignalBox::Item * aOutSignal , SignalBox::Item * aInSignal , SignalBox::Item * aStopSignal );

    void makeHostToChip( void );
    bool   queue ( PARAMETER_ARRAY parameters );
    PARAMETER_ARRAY getIncomingEvent ( void );
    static void recvEvent ( uint8 * apdu , uint32 aLength , void * aThis );
    void doneSend ( Genericpdu * apdu );

private:
    NEXT_PACKET_INFO peekAtNext ( void );
    Genericpdu * getpdu( void );
    void   send   ( Genericpdu * apdu );
    bool bccmd;
    BlueCoreTransport * pTransport;
};


#endif // __PCHANDLER_H__
