///////////////////////////////////////////////////////////////////////
//
//  FILE   :  RFCOMMHandler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Jiny Bradshaw
//
//  CLASS  :  RFCOMMHandler
//
//  PURPOSE:  handle the throughput of RFCOMM data.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/RFCOMMHandler.h#9 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __RFCOMM_HANDLER_H__
#define __RFCOMM_HANDLER_H__

#include "common/types.h"
#include "common/bool.h"
#include "common/linkage.h"

#include "handler.h"
#include "pduList.h"


//  include the callback controlling classes
#include "sendPathway.h"
#include "callBack.h"
#include "blueCoreTransport.h"

class PrimConverter;


class DEVICECONTROLLER_API_CLASS RFCOMMHandler : public Handler
{
	// Suppress
	RFCOMMHandler(const RFCOMMHandler &);
	void operator=(const RFCOMMHandler &);
public:
    RFCOMMHandler();
    ~RFCOMMHandler();
    bool queue (uint16 prim_type, void *prim);
	uint8 *getIncomingRFCOMMprim();
    void doneSend(Genericpdu *apdu);
	void setup(BlueCoreTransport *aTransport,
			   SignalBox::Item *aOutSignal,
			   SignalBox::Item *aInSignal,
			   SignalBox::Item *aStopSignal);
	void AddPrimToIncomingQueue(uint8 *rx_prim, uint32 len);

private:
    PrimConverter &RFCOMM_MyPrimConvert;
	BlueCoreTransport *pTransport;
	
	static void RFCOMMPrimFromChip(uint8 *rx_prim, uint32 len, void *thisObj);
    NEXT_PACKET_INFO peekAtNext(void);
    Genericpdu *getpdu(void);
    void send(Genericpdu *apdu);
};


#endif // __RFCOMM_HANDLER_H__
