///////////////////////////////////////////////////////////////////////
//
//  FILE   :  commandHandler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  CommandHandler
//
//  PURPOSE:  Base class for ACL, command and SCO handlers.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/commandHandler.h#8 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __COMMANDHANDLER_H__
#define __COMMANDHANDLER_H__

#include "handler.h"
#include "HCIPacker.h"
//  #include "SCOHandler.h"

//  declare it, so we don't have to include the whole definition.
class HCIDeviceDriver;
class ConnectionList;
class DeviceList;
class ACLHandler;

//  include the callback controlling classes
#include "sendPathway.h"
#include "callBack.h"

class DEVICECONTROLLER_API_CLASS CommandHandler : public Handler
{
public:
    CommandHandler();
    ~CommandHandler();
    bool queueCommand ( PARAMETER_ARRAY parameters , bool aInternallyGeneratedCommand);
    static void recvEvent ( uint8 * apdu , uint32 aLength , void * aThis );
    PARAMETER_ARRAY getEvent ( void );
    void doneSend ( Genericpdu * apdu );
    bool matchCommandToEvent ( uint16 opCode );

private:
    pduList mCommandQueue;

    NEXT_PACKET_INFO peekAtNext ( void );
    Genericpdu * getpdu( void );
    void   send   ( Genericpdu * apdu );
};

#endif // __HANDLER_H__
