///////////////////////////////////////////////////////////////////////
//
//  FILE   :  handler.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  Handler
//
//  PURPOSE:  Base class for ACL, command and SCO handlers.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/handler.h#13 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __HANDLER_H__
#define __HANDLER_H__

#include "localTypes.h"
#include "pduList.h"
#include "flowControl.h"
#include "HCITransport.h"
#include "thread/signal_box.h"

enum {dummyConnectionHandle};

class DEVICECONTROLLER_API_CLASS Handler
{
public:
    virtual ~Handler();
    void setup( HCITransport * aTransport ,
                SignalBox::Item * aOutSignal ,
		SignalBox::Item * aInSignal ,
                SignalBox::Item * aStopSignal );

    bool trySend ( void );
    virtual void doneSend ( Genericpdu * apdu ) = 0;
    void onPduReceipt ( Genericpdu * apdu );
    FlowControl   mFlowControl;
    SignalBox::Item*	mStopSignal;

protected:
    HCITransport *pTransport;
    bool transportReady;
    SignalBox::Item*	mSentSignal;
    SignalBox::Item*	mRecvSignal;
    pduList       mIncomingpdu;
    pduList       mSentpdu;

    virtual NEXT_PACKET_INFO peekAtNext ( void ) = 0;
    virtual Genericpdu *getpdu ( void ) = 0;
    virtual void send ( Genericpdu *apdu ) = 0;

private:
#ifdef _INDEBUG
    //  release debugging!
public:
    indebug * mDebug;
#else
    //  keep the size of the object the same.
    void * dummy;
#endif
};

#endif // __HANDLER_H__
