///////////////////////////////////////////////////////////////////////
//
//  FILE   :  pduList.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  pduList
//
//  PURPOSE:  Hold an ordered list of pdus
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/pduList.h#8 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __PDULIST_H__
#define __PDULIST_H__

#include "localTypes.h"

class CriticalSection;

class DEVICECONTROLLER_API_CLASS pduList
{
public:
    pduList();
    ~pduList();
    void Add ( Genericpdu * apdu );
    NEXT_PACKET_INFO peekAtNext ( void );
    Genericpdu *Get ();

private:
    CriticalSection * mDataProtection;

    struct pduListEntry
    {
        pduListEntry * next;
        Genericpdu * pdu;
    };
    pduListEntry * mStart;
    pduListEntry * mEnd;

    void Add ( pduListEntry * node );
};

#endif //__PDULIST_H__
