///////////////////////////////////////////////////////////////////////
//
//  FILE   :  sendPathway.cpp
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  SendPathway
//
//  PURPOSE:  the information needed to delete data following
//            a successful sending is all held in an object,
//            a "pathway" to that data.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/sendPathway.cpp#5 $
//
///////////////////////////////////////////////////////////////////////

#include "sendPathway.h"

void SendPathway::initialise( Handler *aRoute, Genericpdu *apdu )
{
    mRoute = aRoute;
    mpdu = apdu;
    mStopSignal = aRoute->mStopSignal;
}

void SendPathway::doneSend ( bool done , void * aObject )
{
    SendPathway * data = ((SendPathway*)aObject);
    //  allow that the message may not get through.
    if (done)
    {
        if ( !data->mStopSignal->getState() )
            data->mRoute->doneSend ( data->mpdu );
    }
    else
    {
        delete data->mpdu;
    }
    delete data;
}

