///////////////////////////////////////////////////////////////////////
//
//  FILE   :  sendPathway.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  SendPathway
//
//  PURPOSE:  the information needed to delete data following
//            a successful sending is all held in an object,
//            a "pathway" to that data.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/DeviceDriver/sendPathway.h#7 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __SENDPATHWAY_H__
#define __SENDPATHWAY_H__

#include "localTypes.h"
#include "handler.h"

class DEVICECONTROLLER_API_CLASS SendPathway
{
public:
    void initialise( Handler *aRoute, Genericpdu *apdu );
    static void doneSend ( bool done , void * aObject);
private:
    Handler *mRoute;
    Genericpdu *mpdu;
    SignalBox::Item * mStopSignal;
};

#endif // __SENDPATHWAY_H__
