/****************************************************************************
**
**  File: BCPacker.h
**
**            (C) CSR 2000
**
**  Purpose:  advertise the services of the BCPacker library
**
**  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/Packer/BCPacker/BCPacker.h#7 $
**
****************************************************************************/

/****************************************************************************
**  Modification history
***************************************************************************** 
**  1.1   8:may:00	ajh	Created.
*/

#ifndef	__BCPACKETISER_H__
#define	__BCPACKETISER_H__
 
#include "common/types.h"
#include "common/linkage.h"
#include "packer_parameters.h"

/****************************************************************************
NAME
	bccmdGenerate  -  generates wire format h->hc commands.

PARAMETERS
        the address of a pointer to a buffer which will be allocated by
        the procedure, and parameter array.

RETURNS
        the size of the buffer written.  Returns zero on failure to create
        the command pdu successfully.
****************************************************************************/

DEVICECONTROLLER_API uint32 bccmdGenerate ( uint8** aPointerToBuffer, PARAMETER_ARRAY aParameters );

/****************************************************************************
NAME
	bccmdAnalyse  -  analyses wire format responses to h->hc commands.

PARAMETERS
        a buffer to be analysed.

RETURNS
	The array of analysed parameters.  NULL is a failure.
****************************************************************************/

DEVICECONTROLLER_API PARAMETER_ARRAY bccmdAnalyse ( uint8 * aBufferContainingApdu , uint32 length );

/****************************************************************************
NAME
	hq_analyse  -  analyses wire format hc->h commands.

PARAMETERS
        a buffer to be analysed.  The buffer will be amended to make it
        the response to send back to the host controller, so that it is
        not necessary to create a new response pdu.

RETURNS
	The array of analysed parameters.  NULL is a failure.
****************************************************************************/

DEVICECONTROLLER_API PARAMETER_ARRAY hqAnalyse ( uint8 * aBufferContainingApdu , uint32 length );

#endif	/* __HCIPACKETISER_H__ */
