#include "inc.h"

void * PrimConverter::conv_L2CA_UPRIM_T(uint8_t dir, uint16_t type, void * prim)
{
	prepareConvert((uint8_t*) xapPrim, dir) ;
	
	switch (type)
	{
		case L2CA_REGISTER_REQ :
			conv_L2CA_REGISTER_REQ_T((L2CA_REGISTER_REQ_T *) prim) ;
			break ;
		case L2CA_REGISTER_CFM :
			conv_L2CA_REGISTER_CFM_T((L2CA_REGISTER_CFM_T *) prim) ;
			break ;
		case L2CA_CONNECT_REQ :
			conv_L2CA_CONNECT_REQ_T((L2CA_CONNECT_REQ_T *) prim) ;
			break ;
		case L2CA_CONNECT_RSP :
			conv_L2CA_CONNECT_RSP_T((L2CA_CONNECT_RSP_T *) prim) ;
			break ;
		case L2CA_CONNECT_IND :
			conv_L2CA_CONNECT_IND_T((L2CA_CONNECT_IND_T *) prim) ;
			break ;
		case L2CA_CONNECT_CFM :
			conv_L2CA_CONNECT_CFM_T((L2CA_CONNECT_CFM_T *) prim) ;
			break ;
		case L2CA_CONFIG_REQ :
			conv_L2CA_CONFIG_REQ_T((L2CA_CONFIG_REQ_T *) prim) ;
			break ;
		case L2CA_CONFIG_RSP :
			conv_L2CA_CONFIG_RSP_T((L2CA_CONFIG_RSP_T *) prim) ;
			break ;
		case L2CA_CONFIG_IND :
			conv_L2CA_CONFIG_IND_T((L2CA_CONFIG_IND_T *) prim) ;
			break ;
		case L2CA_CONFIG_CFM :
			conv_L2CA_CONFIG_CFM_T((L2CA_CONFIG_CFM_T *) prim) ;
			break ;
		case L2CA_DATAWRITE_REQ :
			conv_L2CA_DATAWRITE_REQ_T((L2CA_DATAWRITE_REQ_T *) prim) ;
			break ;
		case L2CA_DATAWRITE_CFM :
			conv_L2CA_DATAWRITE_CFM_T((L2CA_DATAWRITE_CFM_T *) prim) ;
			break ;
		case L2CA_DATAREAD_IND :
			conv_L2CA_DATAREAD_IND_T((L2CA_DATAREAD_IND_T *) prim) ;
			break ;
		case L2CA_DISCONNECT_REQ :
			conv_L2CA_DISCONNECT_REQ_T((L2CA_DISCONNECT_REQ_T *) prim) ;
			break ;
		case L2CA_DISCONNECT_RSP :
			conv_L2CA_DISCONNECT_RSP_T((L2CA_DISCONNECT_RSP_T *) prim) ;
			break ;
		case L2CA_DISCONNECT_IND :
			conv_L2CA_DISCONNECT_IND_T((L2CA_DISCONNECT_IND_T *) prim) ;
			break ;
		case L2CA_DISCONNECT_CFM :
			conv_L2CA_DISCONNECT_CFM_T((L2CA_DISCONNECT_CFM_T *) prim) ;
			break ;
		case L2CA_TIMEOUT_IND :
			conv_L2CA_TIMEOUT_IND_T((L2CA_TIMEOUT_IND_T *) prim) ;
			break ;
		case L2CA_QOSVIOLATION_IND :
			conv_L2CA_QOSVIOLATION_IND_T((L2CA_QOSVIOLATION_IND_T *) prim) ;
			break ;
		case L2CA_PING_REQ :
			conv_L2CA_PING_REQ_T((L2CA_PING_REQ_T *) prim) ;
			break ;
		case L2CA_PING_CFM :
			conv_L2CA_PING_CFM_T((L2CA_PING_CFM_T *) prim) ;
			break ;
		case L2CA_GETINFO_REQ :
			conv_L2CA_GETINFO_REQ_T((L2CA_GETINFO_REQ_T *) prim) ;
			break ;
		case L2CA_GETINFO_CFM :
			conv_L2CA_GETINFO_CFM_T((L2CA_GETINFO_CFM_T *) prim) ;
			break ;
		case L2CA_GROUP_CREATE_REQ :
			conv_L2CA_GROUP_CREATE_REQ_T((L2CA_GROUP_CREATE_REQ_T *) prim) ;
			break ;
		case L2CA_GROUP_CREATE_CFM :
			conv_L2CA_GROUP_CREATE_CFM_T((L2CA_GROUP_CREATE_CFM_T *) prim) ;
			break ;
		case L2CA_GROUP_CLOSE_REQ :
			conv_L2CA_GROUP_CLOSE_REQ_T((L2CA_GROUP_CLOSE_REQ_T *) prim) ;
			break ;
		case L2CA_GROUP_CLOSE_CFM :
			conv_L2CA_GROUP_CLOSE_CFM_T((L2CA_GROUP_CLOSE_CFM_T *) prim) ;
			break ;
		case L2CA_ENABLE_CONNECTIONLESS_REQ :
			conv_L2CA_ENABLE_CONNECTIONLESS_REQ_T((L2CA_ENABLE_CONNECTIONLESS_REQ_T *) prim) ;
			break ;
		case L2CA_ENABLE_CONNECTIONLESS_CFM :
			conv_L2CA_ENABLE_CONNECTIONLESS_CFM_T((L2CA_ENABLE_CONNECTIONLESS_CFM_T *) prim) ;
			break ;
		case L2CA_DISABLE_CONNECTIONLESS_REQ :
			conv_L2CA_DISABLE_CONNECTIONLESS_REQ_T((L2CA_DISABLE_CONNECTIONLESS_REQ_T *) prim) ;
			break ;
		case L2CA_DISABLE_CONNECTIONLESS_CFM :
			conv_L2CA_DISABLE_CONNECTIONLESS_CFM_T((L2CA_DISABLE_CONNECTIONLESS_CFM_T *) prim) ;
			break ;
		case TCP_OPEN_REQ :
			conv_TCP_OPEN_REQ_T((TCP_OPEN_REQ_T *) prim) ;
			break ;
		case TCP_OPEN_CFM :
			conv_TCP_OPEN_CFM_T((TCP_OPEN_CFM_T *) prim) ;
			break ;
		case TCP_OPEN_IND :
			conv_TCP_OPEN_IND_T((TCP_OPEN_IND_T *) prim) ;
			break ;
		case TCP_OPEN_RSP :
			conv_TCP_OPEN_RSP_T((TCP_OPEN_RSP_T *) prim) ;
			break ;
		case TCP_DATA_REQ :
			conv_TCP_DATA_REQ_T((TCP_DATA_REQ_T *) prim) ;
			break ;
		case TCP_DATA_CFM :
			conv_TCP_DATA_CFM_T((TCP_DATA_CFM_T *) prim) ;
			break ;
		case TCP_DATA_IND :
			conv_TCP_DATA_IND_T((TCP_DATA_IND_T *) prim) ;
			break ;
		case TCP_DATA_RSP :
			conv_TCP_DATA_RSP_T((TCP_DATA_RSP_T *) prim) ;
			break ;
		case TCP_CLOSE_REQ :
			conv_TCP_CLOSE_REQ_T((TCP_CLOSE_REQ_T *) prim) ;
			break ;
		case TCP_CLOSE_IND :
			conv_TCP_CLOSE_IND_T((TCP_CLOSE_IND_T *) prim) ;
			break ;
		case TCP_CLOSED_IND :
			conv_TCP_CLOSED_IND_T((TCP_CLOSED_IND_T *) prim) ;
			break ;
		case TCP_CLOSED_RSP :
			conv_TCP_CLOSED_RSP_T((TCP_CLOSED_RSP_T *) prim) ;
			break ;
		case TCP_ABORT_REQ :
			conv_TCP_ABORT_REQ_T((TCP_ABORT_REQ_T *) prim) ;
			break ;
		case TCP_ABORT_IND :
			conv_TCP_ABORT_IND_T((TCP_ABORT_IND_T *) prim) ;
			break ;
		case TCP_ABORT_RSP :
			conv_TCP_ABORT_RSP_T((TCP_ABORT_RSP_T *) prim) ;
			break ;
		case UDP_OPEN_REQ :
			conv_UDP_OPEN_REQ_T((UDP_OPEN_REQ_T *) prim) ;
			break ;
		case UDP_OPEN_CFM :
			conv_UDP_OPEN_CFM_T((UDP_OPEN_CFM_T *) prim) ;
			break ;
		case UDP_LISTEN_REQ :
			conv_UDP_LISTEN_REQ_T((UDP_LISTEN_REQ_T *) prim) ;
			break ;
		case UDP_IGNORE_REQ :
			conv_UDP_IGNORE_REQ_T((UDP_IGNORE_REQ_T *) prim) ;
			break ;
		case UDP_DATA_REQ :
			conv_UDP_DATA_REQ_T((UDP_DATA_REQ_T *) prim) ;
			break ;
		case UDP_EXTENDED_DATA_REQ :
			conv_UDP_EXTENDED_DATA_REQ_T((UDP_EXTENDED_DATA_REQ_T *) prim) ;
			break ;
		case UDP_DATA_CFM :
			conv_UDP_DATA_CFM_T((UDP_DATA_CFM_T *) prim) ;
			break ;
		case UDP_DATA_IND :
			conv_UDP_DATA_IND_T((UDP_DATA_IND_T *) prim) ;
			break ;
		case UDP_EXTENDED_DATA_IND :
			conv_UDP_EXTENDED_DATA_IND_T((UDP_EXTENDED_DATA_IND_T *) prim) ;
			break ;
		case UDP_CLOSE_REQ :
			conv_UDP_CLOSE_REQ_T((UDP_CLOSE_REQ_T *) prim) ;
			break ;
		case UDP_CLOSE_CFM :
			conv_UDP_CLOSE_CFM_T((UDP_CLOSE_CFM_T *) prim) ;
			break ;
		case BNEP_REGISTER_REQ :
			conv_BNEP_REGISTER_REQ_T((BNEP_REGISTER_REQ_T *) prim) ;
			break ;
		case BNEP_CONNECT_REQ :
			conv_BNEP_CONNECT_REQ_T((BNEP_CONNECT_REQ_T *) prim) ;
			break ;
		case BNEP_CONNECT_CFM :
			conv_BNEP_CONNECT_CFM_T((BNEP_CONNECT_CFM_T *) prim) ;
			break ;
		case BNEP_CONNECT_IND :
			conv_BNEP_CONNECT_IND_T((BNEP_CONNECT_IND_T *) prim) ;
			break ;
		case BNEP_LISTEN_REQ :
			conv_BNEP_LISTEN_REQ_T((BNEP_LISTEN_REQ_T *) prim) ;
			break ;
		case BNEP_IGNORE_REQ :
			conv_BNEP_IGNORE_REQ_T((BNEP_IGNORE_REQ_T *) prim) ;
			break ;
		case BNEP_DATA_REQ :
			conv_BNEP_DATA_REQ_T((BNEP_DATA_REQ_T *) prim) ;
			break ;
		case BNEP_EXTENDED_DATA_REQ :
			conv_BNEP_EXTENDED_DATA_REQ_T((BNEP_EXTENDED_DATA_REQ_T *) prim) ;
			break ;
		case BNEP_EXTENDED_MULTICAST_DATA_REQ :
			conv_BNEP_EXTENDED_MULTICAST_DATA_REQ_T((BNEP_EXTENDED_MULTICAST_DATA_REQ_T *) prim) ;
			break ;
		case BNEP_DATA_IND :
			conv_BNEP_DATA_IND_T((BNEP_DATA_IND_T *) prim) ;
			break ;
		case BNEP_EXTENDED_DATA_IND :
			conv_BNEP_EXTENDED_DATA_IND_T((BNEP_EXTENDED_DATA_IND_T *) prim) ;
			break ;
		case BNEP_MULTICAST_DATA_IND :
			conv_BNEP_MULTICAST_DATA_IND_T((BNEP_MULTICAST_DATA_IND_T *) prim) ;
			break ;
		case BNEP_LOOPBACK_DATA_IND :
			conv_BNEP_LOOPBACK_DATA_IND_T((BNEP_LOOPBACK_DATA_IND_T *) prim) ;
			break ;
		case BNEP_UP_IND :
			conv_BNEP_UP_IND_T((BNEP_UP_IND_T *) prim) ;
			break ;
		case BNEP_DOWN_IND :
			conv_BNEP_DOWN_IND_T((BNEP_DOWN_IND_T *) prim) ;
			break ;
		case BNEP_DISCONNECT_REQ :
			conv_BNEP_DISCONNECT_REQ_T((BNEP_DISCONNECT_REQ_T *) prim) ;
			break ;
		case BNEP_DISCONNECT_IND :
			conv_BNEP_DISCONNECT_IND_T((BNEP_DISCONNECT_IND_T *) prim) ;
			break ;
		case BNEP_DEBUG_REQ :
			conv_BNEP_DEBUG_REQ_T((BNEP_DEBUG_REQ_T *) prim) ;
			break ;
		case BNEP_DEBUG_IND :
			conv_BNEP_DEBUG_IND_T((BNEP_DEBUG_IND_T *) prim) ;
			break ;
		case BNEP_FLOW_REQ :
			conv_BNEP_FLOW_REQ_T((BNEP_FLOW_REQ_T *) prim) ;
			break ;
		case BNEP_FLOW_IND :
			conv_BNEP_FLOW_IND_T((BNEP_FLOW_IND_T *) prim) ;
			break ;
		case BNEP_HCI_SWITCH_ROLE_RSP :
			conv_BNEP_HCI_SWITCH_ROLE_RSP_T((BNEP_HCI_SWITCH_ROLE_RSP_T *) prim) ;
			break ;
 
		default : return 0 ;
	}
	return xapPrim ;
}
