#include "inc.h"

void PrimConverter::conv_BD_ADDR_T (BD_ADDR_T * prim) 
 
{
	conv_uint24_t(&prim->lap) ;
	conv_uint8_t(&prim->uap) ;
	conv_uint16_t(&prim->nap) ;
}

void PrimConverter::conv_DM_HCI_STANDARD_COMMAND_COMPLETE_T (DM_HCI_STANDARD_COMMAND_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
}

void PrimConverter::conv_DM_AM_REGISTER_REQ_T (DM_AM_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_AM_REGISTER_CFM_T (DM_AM_REGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_ACL_REGISTER_REQ_T (DM_ACL_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_ACL_REGISTER_CFM_T (DM_ACL_REGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_ACL_CONNECT_REQ_T (DM_ACL_CONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->packet_type) ;
}

void PrimConverter::conv_DM_ACL_CONNECT_CFM_T (DM_ACL_CONNECT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->enc_mode) ;
}

void PrimConverter::conv_DM_ACL_CONNECT_IND_T (DM_ACL_CONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->enc_mode) ;
}

void PrimConverter::conv_DM_ACL_DISCONNECT_REQ_T (DM_ACL_DISCONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->reason) ;
}

void PrimConverter::conv_DM_ACL_DISCONNECT_IND_T (DM_ACL_DISCONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->reason) ;
}

void PrimConverter::conv_DM_ACL_BUFFER_SIZE_IND_T (DM_ACL_BUFFER_SIZE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->size) ;
	conv_uint16_t(&prim->max_num_packets) ;
}

void PrimConverter::conv_DM_ACL_DATA_SENT_IND_T (DM_ACL_DATA_SENT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->num_handles) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_EV_NUM_HANDLE_COMPLETE_PACKET_PTRS ; m++)
			conv_ptr(&prim->handle_complete_ptr [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < ((prim->num_handles+HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR-1)/HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR) ; k++) 
		{
			HANDLE_COMPLETE_T * ptr ;
			startPointer((void **) & (prim->handle_complete_ptr [k]) , sizeof(HANDLE_COMPLETE_T) * (HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR)) ;
			unsetPtrMode();
			ptr = prim->handle_complete_ptr [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR ; d++)
					conv_HANDLE_COMPLETE_T(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_DM_CONNECTIONLESS_CH_REG_REQ_T (DM_CONNECTIONLESS_CH_REG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->handle) ;
}

void PrimConverter::conv_DM_SCO_INCOMING_REGISTER_REQ_T (DM_SCO_INCOMING_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
}

void PrimConverter::conv_DM_SCO_INCOMING_UNREGISTER_REQ_T (DM_SCO_INCOMING_UNREGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
}

void PrimConverter::conv_DM_SCO_CONNECT_REQ_T (DM_SCO_CONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->packet_type) ;
}

void PrimConverter::conv_DM_SCO_CONNECT_CFM_T (DM_SCO_CONNECT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->lm_sco_handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->enc_mode) ;
}

void PrimConverter::conv_DM_SCO_CONNECT_IND_T (DM_SCO_CONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->lm_sco_handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->enc_mode) ;
}

void PrimConverter::conv_DM_SCO_CONNECT_RES_T (DM_SCO_CONNECT_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->handle) ;
	conv_bool_t(&prim->accept) ;
}

void PrimConverter::conv_DM_SCO_DISCONNECT_REQ_T (DM_SCO_DISCONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->reason) ;
}

void PrimConverter::conv_DM_SCO_DISCONNECT_IND_T (DM_SCO_DISCONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->pv_cbarg) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint8_t(&prim->reason) ;
}

void PrimConverter::conv_DM_SCO_BUFFER_SIZE_IND_T (DM_SCO_BUFFER_SIZE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->size) ;
	conv_uint16_t(&prim->max_num_packets) ;
}

void PrimConverter::conv_DM_SCO_DATA_SENT_IND_T (DM_SCO_DATA_SENT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint16_t(&prim->num_completed) ;
}

void PrimConverter::conv_DM_SM_SET_DEFAULT_SECURITY_REQ_T (DM_SM_SET_DEFAULT_SECURITY_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->secl_default) ;
}

void PrimConverter::conv_DM_SM_REGISTER_REQ_T (DM_SM_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
	conv_bool_t(&prim->outgoing_ok) ;
	conv_uint16_t(&prim->security_level) ;
	conv_uint16_t(&prim->psm) ;
}

void PrimConverter::conv_DM_SM_REGISTER_OUTGOING_REQ_T (DM_SM_REGISTER_OUTGOING_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->remote_channel) ;
	conv_uint16_t(&prim->outgoing_security_level) ;
	conv_uint16_t(&prim->psm) ;
}

void PrimConverter::conv_DM_SM_UNREGISTER_REQ_T (DM_SM_UNREGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
}

void PrimConverter::conv_DM_SM_UNREGISTER_OUTGOING_REQ_T (DM_SM_UNREGISTER_OUTGOING_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->remote_channel) ;
}

void PrimConverter::conv_DM_SM_ACCESS_REQ_T (DM_SM_ACCESS_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
	conv_bool_t(&prim->incoming) ;
	conv_uint32_t(&prim->pv_context) ;
	conv_uint32_t(&prim->n_context) ;
}

void PrimConverter::conv_DM_SM_ACCESS_CFM_T (DM_SM_ACCESS_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
	conv_bool_t(&prim->incoming) ;
	conv_bool_t(&prim->granted) ;
	conv_uint32_t(&prim->pv_context) ;
	conv_uint32_t(&prim->n_context) ;
}

void PrimConverter::conv_DM_SM_SET_SEC_MODE_REQ_T (DM_SM_SET_SEC_MODE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mode) ;
	conv_uint8_t(&prim->mode3_enc) ;
}

void PrimConverter::conv_DM_SM_SET_SEC_MODE_CFM_T (DM_SM_SET_SEC_MODE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mode) ;
	conv_uint8_t(&prim->mode3_enc) ;
	conv_bool_t(&prim->success) ;
}

void PrimConverter::conv_DM_SM_ADD_DEVICE_REQ_T (DM_SM_ADD_DEVICE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->update_trust_level) ;
	conv_bool_t(&prim->trusted) ;
	conv_bool_t(&prim->update_link_key) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <SIZE_LINK_KEY ; m++)
			conv_uint8_t(&prim->link_key [m]) ;
	}
}

void PrimConverter::conv_DM_SM_ADD_DEVICE_CFM_T (DM_SM_ADD_DEVICE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->success) ;
}

void PrimConverter::conv_DM_SM_REMOVE_DEVICE_REQ_T (DM_SM_REMOVE_DEVICE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_SM_REMOVE_DEVICE_CFM_T (DM_SM_REMOVE_DEVICE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->success) ;
}

void PrimConverter::conv_DM_SM_LINK_KEY_REQUEST_IND_T (DM_SM_LINK_KEY_REQUEST_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_SM_LINK_KEY_REQUEST_RES_T (DM_SM_LINK_KEY_REQUEST_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <SIZE_LINK_KEY ; m++)
			conv_uint8_t(&prim->key [m]) ;
	}
	conv_bool_t(&prim->valid) ;
}

void PrimConverter::conv_DM_SM_PIN_REQUEST_IND_T (DM_SM_PIN_REQUEST_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_SM_PIN_REQUEST_RES_T (DM_SM_PIN_REQUEST_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->pin_length) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_MAX_PIN_LENGTH ; m++)
			conv_uint8_t(&prim->pin [m]) ;
	}
}

void PrimConverter::conv_DM_SM_LINK_KEY_IND_T (DM_SM_LINK_KEY_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->key_type) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <SIZE_LINK_KEY ; m++)
			conv_uint8_t(&prim->key [m]) ;
	}
}

void PrimConverter::conv_DM_SM_AUTHORISE_IND_T (DM_SM_AUTHORISE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
	conv_bool_t(&prim->incoming) ;
}

void PrimConverter::conv_DM_SM_AUTHORISE_RES_T (DM_SM_AUTHORISE_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->protocol_id) ;
	conv_uint32_t(&prim->channel) ;
	conv_bool_t(&prim->incoming) ;
	conv_bool_t(&prim->authorised) ;
}

void PrimConverter::conv_DM_SM_AUTHENTICATE_REQ_T (DM_SM_AUTHENTICATE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_SM_AUTHENTICATE_CFM_T (DM_SM_AUTHENTICATE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->success) ;
}

void PrimConverter::conv_DM_SM_ENCRYPT_REQ_T (DM_SM_ENCRYPT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->encrypt) ;
}

void PrimConverter::conv_DM_SM_ENCRYPT_CFM_T (DM_SM_ENCRYPT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->success) ;
	conv_bool_t(&prim->encrypted) ;
}

void PrimConverter::conv_DM_SM_ENCRYPTION_CHANGE_T (DM_SM_ENCRYPTION_CHANGE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->encrypted) ;
}

void PrimConverter::conv_DM_SM_L2CAP_REGISTER_REQ_T (DM_SM_L2CAP_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_SM_L2CAP_CLRX_ENABLE_IND_T (DM_SM_L2CAP_CLRX_ENABLE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <MAX_CLRX_PSMS ; m++)
			conv_uint16_t(&prim->psm_array [m]) ;
	}
}

void PrimConverter::conv_DM_WRITE_CACHED_PAGE_MODE_REQ_T (DM_WRITE_CACHED_PAGE_MODE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->page_scan_mode) ;
	conv_uint8_t(&prim->page_scan_rep_mode) ;
}

void PrimConverter::conv_DM_WRITE_CACHED_CLOCK_OFFSET_REQ_T (DM_WRITE_CACHED_CLOCK_OFFSET_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->clock_offset) ;
}

void PrimConverter::conv_DM_CLEAR_PARAM_CACHE_REQ_T (DM_CLEAR_PARAM_CACHE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HC_TO_HOST_FLOW_CONTROL_T (DM_HC_TO_HOST_FLOW_CONTROL_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_bool_t(&prim->Active) ;
}

void PrimConverter::conv_DM_ACL_OPEN_REQ_T (DM_ACL_OPEN_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_ACL_OPEN_CFM_T (DM_ACL_OPEN_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->success) ;
}

void PrimConverter::conv_DM_ACL_CLOSE_REQ_T (DM_ACL_CLOSE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_ACL_OPENED_IND_T (DM_ACL_OPENED_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_bool_t(&prim->incoming) ;
	conv_uint24_t(&prim->dev_class) ;
}

void PrimConverter::conv_DM_ACL_CLOSED_IND_T (DM_ACL_CLOSED_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_SET_DEFAULT_LINK_POLICY_T (DM_SET_DEFAULT_LINK_POLICY_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->link_policy_settings_in) ;
	conv_uint16_t(&prim->link_policy_settings_out) ;
}

void PrimConverter::conv_DM_HCI_INQUIRY_RESULT_T (DM_HCI_INQUIRY_RESULT_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->num_responses) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_MAX_INQ_RESULT_PTRS ; m++)
			conv_ptr(&prim->result [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < ((prim->num_responses+HCI_MAX_INQ_RESULT_PER_PTR-1)/HCI_MAX_INQ_RESULT_PER_PTR) ; k++) 
		{
			HCI_INQ_RESULT_T * ptr ;
			startPointer((void **) & (prim->result [k]) , sizeof(HCI_INQ_RESULT_T) * (HCI_MAX_INQ_RESULT_PER_PTR)) ;
			unsetPtrMode();
			ptr = prim->result [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < HCI_MAX_INQ_RESULT_PER_PTR ; d++)
					conv_HCI_INQ_RESULT_T(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_DM_HCI_INQUIRY_COMPLETE_T (DM_HCI_INQUIRY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
}

void PrimConverter::conv_DM_HCI_LINK_KEY_CHANGE_COMPLETE_T (DM_HCI_LINK_KEY_CHANGE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_RETURN_LINK_KEYS_T (DM_HCI_RETURN_LINK_KEYS_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->num_keys) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_STORED_LINK_KEY_MAX ; m++)
			conv_ptr(&prim->link_key_bd_addr [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < prim->num_keys ; k++) 
		{
			LINK_KEY_BD_ADDR_T * ptr ;
			startPointer((void **) & (prim->link_key_bd_addr [k]) , sizeof(LINK_KEY_BD_ADDR_T) * (1)) ;
			unsetPtrMode();
			ptr = prim->link_key_bd_addr [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < 1 ; d++)
					conv_LINK_KEY_BD_ADDR_T(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_DM_HCI_MASTER_LINK_KEY_COMPLETE_T (DM_HCI_MASTER_LINK_KEY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->key_flag) ;
}

void PrimConverter::conv_DM_HCI_REMOTE_NAME_COMPLETE_T (DM_HCI_REMOTE_NAME_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_LOCAL_NAME_BYTE_PACKET_PTRS ; m++)
			conv_ptr(&prim->name_part [m]) ;
	}
	//startPointer() ; REMEMBER to put this in custom code!
	conv_customDM_HCI_REMOTE_NAME_COMPLETE(prim);
}

void PrimConverter::conv_DM_HCI_READ_REMOTE_FEATURES_COMPLETE_T (DM_HCI_READ_REMOTE_FEATURES_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <4 ; m++)
			conv_uint16_t(&prim->features [m]) ;
	}
}

void PrimConverter::conv_DM_HCI_READ_REMOTE_VERSION_COMPLETE_T (DM_HCI_READ_REMOTE_VERSION_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->LMP_version) ;
	conv_uint16_t(&prim->manufacturer_name) ;
	conv_uint16_t(&prim->LMP_subversion) ;
}

void PrimConverter::conv_DM_HCI_READ_CLOCK_OFFSET_COMPLETE_T (DM_HCI_READ_CLOCK_OFFSET_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->clock_offset) ;
}

void PrimConverter::conv_DM_HCI_MODE_CHANGE_EVENT_T (DM_HCI_MODE_CHANGE_EVENT_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->mode) ;
	conv_uint16_t(&prim->length) ;
}

void PrimConverter::conv_DM_HCI_QOS_SETUP_CFM_T (DM_HCI_QOS_SETUP_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->flags) ;
	conv_uint8_t(&prim->service_type) ;
	conv_uint32_t(&prim->token_rate) ;
	conv_uint32_t(&prim->peak_bandwidth) ;
	conv_uint32_t(&prim->latency) ;
	conv_uint32_t(&prim->delay_variation) ;
}

void PrimConverter::conv_DM_HCI_QOS_VIOLATION_IND_T (DM_HCI_QOS_VIOLATION_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_HCI_ROLE_DISCOVERY_COMPLETE_T (DM_HCI_ROLE_DISCOVERY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->role) ;
}

void PrimConverter::conv_DM_HCI_SWITCH_ROLE_COMPLETE_T (DM_HCI_SWITCH_ROLE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->role) ;
}

void PrimConverter::conv_DM_HCI_READ_LP_SETTINGS_COMPLETE_T (DM_HCI_READ_LP_SETTINGS_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->link_policy) ;
}

void PrimConverter::conv_DM_HCI_WRITE_LP_SETTINGS_T (DM_HCI_WRITE_LP_SETTINGS_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->link_policy_settings) ;
	conv_uint8_t(&prim->dm_policy) ;
	conv_customWriteLPSettings(prim); 
}

void PrimConverter::conv_DM_HCI_WRITE_LP_SETTINGS_COMPLETE_T (DM_HCI_WRITE_LP_SETTINGS_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_SET_EVENT_MASK_COMPLETE_T (DM_HCI_SET_EVENT_MASK_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
}

void PrimConverter::conv_DM_HCI_FLUSH_COMPLETE_T (DM_HCI_FLUSH_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_READ_PIN_TYPE_COMPLETE_T (DM_HCI_READ_PIN_TYPE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->pin_type) ;
}

void PrimConverter::conv_DM_HCI_READ_STORED_LINK_KEY_COMPLETE_T (DM_HCI_READ_STORED_LINK_KEY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->max_num_keys) ;
	conv_uint16_t(&prim->num_keys_read) ;
}

void PrimConverter::conv_DM_HCI_WRITE_STORED_LINK_KEY_COMPLETE_T (DM_HCI_WRITE_STORED_LINK_KEY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->num_keys_written) ;
}

void PrimConverter::conv_DM_HCI_DELETE_STORED_LINK_KEY_COMPLETE_T (DM_HCI_DELETE_STORED_LINK_KEY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->num_keys_deleted) ;
}

void PrimConverter::conv_DM_HCI_READ_LOCAL_NAME_COMPLETE_T (DM_HCI_READ_LOCAL_NAME_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_LOCAL_NAME_BYTE_PACKET_PTRS ; m++)
			conv_ptr(&prim->name_part [m]) ;
	}
	//startPointer() ; REMEMBER to put this in custom code!
	conv_customDM_HCI_READ_LOCAL_NAME_COMPLETE(prim);
}

void PrimConverter::conv_DM_HCI_READ_CONN_ACCEPT_TO_COMPLETE_T (DM_HCI_READ_CONN_ACCEPT_TO_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->conn_accept_timeout) ;
}

void PrimConverter::conv_DM_HCI_READ_PAGE_TO_COMPLETE_T (DM_HCI_READ_PAGE_TO_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->page_timeout) ;
}

void PrimConverter::conv_DM_HCI_READ_SCAN_ENABLE_COMPLETE_T (DM_HCI_READ_SCAN_ENABLE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->scan_enable) ;
}

void PrimConverter::conv_DM_HCI_READ_PAGESCAN_ACTIVITY_COMPLETE_T (DM_HCI_READ_PAGESCAN_ACTIVITY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->pagescan_interval) ;
	conv_uint16_t(&prim->pagescan_window) ;
}

void PrimConverter::conv_DM_HCI_READ_INQUIRYSCAN_ACTIVITY_COMPLETE_T (DM_HCI_READ_INQUIRYSCAN_ACTIVITY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->inqscan_interval) ;
	conv_uint16_t(&prim->inqscan_window) ;
}

void PrimConverter::conv_DM_HCI_READ_AUTH_ENABLE_COMPLETE_T (DM_HCI_READ_AUTH_ENABLE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->auth_enable) ;
}

void PrimConverter::conv_DM_HCI_READ_ENCRYPTION_MODE_COMPLETE_T (DM_HCI_READ_ENCRYPTION_MODE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->mode) ;
}

void PrimConverter::conv_DM_HCI_READ_CLASS_OF_DEVICE_COMPLETE_T (DM_HCI_READ_CLASS_OF_DEVICE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint32_t(&prim->dev_class) ;
}

void PrimConverter::conv_DM_HCI_READ_VOICE_SETTING_COMPLETE_T (DM_HCI_READ_VOICE_SETTING_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->voice_setting) ;
}

void PrimConverter::conv_DM_HCI_READ_AUTO_FLUSH_COMPLETE_T (DM_HCI_READ_AUTO_FLUSH_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->status) ;
	conv_uint16_t(&prim->FlushTimeout) ;
}

void PrimConverter::conv_DM_HCI_WRITE_AUTO_FLUSH_COMPLETE_T (DM_HCI_WRITE_AUTO_FLUSH_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_READ_NUM_BCAST_TXS_COMPLETE_T (DM_HCI_READ_NUM_BCAST_TXS_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->num) ;
}

void PrimConverter::conv_DM_HCI_READ_HOLD_MODE_ACTIVITY_COMPLETE_T (DM_HCI_READ_HOLD_MODE_ACTIVITY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->activity) ;
}

void PrimConverter::conv_DM_HCI_READ_TX_POWER_LEVEL_COMPLETE_T (DM_HCI_READ_TX_POWER_LEVEL_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->pwr_level) ;
}

void PrimConverter::conv_DM_HCI_READ_LINK_SUPERV_TIMEOUT_COMPLETE_T (DM_HCI_READ_LINK_SUPERV_TIMEOUT_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->timeout) ;
}

void PrimConverter::conv_DM_HCI_WRITE_LINK_SUPERV_TIMEOUT_COMPLETE_T (DM_HCI_WRITE_LINK_SUPERV_TIMEOUT_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_READ_NUM_SUPPORTED_IAC_COMPLETE_T (DM_HCI_READ_NUM_SUPPORTED_IAC_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->num) ;
}

void PrimConverter::conv_DM_HCI_READ_CURRENT_IAC_LAP_COMPLETE_T (DM_HCI_READ_CURRENT_IAC_LAP_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->num_current_iac) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_IAC_LAP_PTRS ; m++)
			conv_ptr(&prim->iac_lap [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < ((prim->num_current_iac+HCI_IAC_LAP_PER_PTR-1)/HCI_IAC_LAP_PER_PTR) ; k++) 
		{
			uint24_t * ptr ;
			startPointer((void **) & (prim->iac_lap [k]) , sizeof(uint24_t) * (HCI_IAC_LAP_PER_PTR)) ;
			unsetPtrMode();
			ptr = prim->iac_lap [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < HCI_IAC_LAP_PER_PTR ; d++)
					conv_uint24_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_DM_HCI_READ_PAGESCAN_PERIOD_MODE_COMPLETE_T (DM_HCI_READ_PAGESCAN_PERIOD_MODE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->mode) ;
}

void PrimConverter::conv_DM_HCI_READ_PAGESCAN_MODE_COMPLETE_T (DM_HCI_READ_PAGESCAN_MODE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->mode) ;
}

void PrimConverter::conv_DM_HCI_HARDWARE_ERROR_T (DM_HCI_HARDWARE_ERROR_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->hw_error) ;
}

void PrimConverter::conv_DM_HCI_DATA_BUFFER_OVERFLOW_T (DM_HCI_DATA_BUFFER_OVERFLOW_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_DM_HCI_MAX_SLOTS_CHANGE_T (DM_HCI_MAX_SLOTS_CHANGE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->lmp_max_slots) ;
}

void PrimConverter::conv_DM_HCI_READ_LOCAL_VERSION_COMPLETE_T (DM_HCI_READ_LOCAL_VERSION_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->hci_version) ;
	conv_uint16_t(&prim->hci_revision) ;
	conv_uint8_t(&prim->lmp_version) ;
	conv_uint16_t(&prim->manuf_name) ;
	conv_uint16_t(&prim->lmp_subversion) ;
}

void PrimConverter::conv_DM_HCI_READ_LOCAL_FEATURES_COMPLETE_T (DM_HCI_READ_LOCAL_FEATURES_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <8 ; m++)
			conv_uint8_t(&prim->lmp_supp_features [m]) ;
	}
}

void PrimConverter::conv_DM_HCI_READ_COUNTRY_CODE_COMPLETE_T (DM_HCI_READ_COUNTRY_CODE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->country_code) ;
}

void PrimConverter::conv_DM_HCI_READ_BD_ADDR_COMPLETE_T (DM_HCI_READ_BD_ADDR_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_FAILED_CONTACT_COUNTER_COMPLETE_T (DM_HCI_FAILED_CONTACT_COUNTER_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->failed_contact_count) ;
}

void PrimConverter::conv_DM_HCI_RESET_CONTACT_COUNTER_COMPLETE_T (DM_HCI_RESET_CONTACT_COUNTER_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_DM_HCI_GET_LINK_QUALITY_COMPLETE_T (DM_HCI_GET_LINK_QUALITY_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->link_quality) ;
}

void PrimConverter::conv_DM_HCI_READ_RSSI_COMPLETE_T (DM_HCI_READ_RSSI_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->status) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->rssi) ;
}

void PrimConverter::conv_HCI_COMMAND_COMMON_T (HCI_COMMAND_COMMON_T * prim) 
 
{
	conv_uint16_t(&prim->op_code) ;
	conv_uint8_t(&prim->length) ;
}

void PrimConverter::conv_HANDLE_COMPLETE_T (HANDLE_COMPLETE_T * prim) 
 
{
	conv_uint16_t(&prim->handle) ;
	conv_uint16_t(&prim->num_completed) ;
}

void PrimConverter::conv_LINK_KEY_BD_ADDR_T (LINK_KEY_BD_ADDR_T * prim) 
 
{
	conv_BD_ADDR_T(&prim->bd_addr) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <SIZE_LINK_KEY ; m++)
			conv_uint8_t(&prim->link_key [m]) ;
	}
}

void PrimConverter::conv_HCI_INQUIRY_T (HCI_INQUIRY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint24_t(&prim->lap) ;
	conv_uint8_t(&prim->inquiry_length) ;
	conv_uint8_t(&prim->num_responses) ;
}

void PrimConverter::conv_HCI_INQUIRY_CANCEL_T (HCI_INQUIRY_CANCEL_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_PERIODIC_INQUIRY_MODE_T (HCI_PERIODIC_INQUIRY_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->max_period_length) ;
	conv_uint16_t(&prim->min_period_length) ;
	conv_uint24_t(&prim->lap) ;
	conv_uint8_t(&prim->inquiry_length) ;
	conv_uint8_t(&prim->num_responses) ;
}

void PrimConverter::conv_HCI_EXIT_PERIODIC_INQUIRY_MODE_T (HCI_EXIT_PERIODIC_INQUIRY_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_CHANGE_CONN_PKT_TYPE_T (HCI_CHANGE_CONN_PKT_TYPE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_uint16_t(&prim->pkt_type) ;
}

void PrimConverter::conv_HCI_CHANGE_CONN_LINK_KEY_T (HCI_CHANGE_CONN_LINK_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_MASTER_LINK_KEY_T (HCI_MASTER_LINK_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->link_key_type) ;
}

void PrimConverter::conv_HCI_REMOTE_NAME_REQ_T (HCI_REMOTE_NAME_REQ_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->page_scan_rep_mode) ;
	conv_uint8_t(&prim->page_scan_mode) ;
	conv_uint16_t(&prim->clock_offset) ;
}

void PrimConverter::conv_HCI_READ_REMOTE_SUPP_FEATURES_T (HCI_READ_REMOTE_SUPP_FEATURES_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_READ_REMOTE_VER_INFO_T (HCI_READ_REMOTE_VER_INFO_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_READ_CLOCK_OFFSET_T (HCI_READ_CLOCK_OFFSET_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_HOLD_MODE_T (HCI_HOLD_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->max_interval) ;
	conv_uint16_t(&prim->min_interval) ;
}

void PrimConverter::conv_HCI_SNIFF_MODE_T (HCI_SNIFF_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->max_interval) ;
	conv_uint16_t(&prim->min_interval) ;
	conv_uint16_t(&prim->attempt) ;
	conv_uint16_t(&prim->timeout) ;
}

void PrimConverter::conv_HCI_EXIT_SNIFF_MODE_T (HCI_EXIT_SNIFF_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_PARK_MODE_T (HCI_PARK_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->max_interval) ;
	conv_uint16_t(&prim->min_interval) ;
}

void PrimConverter::conv_HCI_EXIT_PARK_MODE_T (HCI_EXIT_PARK_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_QOS_SETUP_T (HCI_QOS_SETUP_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->flags) ;
	conv_uint8_t(&prim->service_type) ;
	conv_uint32_t(&prim->token_rate) ;
	conv_uint32_t(&prim->peak_bandwidth) ;
	conv_uint32_t(&prim->latency) ;
	conv_uint32_t(&prim->delay_variation) ;
}

void PrimConverter::conv_HCI_ROLE_DISCOVERY_T (HCI_ROLE_DISCOVERY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_SWITCH_ROLE_T (HCI_SWITCH_ROLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->role) ;
}

void PrimConverter::conv_HCI_READ_LINK_POLICY_SETTINGS_T (HCI_READ_LINK_POLICY_SETTINGS_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_SET_EVENT_MASK_T (HCI_SET_EVENT_MASK_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <2 ; m++)
			conv_uint32_t(&prim->event_mask [m]) ;
	}
}

void PrimConverter::conv_HCI_RESET_T (HCI_RESET_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_SET_EVENT_FILTER_T (HCI_SET_EVENT_FILTER_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->filter_type) ;
	conv_uint8_t(&prim->filter_condition_type) ;
	conv_customCondition(prim); 
}

void PrimConverter::conv_HCI_FLUSH_T (HCI_FLUSH_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_READ_PIN_TYPE_T (HCI_READ_PIN_TYPE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_PIN_TYPE_T (HCI_WRITE_PIN_TYPE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->pin_type) ;
}

void PrimConverter::conv_HCI_CREATE_NEW_UNIT_KEY_T (HCI_CREATE_NEW_UNIT_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_STORED_LINK_KEY_T (HCI_READ_STORED_LINK_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->read_all) ;
}

void PrimConverter::conv_HCI_WRITE_STORED_LINK_KEY_T (HCI_WRITE_STORED_LINK_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->number_keys) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_STORED_LINK_KEY_MAX ; m++)
			conv_ptr(&prim->link_key_bd_addr [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < prim->number_keys ; k++) 
		{
			LINK_KEY_BD_ADDR_T * ptr ;
			startPointer((void **) & (prim->link_key_bd_addr [k]) , sizeof(LINK_KEY_BD_ADDR_T) * (1)) ;
			unsetPtrMode();
			ptr = prim->link_key_bd_addr [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < 1 ; d++)
					conv_LINK_KEY_BD_ADDR_T(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_HCI_DELETE_STORED_LINK_KEY_T (HCI_DELETE_STORED_LINK_KEY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->flag) ;
}

void PrimConverter::conv_HCI_CHANGE_LOCAL_NAME_T (HCI_CHANGE_LOCAL_NAME_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_LOCAL_NAME_BYTE_PACKET_PTRS ; m++)
			conv_ptr(&prim->name_part [m]) ;
	}
	//startPointer() ; REMEMBER to put this in custom code!
	conv_customHCI(prim);
}

void PrimConverter::conv_HCI_READ_LOCAL_NAME_T (HCI_READ_LOCAL_NAME_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_CONN_ACCEPT_TIMEOUT_T (HCI_READ_CONN_ACCEPT_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_CONN_ACCEPT_TIMEOUT_T (HCI_WRITE_CONN_ACCEPT_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->conn_accept_timeout) ;
}

void PrimConverter::conv_HCI_READ_PAGE_TIMEOUT_T (HCI_READ_PAGE_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_PAGE_TIMEOUT_T (HCI_WRITE_PAGE_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->page_timeout) ;
}

void PrimConverter::conv_HCI_READ_SCAN_ENABLE_T (HCI_READ_SCAN_ENABLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_SCAN_ENABLE_T (HCI_WRITE_SCAN_ENABLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->scan_enable) ;
}

void PrimConverter::conv_HCI_READ_PAGESCAN_ACTIVITY_T (HCI_READ_PAGESCAN_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_PAGESCAN_ACTIVITY_T (HCI_WRITE_PAGESCAN_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->pagescan_interval) ;
	conv_uint16_t(&prim->pagescan_window) ;
}

void PrimConverter::conv_HCI_READ_INQUIRYSCAN_ACTIVITY_T (HCI_READ_INQUIRYSCAN_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_INQUIRYSCAN_ACTIVITY_T (HCI_WRITE_INQUIRYSCAN_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->inqscan_interval) ;
	conv_uint16_t(&prim->inqscan_window) ;
}

void PrimConverter::conv_HCI_READ_AUTH_ENABLE_T (HCI_READ_AUTH_ENABLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_ENC_MODE_T (HCI_READ_ENC_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_CLASS_OF_DEVICE_T (HCI_READ_CLASS_OF_DEVICE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_CLASS_OF_DEVICE_T (HCI_WRITE_CLASS_OF_DEVICE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint24_t(&prim->dev_class) ;
}

void PrimConverter::conv_HCI_READ_VOICE_SETTING_T (HCI_READ_VOICE_SETTING_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_VOICE_SETTING_T (HCI_WRITE_VOICE_SETTING_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->voice_setting) ;
}

void PrimConverter::conv_HCI_READ_AUTO_FLUSH_TIMEOUT_T (HCI_READ_AUTO_FLUSH_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_WRITE_AUTO_FLUSH_TIMEOUT_T (HCI_WRITE_AUTO_FLUSH_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->timeout) ;
}

void PrimConverter::conv_HCI_READ_NUM_BCAST_RETXS_T (HCI_READ_NUM_BCAST_RETXS_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_NUM_BCAST_RETXS_T (HCI_WRITE_NUM_BCAST_RETXS_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->num) ;
}

void PrimConverter::conv_HCI_READ_HOLD_MODE_ACTIVITY_T (HCI_READ_HOLD_MODE_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_HOLD_MODE_ACTIVITY_T (HCI_WRITE_HOLD_MODE_ACTIVITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->activity) ;
}

void PrimConverter::conv_HCI_READ_TX_POWER_LEVEL_T (HCI_READ_TX_POWER_LEVEL_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->type) ;
}

void PrimConverter::conv_HCI_READ_SCO_FLOW_CON_ENABLE_T (HCI_READ_SCO_FLOW_CON_ENABLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_SCO_FLOW_CON_ENABLE_T (HCI_WRITE_SCO_FLOW_CON_ENABLE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->sco_flow_control_enable) ;
}

void PrimConverter::conv_HCI_SET_HCTOHOST_FLOW_CONTROL_T (HCI_SET_HCTOHOST_FLOW_CONTROL_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->enable) ;
}

void PrimConverter::conv_HCI_HOST_NUM_COMPLETED_PACKETS_T (HCI_HOST_NUM_COMPLETED_PACKETS_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->num_handles) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_HOST_NUM_COMPLETED_PACKET_PTRS ; m++)
			conv_ptr(&prim->num_completed_pkts_ptr [m]) ;
	}
	if(1) 
	{
		// ptr template
		uint16_t k ;
		for (k=0; k < ((prim->num_handles+HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR-1)/HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR) ; k++) 
		{
			HANDLE_COMPLETE_T * ptr ;
			startPointer((void **) & (prim->num_completed_pkts_ptr [k]) , sizeof(HANDLE_COMPLETE_T) * (HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR)) ;
			unsetPtrMode();
			ptr = prim->num_completed_pkts_ptr [k] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < HCI_HOST_NUM_COMPLETED_PACKETS_PER_PTR ; d++)
					conv_HANDLE_COMPLETE_T(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_HCI_READ_LINK_SUPERV_TIMEOUT_T (HCI_READ_LINK_SUPERV_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_WRITE_LINK_SUPERV_TIMEOUT_T (HCI_WRITE_LINK_SUPERV_TIMEOUT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->timeout) ;
}

void PrimConverter::conv_HCI_READ_NUM_SUPPORTED_IAC_T (HCI_READ_NUM_SUPPORTED_IAC_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_CURRENT_IAC_LAP_T (HCI_READ_CURRENT_IAC_LAP_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_CURRENT_IAC_LAP_T (HCI_WRITE_CURRENT_IAC_LAP_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->num_current_iac) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <HCI_IAC_LAP_PTRS ; m++)
			conv_ptr(&prim->iac_lap [m]) ;
	}
	//startPointer() ; REMEMBER to put this in custom code!
	conv_customWriteIacLap(prim);
}

void PrimConverter::conv_HCI_READ_PAGESCAN_PERIOD_MODE_T (HCI_READ_PAGESCAN_PERIOD_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_PAGESCAN_PERIOD_MODE_T (HCI_WRITE_PAGESCAN_PERIOD_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->mode) ;
}

void PrimConverter::conv_HCI_READ_PAGESCAN_MODE_T (HCI_READ_PAGESCAN_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_WRITE_PAGESCAN_MODE_T (HCI_WRITE_PAGESCAN_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint8_t(&prim->mode) ;
}

void PrimConverter::conv_HCI_READ_LOCAL_VER_INFO_T (HCI_READ_LOCAL_VER_INFO_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_LOCAL_SUPP_FEATURES_T (HCI_READ_LOCAL_SUPP_FEATURES_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_COUNTRY_CODE_T (HCI_READ_COUNTRY_CODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_BD_ADDR_T (HCI_READ_BD_ADDR_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_READ_FAILED_CONTACT_COUNT_T (HCI_READ_FAILED_CONTACT_COUNT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_RESET_FAILED_CONTACT_COUNT_T (HCI_RESET_FAILED_CONTACT_COUNT_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_GET_LINK_QUALITY_T (HCI_GET_LINK_QUALITY_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_READ_RSSI_T (HCI_READ_RSSI_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
	conv_uint16_t(&prim->handle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_HCI_ENABLE_DUT_MODE_T (HCI_ENABLE_DUT_MODE_T * prim) 
 
{
	conv_HCI_COMMAND_COMMON_T(&prim->common) ;
}

void PrimConverter::conv_HCI_INQ_RESULT_T (HCI_INQ_RESULT_T * prim) 
 
{
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->page_scan_rep_mode) ;
	conv_uint8_t(&prim->page_scan_period_mode) ;
	conv_uint8_t(&prim->page_scan_mode) ;
	conv_uint24_t(&prim->dev_class) ;
	conv_uint16_t(&prim->clock_offset) ;
}

void PrimConverter::conv_QOS_FLOW_T (QOS_FLOW_T * prim) 
 
{
	conv_uint8_t(&prim->service_type) ;
	conv_uint32_t(&prim->token_rate) ;
	conv_uint32_t(&prim->token_bucket) ;
	conv_uint32_t(&prim->peak_bw) ;
	conv_uint32_t(&prim->latency) ;
	conv_uint32_t(&prim->delay_var) ;
}

void PrimConverter::conv_L2CA_REGISTER_REQ_T (L2CA_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_L2CA_REGISTER_CFM_T (L2CA_REGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->psm) ;
}

void PrimConverter::conv_L2CA_CONNECT_REQ_T (L2CA_CONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->psm_local) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->packet_type) ;
}

void PrimConverter::conv_L2CA_CONNECT_RSP_T (L2CA_CONNECT_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->identifier) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_L2CA_CONNECT_IND_T (L2CA_CONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->identifier) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->psm) ;
}

void PrimConverter::conv_L2CA_CONNECT_CFM_T (L2CA_CONNECT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_L2CA_CONFIG_REQ_T (L2CA_CONFIG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->options) ;
	conv_uint16_t(&prim->in_mtu) ;
	conv_QOS_FLOW_T(&prim->outflow) ;
	conv_uint16_t(&prim->outflush_to) ;
	conv_bool_t(&prim->more_flag) ;
}

void PrimConverter::conv_L2CA_CONFIG_RSP_T (L2CA_CONFIG_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint8_t(&prim->identifier) ;
	conv_uint16_t(&prim->size_options) ;
	conv_ptr(&prim->options) ;
	conv_uint16_t(&prim->response) ;
	conv_bool_t(&prim->more_flag) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->options ) [c]) , sizeof(uint8_t) * (prim->size_options)) ;
			ptr = (uint8_t *) (&prim->options ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_options ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_CONFIG_IND_T (L2CA_CONFIG_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint8_t(&prim->identifier) ;
	conv_uint16_t(&prim->size_options) ;
	conv_ptr(&prim->options) ;
	conv_bool_t(&prim->more_flag) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->options ) [c]) , sizeof(uint8_t) * (prim->size_options)) ;
			ptr = (uint8_t *) (&prim->options ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_options ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_CONFIG_CFM_T (L2CA_CONFIG_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->response) ;
	conv_uint16_t(&prim->options) ;
	conv_uint16_t(&prim->in_mtu) ;
	conv_QOS_FLOW_T(&prim->outflow) ;
	conv_uint16_t(&prim->flush_to) ;
	conv_bool_t(&prim->more_flag) ;
}

void PrimConverter::conv_L2CA_DATAWRITE_REQ_T (L2CA_DATAWRITE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->length) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->length)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_DATAWRITE_CFM_T (L2CA_DATAWRITE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->length) ;
	conv_uint16_t(&prim->result) ;
}

void PrimConverter::conv_L2CA_DATAREAD_IND_T (L2CA_DATAREAD_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->cl_psm) ;
	conv_uint16_t(&prim->length) ;
	conv_ptr(&prim->data) ;
	conv_uint16_t(&prim->result) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->length)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_DISCONNECT_REQ_T (L2CA_DISCONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->cid) ;
}

void PrimConverter::conv_L2CA_DISCONNECT_RSP_T (L2CA_DISCONNECT_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->identifier) ;
	conv_uint16_t(&prim->cid) ;
}

void PrimConverter::conv_L2CA_DISCONNECT_IND_T (L2CA_DISCONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->identifier) ;
	conv_uint16_t(&prim->cid) ;
}

void PrimConverter::conv_L2CA_DISCONNECT_CFM_T (L2CA_DISCONNECT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->result) ;
}

void PrimConverter::conv_L2CA_TIMEOUT_IND_T (L2CA_TIMEOUT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
}

void PrimConverter::conv_L2CA_QOSVIOLATION_IND_T (L2CA_QOSVIOLATION_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_L2CA_PING_REQ_T (L2CA_PING_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_ptr(&prim->data) ;
	conv_uint16_t(&prim->length) ;
	conv_uint16_t(&prim->psm_local) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->length)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_PING_CFM_T (L2CA_PING_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_ptr(&prim->data) ;
	conv_uint16_t(&prim->size) ;
	conv_uint16_t(&prim->result) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->size)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_GETINFO_REQ_T (L2CA_GETINFO_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->info_type) ;
	conv_uint16_t(&prim->psm_local) ;
}

void PrimConverter::conv_L2CA_GETINFO_CFM_T (L2CA_GETINFO_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->result) ;
	conv_ptr(&prim->info_data) ;
	conv_uint16_t(&prim->size) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->info_data ) [c]) , sizeof(uint8_t) * (prim->size)) ;
			ptr = (uint8_t *) (&prim->info_data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_L2CA_GROUP_CREATE_REQ_T (L2CA_GROUP_CREATE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->psm_local) ;
}

void PrimConverter::conv_L2CA_GROUP_CREATE_CFM_T (L2CA_GROUP_CREATE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_L2CA_GROUP_CLOSE_REQ_T (L2CA_GROUP_CLOSE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->cid) ;
	conv_uint16_t(&prim->psm_local) ;
}

void PrimConverter::conv_L2CA_GROUP_CLOSE_CFM_T (L2CA_GROUP_CLOSE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_L2CA_ENABLE_CONNECTIONLESS_REQ_T (L2CA_ENABLE_CONNECTIONLESS_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_L2CA_ENABLE_CONNECTIONLESS_CFM_T (L2CA_ENABLE_CONNECTIONLESS_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_L2CA_DISABLE_CONNECTIONLESS_REQ_T (L2CA_DISABLE_CONNECTIONLESS_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->psm) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_L2CA_DISABLE_CONNECTIONLESS_CFM_T (L2CA_DISABLE_CONNECTIONLESS_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->response) ;
}

void PrimConverter::conv_SYS_PAR_T (SYS_PAR_T * prim) 
 
{
	conv_uint8_t(&prim->port_speed) ;
	conv_uint16_t(&prim->max_frame_size) ;
}

void PrimConverter::conv_DLC_PAR_T (DLC_PAR_T * prim) 
 
{
	conv_uint16_t(&prim->max_frame_size) ;
	conv_uint8_t(&prim->credit_flow_ctrl) ;
	conv_uint16_t(&prim->initial_credits) ;
}

void PrimConverter::conv_CONTROL_PAR_T (CONTROL_PAR_T * prim) 
 
{
	conv_uint8_t(&prim->modem_signal) ;
	conv_uint8_t(&prim->break_signal) ;
}

void PrimConverter::conv_PORT_PAR_T (PORT_PAR_T * prim) 
 
{
	conv_uint8_t(&prim->port_speed) ;
	conv_uint8_t(&prim->data_bits) ;
	conv_uint8_t(&prim->stop_bits) ;
	conv_uint8_t(&prim->parity) ;
	conv_uint8_t(&prim->parity_type) ;
	conv_uint8_t(&prim->flow_ctrl_mask) ;
	conv_uint8_t(&prim->xon) ;
	conv_uint8_t(&prim->xoff) ;
	conv_uint16_t(&prim->parameter_mask) ;
}

void PrimConverter::conv_RFC_INIT_REQ_T (RFC_INIT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->psm_local) ;
	conv_bool_t(&prim->use_flow_control) ;
	conv_uint16_t(&prim->fc_type) ;
	conv_uint16_t(&prim->fc_threshold) ;
	conv_uint32_t(&prim->fc_timer) ;
	conv_uint32_t(&prim->rsvd_4) ;
	conv_uint32_t(&prim->rsvd_5) ;
}

void PrimConverter::conv_RFC_INIT_CFM_T (RFC_INIT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->psm_local) ;
	conv_uint16_t(&prim->fc_type) ;
	conv_uint16_t(&prim->fc_threshold) ;
	conv_uint32_t(&prim->fc_timer) ;
	conv_uint32_t(&prim->rsvd_4) ;
	conv_uint32_t(&prim->rsvd_5) ;
}

void PrimConverter::conv_RFC_REGISTER_REQ_T (RFC_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_RFC_REGISTER_CFM_T (RFC_REGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_bool_t(&prim->accept) ;
}

void PrimConverter::conv_RFC_START_REQ_T (RFC_START_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->psm_remote) ;
	conv_SYS_PAR_T(&prim->sys_pars) ;
	conv_uint16_t(&prim->respond_phandle) ;
}

void PrimConverter::conv_RFC_START_CFM_T (RFC_START_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->result_code) ;
	conv_SYS_PAR_T(&prim->sys_pars) ;
}

void PrimConverter::conv_RFC_START_IND_T (RFC_START_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_SYS_PAR_T(&prim->sys_pars) ;
}

void PrimConverter::conv_RFC_START_RES_T (RFC_START_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_bool_t(&prim->accept) ;
	conv_SYS_PAR_T(&prim->sys_pars) ;
	conv_uint16_t(&prim->respond_phandle) ;
}

void PrimConverter::conv_RFC_STARTCMP_IND_T (RFC_STARTCMP_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->result_code) ;
	conv_SYS_PAR_T(&prim->sys_pars) ;
}

void PrimConverter::conv_RFC_CLOSE_REQ_T (RFC_CLOSE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_CLOSE_IND_T (RFC_CLOSE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->reason_code) ;
}

void PrimConverter::conv_RFC_PARNEG_REQ_T (RFC_PARNEG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->loc_server_chan) ;
	conv_uint8_t(&prim->rem_server_chan) ;
	conv_DLC_PAR_T(&prim->dlc_pars) ;
}

void PrimConverter::conv_RFC_PARNEG_CFM_T (RFC_PARNEG_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_DLC_PAR_T(&prim->dlc_pars) ;
}

void PrimConverter::conv_RFC_PARNEG_IND_T (RFC_PARNEG_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_DLC_PAR_T(&prim->dlc_pars) ;
}

void PrimConverter::conv_RFC_PARNEG_RES_T (RFC_PARNEG_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_DLC_PAR_T(&prim->dlc_pars) ;
}

void PrimConverter::conv_RFC_ESTABLISH_REQ_T (RFC_ESTABLISH_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->loc_server_chan) ;
	conv_uint8_t(&prim->rem_server_chan) ;
}

void PrimConverter::conv_RFC_ESTABLISH_CFM_T (RFC_ESTABLISH_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint8_t(&prim->result_code) ;
}

void PrimConverter::conv_RFC_ESTABLISH_IND_T (RFC_ESTABLISH_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
}

void PrimConverter::conv_RFC_ESTABLISH_RES_T (RFC_ESTABLISH_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_bool_t(&prim->accept) ;
}

void PrimConverter::conv_RFC_RELEASE_REQ_T (RFC_RELEASE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
}

void PrimConverter::conv_RFC_RELEASE_IND_T (RFC_RELEASE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint8_t(&prim->reason_code) ;
}

void PrimConverter::conv_RFC_CONTROL_REQ_T (RFC_CONTROL_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_CONTROL_PAR_T(&prim->control_pars) ;
}

void PrimConverter::conv_RFC_CONTROL_IND_T (RFC_CONTROL_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_CONTROL_PAR_T(&prim->control_pars) ;
}

void PrimConverter::conv_RFC_PORTNEG_REQ_T (RFC_PORTNEG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->loc_server_chan) ;
	conv_uint8_t(&prim->rem_server_chan) ;
	conv_bool_t(&prim->request) ;
	conv_PORT_PAR_T(&prim->port_pars) ;
}

void PrimConverter::conv_RFC_PORTNEG_CFM_T (RFC_PORTNEG_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_PORT_PAR_T(&prim->port_pars) ;
}

void PrimConverter::conv_RFC_PORTNEG_IND_T (RFC_PORTNEG_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_bool_t(&prim->request) ;
	conv_PORT_PAR_T(&prim->port_pars) ;
}

void PrimConverter::conv_RFC_PORTNEG_RES_T (RFC_PORTNEG_RES_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_PORT_PAR_T(&prim->port_pars) ;
}

void PrimConverter::conv_RFC_FCOFF_REQ_T (RFC_FCOFF_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_FCOFF_CFM_T (RFC_FCOFF_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_FCON_REQ_T (RFC_FCON_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_FCON_CFM_T (RFC_FCON_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_FCOFF_IND_T (RFC_FCOFF_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_FCON_IND_T (RFC_FCON_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
}

void PrimConverter::conv_RFC_DATA_REQ_T (RFC_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint16_t(&prim->credits) ;
	conv_uint16_t(&prim->payload_length) ;
	conv_ptr(&prim->payload) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->payload ) [c]) , sizeof(uint8_t) * (prim->payload_length)) ;
			ptr = (uint8_t *) (&prim->payload ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->payload_length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_RFC_DATAWRITE_REQ_T (RFC_DATAWRITE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint16_t(&prim->credits) ;
	conv_uint16_t(&prim->payload_length) ;
	conv_ptr(&prim->payload) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->payload ) [c]) , sizeof(uint8_t) * (prim->payload_length)) ;
			ptr = (uint8_t *) (&prim->payload ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->payload_length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_RFC_DATAWRITE_CFM_T (RFC_DATAWRITE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
}

void PrimConverter::conv_RFC_DATA_IND_T (RFC_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint16_t(&prim->credits) ;
	conv_uint16_t(&prim->payload_length) ;
	conv_ptr(&prim->payload) ;
	conv_ptr(&prim->prelease) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->payload ) [c]) , sizeof(uint8_t) * (prim->payload_length)) ;
			ptr = (uint8_t *) (&prim->payload ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->payload_length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
	 prim->prelease = prim->payload;
}

void PrimConverter::conv_RFC_LINESTATUS_REQ_T (RFC_LINESTATUS_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint8_t(&prim->error_flag) ;
	conv_uint8_t(&prim->line_status) ;
}

void PrimConverter::conv_RFC_LINESTATUS_IND_T (RFC_LINESTATUS_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->server_chan) ;
	conv_uint8_t(&prim->error_flag) ;
	conv_uint8_t(&prim->line_status) ;
}

void PrimConverter::conv_RFC_TEST_REQ_T (RFC_TEST_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint16_t(&prim->test_data_length) ;
	conv_ptr(&prim->test_data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->test_data ) [c]) , sizeof(uint8_t) * (prim->test_data_length)) ;
			ptr = (uint8_t *) (&prim->test_data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->test_data_length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_RFC_TEST_CFM_T (RFC_TEST_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint16_t(&prim->test_data_length) ;
	conv_ptr(&prim->test_data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->test_data ) [c]) , sizeof(uint8_t) * (prim->test_data_length)) ;
			ptr = (uint8_t *) (&prim->test_data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->test_data_length ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_RFC_NSC_IND_T (RFC_NSC_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->mux_id) ;
	conv_uint8_t(&prim->command_type) ;
	conv_uint8_t(&prim->cmd_res) ;
}

void PrimConverter::conv_SDC_SERVICE_SEARCH_REQ_T (SDC_SERVICE_SEARCH_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->size_srch_pttrn) ;
	conv_ptr(&prim->srch_pttrn) ;
	conv_uint16_t(&prim->max_num_recs) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->srch_pttrn ) [c]) , sizeof(uint8_t) * (prim->size_srch_pttrn)) ;
			ptr = (uint8_t *) (&prim->srch_pttrn ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_srch_pttrn ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_SERVICE_SEARCH_CFM_T (SDC_SERVICE_SEARCH_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->num_recs_ret) ;
	conv_uint16_t(&prim->size_rec_list) ;
	conv_ptr(&prim->rec_list) ;
	conv_uint16_t(&prim->response) ;
	conv_uint16_t(&prim->err_code) ;
	conv_uint16_t(&prim->size_err_info) ;
	conv_ptr(&prim->err_info) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->rec_list ) [c]) , sizeof(uint8_t) * (prim->size_rec_list)) ;
			ptr = (uint8_t *) (&prim->rec_list ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_rec_list ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->err_info ) [c]) , sizeof(uint8_t) * (prim->size_err_info)) ;
			ptr = (uint8_t *) (&prim->err_info ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_err_info ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_SERVICE_ATTRIBUTE_REQ_T (SDC_SERVICE_ATTRIBUTE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint32_t(&prim->svc_rec_hndl) ;
	conv_uint16_t(&prim->size_attr_list) ;
	conv_ptr(&prim->attr_list) ;
	conv_uint16_t(&prim->max_num_attr) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->attr_list ) [c]) , sizeof(uint8_t) * (prim->size_attr_list)) ;
			ptr = (uint8_t *) (&prim->attr_list ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_attr_list ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_SERVICE_ATTRIBUTE_CFM_T (SDC_SERVICE_ATTRIBUTE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->size_attr_list) ;
	conv_ptr(&prim->attr_list) ;
	conv_uint16_t(&prim->response) ;
	conv_uint16_t(&prim->err_code) ;
	conv_uint16_t(&prim->size_err_info) ;
	conv_ptr(&prim->err_info) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->attr_list ) [c]) , sizeof(uint8_t) * (prim->size_attr_list)) ;
			ptr = (uint8_t *) (&prim->attr_list ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_attr_list ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->err_info ) [c]) , sizeof(uint8_t) * (prim->size_err_info)) ;
			ptr = (uint8_t *) (&prim->err_info ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_err_info ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_SERVICE_SEARCH_ATTRIBUTE_REQ_T (SDC_SERVICE_SEARCH_ATTRIBUTE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint16_t(&prim->size_srch_pttrn) ;
	conv_ptr(&prim->srch_pttrn) ;
	conv_uint16_t(&prim->size_attr_list) ;
	conv_ptr(&prim->attr_list) ;
	conv_uint16_t(&prim->max_num_attr) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->srch_pttrn ) [c]) , sizeof(uint8_t) * (prim->size_srch_pttrn)) ;
			ptr = (uint8_t *) (&prim->srch_pttrn ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_srch_pttrn ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->attr_list ) [c]) , sizeof(uint8_t) * (prim->size_attr_list)) ;
			ptr = (uint8_t *) (&prim->attr_list ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_attr_list ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_SERVICE_SEARCH_ATTRIBUTE_CFM_T (SDC_SERVICE_SEARCH_ATTRIBUTE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->total_response_size) ;
	conv_uint16_t(&prim->size_attr_list) ;
	conv_ptr(&prim->attr_list) ;
	conv_bool_t(&prim->more_to_come) ;
	conv_uint16_t(&prim->response) ;
	conv_uint16_t(&prim->err_code) ;
	conv_uint16_t(&prim->size_err_info) ;
	conv_ptr(&prim->err_info) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->attr_list ) [c]) , sizeof(uint8_t) * (prim->size_attr_list)) ;
			ptr = (uint8_t *) (&prim->attr_list ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_attr_list ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->err_info ) [c]) , sizeof(uint8_t) * (prim->size_err_info)) ;
			ptr = (uint8_t *) (&prim->err_info ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->size_err_info ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDC_TERMINATE_PRIMITIVE_REQ_T (SDC_TERMINATE_PRIMITIVE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_SDC_OPEN_SEARCH_REQ_T (SDC_OPEN_SEARCH_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
}

void PrimConverter::conv_SDC_OPEN_SEARCH_CFM_T (SDC_OPEN_SEARCH_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->result) ;
}

void PrimConverter::conv_SDC_CLOSE_SEARCH_REQ_T (SDC_CLOSE_SEARCH_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_SDC_CONFIG_REQ_T (SDC_CONFIG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->mtu) ;
}

void PrimConverter::conv_SDC_CLOSE_SEARCH_IND_T (SDC_CLOSE_SEARCH_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint8_t(&prim->result) ;
}

void PrimConverter::conv_SDS_REGISTER_REQ_T (SDS_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_ptr(&prim->service_rec) ;
	conv_uint16_t(&prim->num_rec_bytes) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->service_rec ) [c]) , sizeof(uint8_t) * (prim->num_rec_bytes)) ;
			ptr = (uint8_t *) (&prim->service_rec ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->num_rec_bytes ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_SDS_REGISTER_CFM_T (SDS_REGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->svc_rec_hndl) ;
	conv_uint16_t(&prim->result) ;
}

void PrimConverter::conv_SDS_UNREGISTER_REQ_T (SDS_UNREGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->svc_rec_hndl) ;
}

void PrimConverter::conv_SDS_UNREGISTER_CFM_T (SDS_UNREGISTER_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint32_t(&prim->svc_rec_hndl) ;
	conv_uint16_t(&prim->result) ;
}

void PrimConverter::conv_SDS_CONFIG_REQ_T (SDS_CONFIG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->mtu) ;
}

void PrimConverter::conv_TCP_OPEN_REQ_T (TCP_OPEN_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->flags) ;
	conv_IP_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_port) ;
	conv_uint16_t(&prim->out_size) ;
	conv_uint16_t(&prim->loc_port) ;
	conv_uint16_t(&prim->in_size) ;
}

void PrimConverter::conv_TCP_OPEN_CFM_T (TCP_OPEN_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->status) ;
	conv_uint16_t(&prim->b_in) ;
	conv_uint16_t(&prim->b_out) ;
	conv_uint16_t(&prim->out_size) ;
}

void PrimConverter::conv_TCP_OPEN_IND_T (TCP_OPEN_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
	conv_uint16_t(&prim->status) ;
	conv_IP_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_port) ;
}

void PrimConverter::conv_TCP_OPEN_RSP_T (TCP_OPEN_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
	conv_uint16_t(&prim->status) ;
}

void PrimConverter::conv_TCP_DATA_REQ_T (TCP_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b_out) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_TCP_DATA_CFM_T (TCP_DATA_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
	conv_uint16_t(&prim->len) ;
}

void PrimConverter::conv_TCP_DATA_IND_T (TCP_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_TCP_DATA_RSP_T (TCP_DATA_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
	conv_uint16_t(&prim->len) ;
}

void PrimConverter::conv_TCP_CLOSE_REQ_T (TCP_CLOSE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
}

void PrimConverter::conv_TCP_CLOSE_IND_T (TCP_CLOSE_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
}

void PrimConverter::conv_TCP_CLOSED_IND_T (TCP_CLOSED_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
}

void PrimConverter::conv_TCP_CLOSED_RSP_T (TCP_CLOSED_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
}

void PrimConverter::conv_TCP_ABORT_REQ_T (TCP_ABORT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
}

void PrimConverter::conv_TCP_ABORT_IND_T (TCP_ABORT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->b_out) ;
}

void PrimConverter::conv_TCP_ABORT_RSP_T (TCP_ABORT_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->b) ;
	conv_uint16_t(&prim->flags) ;
}

void PrimConverter::conv_UDP_OPEN_REQ_T (UDP_OPEN_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->flags) ;
	conv_IP_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_port) ;
	conv_uint16_t(&prim->loc_port) ;
}

void PrimConverter::conv_UDP_OPEN_CFM_T (UDP_OPEN_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->status) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->reserved) ;
}

void PrimConverter::conv_UDP_LISTEN_REQ_T (UDP_LISTEN_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_IP_ADDR(&prim->loc_addr) ;
}

void PrimConverter::conv_UDP_IGNORE_REQ_T (UDP_IGNORE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_IP_ADDR(&prim->loc_addr) ;
}

void PrimConverter::conv_UDP_DATA_REQ_T (UDP_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_UDP_EXTENDED_DATA_REQ_T (UDP_EXTENDED_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_IP_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_port) ;
	conv_IP_ADDR(&prim->loc_addr) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_UDP_DATA_CFM_T (UDP_DATA_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->len) ;
}

void PrimConverter::conv_UDP_DATA_IND_T (UDP_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_UDP_EXTENDED_DATA_IND_T (UDP_EXTENDED_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_IP_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_port) ;
	conv_IP_ADDR(&prim->loc_addr) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->len) ;
	conv_ptr(&prim->data) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->data ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->data ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_UDP_CLOSE_REQ_T (UDP_CLOSE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
}

void PrimConverter::conv_UDP_CLOSE_CFM_T (UDP_CLOSE_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->id) ;
}

void PrimConverter::conv_ETHER_ADDR (ETHER_ADDR * prim) 
 
{
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <3 ; m++)
			conv_uint16_t(&prim->w [m]) ;
	}
}

void PrimConverter::conv_BNEP_REGISTER_REQ_T (BNEP_REGISTER_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->flags) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_BNEP_CONNECT_REQ_T (BNEP_CONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->flags) ;
	conv_ETHER_ADDR(&prim->rem_addr) ;
}

void PrimConverter::conv_BNEP_CONNECT_CFM_T (BNEP_CONNECT_CFM_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->status) ;
}

void PrimConverter::conv_BNEP_CONNECT_IND_T (BNEP_CONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->status) ;
	conv_uint16_t(&prim->id) ;
	conv_ETHER_ADDR(&prim->rem_addr) ;
	conv_uint16_t(&prim->rem_uuid) ;
	conv_uint16_t(&prim->loc_uuid) ;
}

void PrimConverter::conv_BNEP_LISTEN_REQ_T (BNEP_LISTEN_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->addr) ;
}

void PrimConverter::conv_BNEP_IGNORE_REQ_T (BNEP_IGNORE_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->addr) ;
}

void PrimConverter::conv_BNEP_DATA_REQ_T (BNEP_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->rem_addr) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_EXTENDED_DATA_REQ_T (BNEP_EXTENDED_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->dst_addr) ;
	conv_ETHER_ADDR(&prim->src_addr) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_EXTENDED_MULTICAST_DATA_REQ_T (BNEP_EXTENDED_MULTICAST_DATA_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id_not) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->dst_addr) ;
	conv_ETHER_ADDR(&prim->src_addr) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_DATA_IND_T (BNEP_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_EXTENDED_DATA_IND_T (BNEP_EXTENDED_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->ether_type) ;
	conv_ETHER_ADDR(&prim->dst_addr) ;
	conv_ETHER_ADDR(&prim->src_addr) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_MULTICAST_DATA_IND_T (BNEP_MULTICAST_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_LOOPBACK_DATA_IND_T (BNEP_LOOPBACK_DATA_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_ptr(&prim->mblk) ;
	conv_uint16_t(&prim->len) ;
	if(1) 
	{
		// ptr template
		uint16_t c ;
		for (c=0; c < 1 ; c++) 
		{
			uint8_t *ptr ;
			startPointer((void **) & ((&prim->mblk ) [c]) , sizeof(uint8_t) * (prim->len)) ;
			ptr = (uint8_t *) (&prim->mblk ) [c] ;
			if (1) 
			{
				uint16_t d ;
				for (d=0; d < prim->len ; d++)
					conv_uint8_t(ptr+d) ;
			}
		}
	}
}

void PrimConverter::conv_BNEP_UP_IND_T (BNEP_UP_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_uint16_t(&prim->rem_uuid) ;
	conv_uint16_t(&prim->loc_uuid) ;
}

void PrimConverter::conv_BNEP_DOWN_IND_T (BNEP_DOWN_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
}

void PrimConverter::conv_BNEP_DISCONNECT_REQ_T (BNEP_DISCONNECT_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->flags) ;
	conv_uint16_t(&prim->id) ;
}

void PrimConverter::conv_BNEP_DISCONNECT_IND_T (BNEP_DISCONNECT_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->reason) ;
}

void PrimConverter::conv_BNEP_DEBUG_REQ_T (BNEP_DEBUG_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->test) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <18 ; m++)
			conv_uint16_t(&prim->args [m]) ;
	}
}

void PrimConverter::conv_BNEP_DEBUG_IND_T (BNEP_DEBUG_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->id) ;
	conv_uint16_t(&prim->test) ;
	if(1)
	{
		// array template
		uint16_t m ;
		for (m=0 ;m <18 ; m++)
			conv_uint16_t(&prim->args [m]) ;
	}
}

void PrimConverter::conv_BNEP_FLOW_REQ_T (BNEP_FLOW_REQ_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
}

void PrimConverter::conv_BNEP_FLOW_IND_T (BNEP_FLOW_IND_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->free) ;
}

void PrimConverter::conv_BNEP_HCI_SWITCH_ROLE_RSP_T (BNEP_HCI_SWITCH_ROLE_RSP_T * prim) 
 
{
	conv_uint16_t(&prim->type) ;
	conv_uint16_t(&prim->phandle) ;
	conv_BD_ADDR_T(&prim->bd_addr) ;
	conv_uint8_t(&prim->status) ;
	conv_uint8_t(&prim->role) ;
}

