/******************************************************************************
**
**   File:	packer_inline.h
**
**            (C) CSR 2000
**   
**   Purpose:	define ugly "inline" functions to write to buffer.
**
**  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/Packer/packer_inline.h#4 $
**
******************************************************************************/

/****************************************************************************
**  Modification history
***************************************************************************** 
**  1.1  22:june:00	ajh	Created from common code in HCI and BC
**                              packers.
*/


#ifndef __PACKER_INLINE_H__
#define __PACKER_INLINE_H__

#define WRITE_BYTE(where,what)        ( *(where)=(uint8)(what) )
#define WRITE_2BYTES(where,what)      ( *(where)=(uint8)((what) & 255),*((where)+1)=(uint8)(((what)>>8) & 255) )
#define WRITE_3BYTES(where,what)      ( *(where)=(uint8)((what) & 255),*((where)+1)=(uint8)(((what)>>8) & 255),*((where)+2)=(uint8)(((what)>>16) & 255)	)
#define WRITE_4BYTES(where,what)      ( *(where)=(uint8)((what) & 255),*((where)+1)=(uint8)(((what)>>8) & 255),*((where)+2)=(uint8)(((what)>>16) & 255),*((where)+3)=(uint8)(((what)>>24) & 255) )
#define WRITE_4BCF_BYTES(where,what)  ( *(where+2)=(uint8)((what) & 255),*((where)+3)=(uint8)(((what)>>8) & 255),*((where))=(uint8)(((what)>>16) & 255),*((where)+1)=(uint8)(((what)>>24) & 255) )

#define READ_BYTE(from)        ( *(from) )
#define READ_2BYTES(from)      ( (uint16)*(from) + ((uint16)*((from)+1) << 8) )
#define READ_3BYTES(from)      ( (uint32)*(from) + ((uint32)*((from)+1) << 8 ) + ((uint32)*((from)+2) << 16 ) )
#define READ_4BYTES(from)      ( (uint32)*(from) + ((uint32)*((from)+1) << 8 ) + ((uint32)*((from)+2) << 16 ) + ((uint32)*((from)+3) << 24 ) )
#define READ_4BCF_BYTES(from)  (((uint32)*(from) << 16 ) + ((uint32)*((from)+1) << 24 ) + (uint32)*((from)+2) + ((uint32)*((from)+3) << 8  ) )

#endif  /* __PACKER_INLINE_H__ */
