///////////////////////////////////////////////////////////////////////
//
//  FILE   :  callBack.cpp
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  CallBack
//
//  PURPOSE:  Provide a plain callback function.
//            The call back function should be declared static
//            within its object.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/TransportLayer/callBack.cpp#6 $
//
///////////////////////////////////////////////////////////////////////

#include "callBack.h"

void CallBack::initialise (void * aObject , void (*aCallBack)( bool , void *) )
{
    mObject = aObject;
    mCallBack = aCallBack;
}

void CallBack::execute ()
{
    mCallBack (true , mObject);
    //  delete this;
}

void CallBack::diedIncomplete ()
{
    mCallBack (false , mObject);
    //  delete this;
}
