///////////////////////////////////////////////////////////////////////
//
//  FILE   :  localTypes.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  PURPOSE:  Define the generic types for the HCI device Driver.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/localTypes.h#16 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __LOCALTYPES_H__
#define __LOCALTYPES_H__

#include "common/types.h"
#include "common/bool.h"
#include "common/linkage.h"

#include "HCIDeviceController.h"

#include "driver_types.h"

#include "packer.h"

class ACLHandler;
class CommandHandler;

typedef enum NEXT_PACKET_INFO
{
    nothingMore,
    flowControlled,
    notFlowControlled
}
NEXT_PACKET_INFO;

class DEVICECONTROLLER_API_CLASS Genericpdu
{
public:
    Genericpdu();
    virtual ~Genericpdu();
    void disownData ( void );
    uint8 * mBuffer;
    uint32 mLength;
    bool flowControlled;
};

class DEVICECONTROLLER_API_CLASS Datapdu : public Genericpdu
{
public:
    Datapdu();
    virtual ~Datapdu();
    void size(uint32 aLength);
    uint16 connectionHandle;
};

class Eventpdu : public Genericpdu
{
public:
    Eventpdu();
    virtual ~Eventpdu();
    uint8 HCIeventCode;
};

class DEVICECONTROLLER_API_CLASS Commandpdu : public Genericpdu
{
public:
    Commandpdu();
    Commandpdu( Eventpdu * hq );
    virtual ~Commandpdu();
    bool internallyGeneratedCommand;
    uint16 HCIopCode;
};

class DEVICECONTROLLER_API_CLASS Badpdu : public Genericpdu
{
public:
    Badpdu();
    virtual ~Badpdu();
    BadPDUReason mReason;
};

class DMpdu : public Genericpdu
{
public:
    DMpdu();
    virtual ~DMpdu();
};

class RFCOMMpdu : public Genericpdu
{
public:
    RFCOMMpdu();
    virtual ~RFCOMMpdu();
};

class SDPpdu : public Genericpdu
{
public:
    SDPpdu();
    virtual ~SDPpdu();
};

class L2CAPpdu : public Genericpdu
{
public:
    L2CAPpdu();
    virtual ~L2CAPpdu();
};

#endif //__LOCALTYPES_H__
