///////////////////////////////////////////////////////////////////////
//
//  FILE   :  Win32H4
//
//  AUTHOR :  Mark RISON
//
//  CLASS  :  Win32H4
//
//  PURPOSE:  Win32-specific portion of H4 implementation of HCITransport
//
///////////////////////////////////////////////////////////////////////

#ifndef __Win32H4_H__
#define __Win32H4_H__

#include "H4Stack.h"

class H4_API_CLASS Win32H4 : public H4Stack
{
	HANDLE event[H4_NUMEVENTS];
	bool initEvents (void);
	H4_EVENT waitForEvent (void);
	void finalEvents (void);

	HANDLE comport;
	OVERLAPPED txOverlapped, rxOverlapped;
	startReturnValue initSerial (const ichar *portName, uint32 datarate);
	startReturnValue initSerial (HANDLE portHandle) ;
	bool txData (uint32 len, const uint8 *buf);
	bool rxData (uint32 len, uint8 *buf);
	void finalSerial (void);

	HANDLE serialDaemonThread;
	bool initSerialDaemon (void);
	void notifySerialDaemon (H4_EVENT event);
	void finalSerialDaemon (void);

	CRITICAL_SECTION critSec;
	bool initCriticalSection (void);
	void enterCriticalSection (void);
	void exitCriticalSection (void);
	void finalCriticalSection (void);
};

#endif // __Win32H4_H__
