#include "inc.h"
#include <string>
#include "time/time_stamp.h"

//The rules for converting to XAP are ...
//uint8 == uint16 (ie it takes two bytes
//uint32 = uint16 MSW uint16 LSW


void WinPrimDebug::add_str_to_monster_buf(int indent, const char *name, std::string& buf)
{
	add_indent(indent, buf);
	buf += name;
}


void WinPrimDebug::add_indent(int num_tabs, std::string& buf)
{
	for (int i=0; i<num_tabs; i++)
	{
		buf += "\t";
	}
}

void WinPrimDebug::start_prim(std::string &buf)
{
    std::string s = "---- " + TimeStamp().hms() + " ------------------\n";
    add_str_to_monster_buf(0, s.c_str(), buf);
}

std::string WinPrimDebug::no_matching_prim(int indent)
{
	std::string error_string = ("ERROR: none of the prim types matched, default reached \n\0");
	return error_string;
}


void WinPrimDebug::add_to_monster_buf(int indent, const char *name, std::string& buf, uint32_t value)
{
	add_indent(indent, buf);
	char newstr[100];
    
    // quick hack to remove newlines from data payloads
    if (ptr_flag)
        sprintf(newstr, "%s %02x", name, value);
    else
        sprintf(newstr, "%s %02x\n", name, value);

	buf += newstr;
}


void WinPrimDebug::debug_uint8_t(int indent, uint8_t *num, std::string& buf, char *name)
{
	add_to_monster_buf(indent, name, buf, *num);
}


void WinPrimDebug::debug_int8_t(int indent, int8_t *num, std::string& buf, char *name)
{
	debug_uint8_t(indent, (uint8_t *)num, buf, name);
}

void WinPrimDebug::debug_int32_t(int indent, int32_t *num, std::string& buf, char *name)
{
	debug_uint32_t(indent, (uint32_t *)num, buf, name);
}

void WinPrimDebug::debug_uint16_t(int indent, uint16_t *num, std::string& buf, char *name)
{
	add_to_monster_buf(indent, name, buf, *num);
}

void WinPrimDebug::debug_enum(int indent, void *en, std::string& buf, char *name)
{
	debug_uint16_t(indent,(uint16_t*) en,buf,name) ;
}

void WinPrimDebug::debug_uint24_t(int indent, uint24_t *num, std::string& buf, char *name)
{
    debug_uint32_t(indent, num, buf, name) ;
}


void WinPrimDebug::debug_uint32_t(int indent, uint32_t *num, std::string& buf, char *name)
{
	add_to_monster_buf(indent, name, buf, *num);
}

void WinPrimDebug::debug_bool_t(int indent, bool_t *num, std::string& buf, char *name)
{
    debug_uint8_t(indent, num, buf, name) ;
}


void WinPrimDebug::debug_IP_ADDR(int indent, void * vaddr, std::string& buf, char *name)
{
	IP_ADDR * addr = (IP_ADDR*) vaddr ;
	add_indent(indent,buf) ;
	char newstr[100];
    
	sprintf(newstr, "%s ",name);
	buf += newstr;
	for (int c = 0 ; c < 8 ; c++)
	{
		sprintf(newstr, "%04x ",addr->w[c]);
		buf += newstr;
	}

}



void WinPrimDebug::debug_ptr(int indent, void * ptr, std::string& buf, char *name)
{
    //add_str_to_monster_buf(indent, name, buf);
}
