// Use boost implementations for threading

#ifndef THREAD__THREAD_IMPL_H

#define THREAD__THREAD_IMPL_H

#include "thread/mutex.h"
#include "thread/condition.h"

#include "common/nocopy.h"
#include "common/types.h"

#include "boost/thread/condition.hpp"
#include "boost/thread/mutex.hpp"

class Mutex::Impl : private NoCopy
{
public:

    boost::mutex real_mutex;
};

class Mutex::Lock::Impl : private NoCopy
{
public:
    Impl(Mutex::Impl &x)
        : real_lock(x.real_mutex, true)
    { }

    boost::mutex::scoped_lock real_lock;
};

class Condition::Impl : private NoCopy
{
public:
    void wait(Mutex::Lock::Impl &x);
    bool wait(Mutex::Lock::Impl &x, uint32 udelay);
    void notifyOne();
    void notifyAll();

    boost::condition real_condition;
};

#endif
