// Abstraction of a condition variable

#ifndef THREAD__CONDITION_H

#define THREAD__CONDITION_H

#include "common/nocopy.h"

#include "mutex.h"
#include "common/types.h"

class Condition : private NoCopy
{
public:
    Condition();
    ~Condition();

    void wait(Mutex::Lock &);
    bool wait(Mutex::Lock &, uint32 microsecs);
    void notifyOne();
    void notifyAll();

private:
    class Impl;
    Impl *impl;
};

#endif
