// system_wide_mutex.h
// A system-wide mutex class.
// This can be used to guard objects across inter-process boundries.
// Speed isn't an issue.

// As with all these classes, the header is a pretty generic C++ class.  
// The implementation is entrirely platform specific.


#ifndef THREAD__SYSTEM_WIDE_MUTEX_H
#define THREAD__SYSTEM_WIDE_MUTEX_H

#include "common/nocopy.h"
#include "common/types.h"
#include <stdlib.h>

class SystemWideMutex : private NoCopy
{
public:
	SystemWideMutex(const char * mutex_name, bool AcquireImmed = false);
	SystemWideMutex(const wchar_t * mutex_name, bool AcquireImmed = false);
	~SystemWideMutex();

	bool Acquire(uint32 dwMilliseconds = 0L);
	void Release();
    bool IsAcquired() const;

private:
	// Data hiding using pimpl
    class MutexData;
	// Trailing underscore nomenclature for member variables taken from A. Alexandescu
	MutexData *data_;
};

#endif

