/*******************************************************************************

    (C) COPYRIGHT Cambridge Consultants Ltd 1999

    CCL Project Reference C6066 - Lindisfarne

FILE
    $Workfile: types.h $
    $Revision: #10 $
    $Author: ajh $
         
ORIGINAL AUTHOR
    Simon Morris

DESCRIPTION
    This file contains the type definitions.
         
REFERENCES
    C6066-S-001 Bluetooth Software Architecture Description.
 
*******************************************************************************/

#ifndef BLUESTACK__TYPES_H    /* Once is enough */
#define BLUESTACK__TYPES_H

#ifdef RCS_STRINGS
static const char* const types_h_id = "$Header: //depot/bc/main/interface/app/bluestack/types.h#10 $";
#endif


/*============================================================================*
Public Defines
*============================================================================*/

#undef  NULL
#define NULL    0

#undef  FALSE
#define FALSE   (0)

#undef  TRUE
#define TRUE    (1)

#define PARAM_UNUSED(x) x

#define INVALID_PHANDLE     0xFFFF       /* Invalid protocol handle setting */

/*============================================================================*
Public Data Types
*============================================================================*/

/*
 * base types
 */
typedef unsigned        char    bool_t;
typedef unsigned        char    uint8_t;
typedef unsigned short  int		uint16_t;
typedef unsigned long   int     uint24_t;
typedef unsigned long   int     uint32_t;
#if !defined(XAP) || !defined(__GNUC__) || !defined(_SYS_TYPES_H)
/*
 * Hack because gcc already defines these types in sys/types.h.
 * Fix it some other way, if you like.  The type definitions are
 * a ghastly mess anyway.
 */
typedef signed   char           int8_t;
typedef signed   short  int     int16_t;
#if !defined(__GNUC__)
typedef signed   long   int     int32_t;
#endif
#endif
typedef uint32_t                tid_t;
typedef uint16_t                phandle_t;

#if !defined(__cplusplus) && !defined(__XAP__)
#undef bool
#define bool bool_t
#endif

/*============================================================================*
Public Data
*============================================================================*/
/* None */

/*============================================================================*
Public Functions
*============================================================================*/
/* None */


#endif /* ndef _TYPES_H */
/*============================================================================*
End Of File
*============================================================================*/
