// sluttable.h

#ifndef CHIPUTIL__SLUTTABLE_H_INCLUDED
#define CHIPUTIL__SLUTTABLE_H_INCLUDED



#include "abstract/memory_reader.h"
#include "common/types.h"

class SlutTable
{
public:
	// This class reads a slut table from an IMemoryReader and provides access to the keys.
	SlutTable(IMemoryReader *reader);
	~SlutTable();
	bool read_slut();
	bool entry_exists(uint16 key);
	uint16 getValue(uint16 key);
private:
	IMemoryReader * reader_;
	class Entries;
	Entries * entries_;
};

#endif // CHIPUTIL__SLUTTABLE_H_INCLUDED