///////////////////////////////////////////////////////////////////////
//
//  FILE   :  HCIFactory.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  ControllerFactory,
//            HCIControllerFactory,
//            BlueCoreControllerFactory,
//            ControllerDefinition
//
//  PURPOSE:  A set of classes to create and initialise a Host Side HCI/Serial
//            stack.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/Factory/FactoryLinkage.h#2 $
//
///////////////////////////////////////////////////////////////////////

#ifndef FACTORYLINKAGE_H_INCLUDED
#define FACTORYLINKAGE_H_INCLUDED

#include "common/linkage.h"

#ifdef _WIN32
#ifndef FACTORY_API
#ifdef  FACTORY_EXPORTS
#define FACTORY_API extern LINKAGE __declspec(dllexport)
#else
#define FACTORY_API extern LINKAGE __declspec(dllimport)
#endif
#endif
#ifdef __cplusplus
#ifndef FACTORY_API_CLASS
#ifdef	FACTORY_EXPORTS
#define FACTORY_API_CLASS __declspec(dllexport)
#else
#define FACTORY_API_CLASS __declspec(dllimport)
#endif
#endif
#endif
#else
#define FACTORY_API
#define FACTORY_API_CLASS
#endif


#endif // FACTORYLINKAGE_H_INCLUDED
