////////////////////////////////////////////////////////////////////////////////////
//
//   File:      TestFrameAPI.h
//
//   Purpose:   Present the simple API for applications interfacing to the
//              Test Frame.
//
//   (C) 2000 Cambridge Silicon Radio
//
////////////////////////////////////////////////////////////////////////////////////

#include "common/types.h"
#include "hci/packer_parameters.h"

//NB we don't use bool in this api because MSVC forces it to be 1 byte but things 
//like MEX expect it to be an int

#define MAX_HANDLES 50 

EXPORTC int openTestFrame(char * comname, char * configStr, char * transport) ;
EXPORTC int isConnected(int frameHandle) ;
EXPORTC int hasLinkFailed(int frameHandle) ;
EXPORTC int closeTestFrame(int frameHandle);

EXPORTC int queuedChipMgtHC(int  frameHandle) ;
EXPORTC int queuedChipMgtCH(int  frameHandle) ;
EXPORTC int queuedHCI(int  frameHandle) ;

EXPORTC int readChipMgtHC(int  frameHandle, PARAMETER_ARRAY * answers) ;
EXPORTC int readChipMgtCH(int  frameHandle, PARAMETER_ARRAY * answers) ;
EXPORTC int readHCI(int  frameHandle, PARAMETER_ARRAY * answers) ;

EXPORTC int writeChipMgtHC(int frameHandle , PARAMETER_ARRAY parameterList ) ;
EXPORTC int writeHCI(int frameHandle , PARAMETER_ARRAY parameterList ) ;
