///////////////////////////////////////////////////////////////////////
//
//  FILE   :  callBack.h
//
//            (C) CSR 2000
//
//  AUTHOR :  Adam Hughes
//
//  CLASS  :  CallBack
//
//  PURPOSE:  Provide a plain callback function.
//            The CallBack function must be declared static within its
//            object.
//
//  $Id: //depot/bc/main/devHost/HostStack/DeviceDriver/generic/TransportLayer/callBack.h#6 $
//
///////////////////////////////////////////////////////////////////////

#ifndef __CALLBACK_H__
#define __CALLBACK_H__

#include "H4/H4Linkage.h"

class H4_API_CLASS CallBack
{
public:
    void initialise (void * aObject , void (*aCallBack)( bool , void *) );
    void execute ();
    void diedIncomplete();
private:
    void *mObject;
    void (*mCallBack) ( bool , void *);
};

#endif // __CALLBACK_H__
