// FlashID.h

// Class for reading the identity of a flash image (on chip or off).
// Uses an interface on an abstract base class to read locations.
//
//  1.5	06:jan:2001		ckl:		Created

// $Id: //depot/bc/main/devHost/spi/flashdll/FlashID.H#4 $


// abstract class - provides a location reader.

#ifndef FLASHID_H_INCLUDED
#define FLASHID_H_INCLUDED

#include "abstract/memory_reader.h"

const int FlashIDBuildNameLen = 200;


class FlashIDSolver
{
public:
	enum FlashIDState
	{
		FlashIDStateUnread,
		FlashIDStateRead,
		FlashIDStateFailed
	};

	FlashIDSolver(IMemoryReader *Reader)  { FlashIDSolver::Reader = Reader;};
	void SetReader(IMemoryReader *Reader) { FlashIDSolver::Reader = Reader;};
	IMemoryReader *GetReader() { return Reader;};

	void Solve();
	
	FlashIDState State;
	char BuildName[FlashIDBuildNameLen] ;
	uint16 BuildNum;

private:
	IMemoryReader *Reader;
	bool GetFirmwareIdFromSlut();
	bool GetFirmwareIDFromIdsFile();
	int check_string(FILE *fp);
	bool identify_stack(FILE *fp);

};

#endif // FLASHID_H_INCLUDED