// File for storing an image 


// $Log: FlashImg.h,v $
// Revision 1.20  2002/04/19 20:00:35  cl01
// Made some functions const
//
// Revision 1.19  2001/10/08 13:57:43  doc
// Added SetDataErased and SetCodeErased functions
//
// Revision 1.18  2001/10/01 11:15:09  cl01
// Added SetFlashLocation functions
//
// Revision 1.17  2001/09/12 17:26:03  cl01
// Flash device code size now calculated
//
// Revision 1.16  2001/09/04 16:53:25  cl01
// Improved speed.
//
// Revision 1.15  2001/08/17 13:38:06  cl01
// Changed includes to allow cleaner interface on flashdll.h
//

//  1.5		14:jan:2001		ckl:		Checks timestamps on files
//  1.6		23:feb:2001		ckl:		Added Firmware versions
//  1.7		23:feb:2001		ckl:		removed MFC from interface
//  1.10	14:mar:2001		ckl:		uses flash_prog_start
//  1.13	14:mar:2001		ckl:		changed flash_top

// $Id: //depot/bc/main/devHost/spi/flashdll/FlashImg.h#23 $

#ifndef FLASHIMG_H_INCLUDED
#define FLASHIMG_H_INCLUDED


#include <vector>

using namespace std ;

typedef vector<WORD> wordvector;
typedef vector<bool> boolvector;

#define BC01_FLASH_SIZE (0x40000)
#define BC02_FLASH_SIZE (0x80000)

enum {	flash_window = 0x8000 };


class SectionImage;

class FLASHDLL_API FlashImage: public IMemoryReader
{

protected:
	enum { flash_prog_start = 0x10000 };
	SectionImage *prog, *data;
	bool errflag;
	enum {errorBufSize = 240};
	char lastError[errorBufSize];
	long flash_size;
public:
	
	const char *GetErrorString();

	int SliderPos;

	FlashImage(long flash_size = BC02_FLASH_SIZE);
	virtual ~FlashImage();
	void SetDataLocation(int nIndex, WORD newElement);
	WORD GetDataLocation(int nIndex) const; 
	void SetCodeLocation(int nIndex, WORD newElement);
	WORD GetCodeLocation(int nIndex) const;
	WORD GetFlashLocation(int nIndex) const;
	void SetFlashLocation(int nIndex, WORD newElement);
	bool AddressUsed(int nIndex) const;
	long GetFlashSize() const {return flash_size;} ;
	static long GetFlashProgStart() {return flash_prog_start;};
	int GetDataSize() const;
	int GetCodeSize() const;
	int GetTotalSize() const;
	bool GetError() const;
	void ClearError();
	//bool GetError() {return prog.GetError() || data.GetError();};
	//void ClearError() {prog.ClearError(); data.ClearError();};
//	void PreloadContents(void);
	bool ReadDataFile(const char *filename);
	bool ReadCodeFile(const char *filename);
	bool RefreshFiles();
	bool GetFirmwareId(int *const id, char *const nameBuffer, const size_t sNameBuffer) const;
	virtual bool read_mem(uint16 addr, uint16 len, uint16 * data);
	void SetDataErased(int start_addr, int end_addr);
	void SetCodeErased(int start_addr, int end_addr);
	void SetAsErased(int start_addr, int end_addr);
	bool IsWrapped() const;
};

#endif //  FLASHIMG_H_INCLUDED