/******************************************************************************
Project:		SPI.dll  (and spilib.lib)
File Name:		spi.cpp
Description:	Implementation of the spi access functions, 
				including the mutex around spi locks.

$Id: //depot/bc/main/devHost/spi/spidll/spi.h#27 $
******************************************************************************/


#ifndef __SPI_H
#define __SPI_H
#define SUCCESS (0)
#define FAILURE (1)

#ifdef __cplusplus
extern "C" {
#endif

//extern int crnt_bank;
//extern int emu_debug;
//extern sif_kind;
//extern notify_user;

// typedef unsigned char bitstream_t[1048576];

#ifdef SPI_LIB
#define SPIDLL_API
#else
#ifdef SPIDLL_EXPORTS
#define SPIDLL_API __declspec(dllexport)
#else
#define SPIDLL_API __declspec(dllimport)
#endif
#endif

// SPIDLL_API void (*err_msg_hook)(char *tmpbuf);

SPIDLL_API int lpt_test(void);
SPIDLL_API int lpt_read(ULONG PortNumber);
SPIDLL_API int lpt_write(ULONG PortNumber, ULONG DataValue);
SPIDLL_API int hardware_test (int);
SPIDLL_API int spi_reset(int flag);
SPIDLL_API int xap_stopped_spi(void);
SPIDLL_API int spi_read(unsigned long addr, unsigned short *value);
SPIDLL_API int spi_write(unsigned long addr, unsigned short data);
SPIDLL_API int spi_read_verify(unsigned long addr, unsigned short *value);
SPIDLL_API int spi_write_verify(unsigned long addr, unsigned short data);
SPIDLL_API int spi_read_block(unsigned long addr, unsigned long num_dwords, unsigned long *data);
SPIDLL_API int spi_write_block(unsigned long addr, unsigned long num_dwords, unsigned long *data);
SPIDLL_API int spi_set_shift_period(int shift_period); /* replacement for sif_set_shift_period */
SPIDLL_API int spi_query_shift_period(int *shift_period); /* replacement for sif_query_shift_period */
SPIDLL_API void spi_chip_select(int which);
SPIDLL_API int spi_id(int id); /* replacement for sif_set_sif_id */
SPIDLL_API int spi_set_shift_period(int shift_period); /* replacement for sif_set_shift_period */
SPIDLL_API int spi_query_shift_period(int *shift_period); /* replacement for sif_query_shift_period */
SPIDLL_API void spi_multiplex_select(int which);
SPIDLL_API int spi_get_chip_num();
SPIDLL_API void spi_set_cmd_bits(unsigned char cmd);
SPIDLL_API unsigned char spi_get_cmd_bits();
SPIDLL_API int spi_is_acquired();
SPIDLL_API int acquire_spi(DWORD timeout);
SPIDLL_API void release_spi();
SPIDLL_API unsigned long rawlpt_shift(UCHAR in[], UCHAR out[], DWORD cnt);
SPIDLL_API int spidll_control_write(UCHAR Data);



#ifdef __cplusplus
};
#endif

#endif // __SPI_H
