// Abstraction of a mutex

#ifndef THREAD__MUTEX_H

#define THREAD__MUTEX_H

#include "common/nocopy.h"

class Condition;

class Mutex : private NoCopy
{
public:
    Mutex();
    ~Mutex();

    class Lock : private NoCopy
    {
    public:
        Lock(Mutex &);
        ~Lock();
        class Impl;
        friend class Condition;
    private:
        Impl *impl;
    };
    friend class Lock;

    class Impl;
private:
    Impl *impl;
};

#endif
