// Simple time stamp
// JBS 3 October 2001
// Introduced for marking packets in WinPrimDebug

#ifndef TIME_STAMP_H

#define TIME_STAMP_H

#include "boost/smart_ptr.hpp"
#include <string>

class TimeStamp
{
public:
    TimeStamp(); // Records the time it was built
    TimeStamp(const TimeStamp &);
    TimeStamp &operator=(const TimeStamp &);
    ~TimeStamp();

    std::string hms() const; // HH:MM:SS (plus millisecs if available)

    std::string ymdhm() const; // YYYY-MMM-DD HH:MM

private:
    class Impl;
    boost::shared_ptr<Impl> ptr;
};

#endif
