
#ifndef _WINPRIMDEBUG_H
#define _WINPRIMDEBUG_H

#ifdef WINPRIMDEBUG_EXPORTS
#define WINPRIMDEBUG_API __declspec(dllexport)
#else
#define WINPRIMDEBUG_API __declspec(dllimport)
#endif

#include <stdio.h>
#include "malloc.h"
#include "app/bluestack/types.h"

#include <string>


#define debug_uint16 debug_uint16_t
class WINPRIMDEBUG_API WinPrimDebug {
public:
	WinPrimDebug();
	~WinPrimDebug();

	// debugging Windoes packed prims
	std::string debugDMprim(uint16_t type, void *prim);
	std::string debugRFCOMMprim(uint16_t type, void *prim);
	std::string debugSDPprim(uint16_t type, void *prim);
	std::string debugL2CAPprim(uint16_t type, void *prim);

private:
	bool ptr_flag;

	void add_to_monster_buf(int indent, const char *name, std::string& buf, uint32_t value);
	void add_str_to_monster_buf(int indent, const char *name, std::string& monster_buffer);
	std::string no_matching_prim(int indent);

	std::string debug_DM_UPRIM_T(uint16_t type, void *prim);
	std::string debug_RFCOMM_UPRIM_T(uint16_t type, void *prim);
	std::string debug_SDC_UPRIM_T(uint16_t type, void *prim);
	std::string debug_L2CA_UPRIM_T(uint16_t type, void *prim);

	// hand made functions
	void add_indent(int num_tabs, std::string& buf);
    void start_prim(std::string &buf);
	void debug_uint8_t(int indent, uint8_t *num, std::string& monster_buf, char *name);
	void debug_uint16_t(int indent, uint16_t *num, std::string& monster_buf, char *name);
	void debug_enum(int indent, void *num, std::string& monster_buf, char *name);
	void debug_uint24_t(int indent, uint24_t *num, std::string& monster_buf, char *name);
	void debug_uint32_t(int indent, uint32_t *num, std::string& monster_buf, char *name);
	void debug_bool_t(int indent, bool_t *num, std::string& monster_buf, char *name);
	void debug_ptr(int indent, void *ptr, std::string& monster_buf, char *name);
	void debug_int8_t(int indent, int8_t *num, std::string& monster_buf, char *name);
	void debug_int32_t(int indent, int32_t *num, std::string& monster_buf, char *name);
        void debug_IP_ADDR(int indent, void * vaddr, std::string& buf, char *name);

	uint16_t namelen(const uint8_t *s, uint16_t n);
	void debug_printName(uint8_t **name_part, std::string& monster_buffer);	
	void debug_customDebug(void *prim, std::string& monster_buffer);	
	void debug_customWriteLPSettings(void *prim, int indent, std::string& monster_buffer); 	

	// generated functions
	void debug_BD_ADDR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_STANDARD_COMMAND_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_AM_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_AM_REGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_REGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_CONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_CONNECT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_CONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_DISCONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_DISCONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_BUFFER_SIZE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_DATA_SENT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_CONNECTIONLESS_CH_REG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_INCOMING_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_INCOMING_UNREGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_CONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_CONNECT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_CONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_CONNECT_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_DISCONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_DISCONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_BUFFER_SIZE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SCO_DATA_SENT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_SET_DEFAULT_SECURITY_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_REGISTER_OUTGOING_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_UNREGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_UNREGISTER_OUTGOING_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ACCESS_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ACCESS_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_SET_SEC_MODE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_SET_SEC_MODE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ADD_DEVICE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ADD_DEVICE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_REMOVE_DEVICE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_REMOVE_DEVICE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_LINK_KEY_REQUEST_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_LINK_KEY_REQUEST_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_PIN_REQUEST_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_PIN_REQUEST_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_LINK_KEY_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_AUTHORISE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_AUTHORISE_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_AUTHENTICATE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_AUTHENTICATE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ENCRYPT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ENCRYPT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_ENCRYPTION_CHANGE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_L2CAP_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SM_L2CAP_CLRX_ENABLE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_WRITE_CACHED_PAGE_MODE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_WRITE_CACHED_CLOCK_OFFSET_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_CLEAR_PARAM_CACHE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HC_TO_HOST_FLOW_CONTROL_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_OPEN_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_OPEN_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_CLOSE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_OPENED_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_ACL_CLOSED_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_SET_DEFAULT_LINK_POLICY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_INQUIRY_RESULT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_INQUIRY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_LINK_KEY_CHANGE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_RETURN_LINK_KEYS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_MASTER_LINK_KEY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_REMOTE_NAME_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_REMOTE_FEATURES_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_REMOTE_VERSION_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_CLOCK_OFFSET_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_MODE_CHANGE_EVENT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_QOS_SETUP_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_QOS_VIOLATION_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_ROLE_DISCOVERY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_SWITCH_ROLE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_LP_SETTINGS_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_WRITE_LP_SETTINGS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_WRITE_LP_SETTINGS_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_SET_EVENT_MASK_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_FLUSH_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_PIN_TYPE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_STORED_LINK_KEY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_WRITE_STORED_LINK_KEY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_DELETE_STORED_LINK_KEY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_LOCAL_NAME_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_CONN_ACCEPT_TO_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_PAGE_TO_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_SCAN_ENABLE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_PAGESCAN_ACTIVITY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_INQUIRYSCAN_ACTIVITY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_AUTH_ENABLE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_ENCRYPTION_MODE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_CLASS_OF_DEVICE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_VOICE_SETTING_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_AUTO_FLUSH_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_WRITE_AUTO_FLUSH_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_NUM_BCAST_TXS_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_HOLD_MODE_ACTIVITY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_TX_POWER_LEVEL_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_LINK_SUPERV_TIMEOUT_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_WRITE_LINK_SUPERV_TIMEOUT_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_NUM_SUPPORTED_IAC_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_CURRENT_IAC_LAP_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_PAGESCAN_PERIOD_MODE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_PAGESCAN_MODE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_HARDWARE_ERROR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_DATA_BUFFER_OVERFLOW_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_MAX_SLOTS_CHANGE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_LOCAL_VERSION_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_LOCAL_FEATURES_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_COUNTRY_CODE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_BD_ADDR_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_FAILED_CONTACT_COUNTER_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_RESET_CONTACT_COUNTER_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_GET_LINK_QUALITY_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DM_HCI_READ_RSSI_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_COMMAND_COMMON_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HANDLE_COMPLETE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_LINK_KEY_BD_ADDR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_INQUIRY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_INQUIRY_CANCEL_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_PERIODIC_INQUIRY_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_EXIT_PERIODIC_INQUIRY_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_CHANGE_CONN_PKT_TYPE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_CHANGE_CONN_LINK_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_MASTER_LINK_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_REMOTE_NAME_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_REMOTE_SUPP_FEATURES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_REMOTE_VER_INFO_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_CLOCK_OFFSET_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_HOLD_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_SNIFF_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_EXIT_SNIFF_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_PARK_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_EXIT_PARK_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_QOS_SETUP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_ROLE_DISCOVERY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_SWITCH_ROLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_LINK_POLICY_SETTINGS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_SET_EVENT_MASK_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_RESET_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_FLUSH_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_PIN_TYPE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_PIN_TYPE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_CREATE_NEW_UNIT_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_STORED_LINK_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_STORED_LINK_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_DELETE_STORED_LINK_KEY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_CHANGE_LOCAL_NAME_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_LOCAL_NAME_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_CONN_ACCEPT_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_CONN_ACCEPT_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_PAGE_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_PAGE_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_SCAN_ENABLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_SCAN_ENABLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_PAGESCAN_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_PAGESCAN_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_INQUIRYSCAN_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_INQUIRYSCAN_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_AUTH_ENABLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_ENC_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_CLASS_OF_DEVICE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_CLASS_OF_DEVICE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_VOICE_SETTING_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_VOICE_SETTING_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_AUTO_FLUSH_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_AUTO_FLUSH_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_NUM_BCAST_RETXS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_NUM_BCAST_RETXS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_HOLD_MODE_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_HOLD_MODE_ACTIVITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_TX_POWER_LEVEL_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_SCO_FLOW_CON_ENABLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_SCO_FLOW_CON_ENABLE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_SET_HCTOHOST_FLOW_CONTROL_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_HOST_NUM_COMPLETED_PACKETS_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_LINK_SUPERV_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_LINK_SUPERV_TIMEOUT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_NUM_SUPPORTED_IAC_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_CURRENT_IAC_LAP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_CURRENT_IAC_LAP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_PAGESCAN_PERIOD_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_PAGESCAN_PERIOD_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_PAGESCAN_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_WRITE_PAGESCAN_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_LOCAL_VER_INFO_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_LOCAL_SUPP_FEATURES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_COUNTRY_CODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_BD_ADDR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_FAILED_CONTACT_COUNT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_RESET_FAILED_CONTACT_COUNT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_GET_LINK_QUALITY_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_READ_RSSI_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_ENABLE_DUT_MODE_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_HCI_INQ_RESULT_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_QOS_FLOW_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_REGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONNECT_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONNECT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONFIG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONFIG_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONFIG_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_CONFIG_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DATAWRITE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DATAWRITE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DATAREAD_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISCONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISCONNECT_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISCONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISCONNECT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_TIMEOUT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_QOSVIOLATION_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_PING_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_PING_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GETINFO_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GETINFO_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GROUP_CREATE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GROUP_CREATE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GROUP_CLOSE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_GROUP_CLOSE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_ENABLE_CONNECTIONLESS_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_ENABLE_CONNECTIONLESS_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISABLE_CONNECTIONLESS_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_L2CA_DISABLE_CONNECTIONLESS_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SYS_PAR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_DLC_PAR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_CONTROL_PAR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_PORT_PAR_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_INIT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_INIT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_REGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_START_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_START_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_START_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_START_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_STARTCMP_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_CLOSE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_CLOSE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PARNEG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PARNEG_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PARNEG_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PARNEG_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_ESTABLISH_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_ESTABLISH_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_ESTABLISH_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_ESTABLISH_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_RELEASE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_RELEASE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_CONTROL_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_CONTROL_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PORTNEG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PORTNEG_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PORTNEG_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_PORTNEG_RES_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCOFF_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCOFF_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCON_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCON_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCOFF_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_FCON_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_DATAWRITE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_DATAWRITE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_LINESTATUS_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_LINESTATUS_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_TEST_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_TEST_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_RFC_NSC_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_SEARCH_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_SEARCH_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_ATTRIBUTE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_ATTRIBUTE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_SEARCH_ATTRIBUTE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_SERVICE_SEARCH_ATTRIBUTE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_TERMINATE_PRIMITIVE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_OPEN_SEARCH_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_OPEN_SEARCH_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_CLOSE_SEARCH_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_CONFIG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDC_CLOSE_SEARCH_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDS_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDS_REGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDS_UNREGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDS_UNREGISTER_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_SDS_CONFIG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_ETHER_ADDR (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_REGISTER_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_CONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_CONNECT_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_CONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_LISTEN_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_IGNORE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_EXTENDED_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_EXTENDED_MULTICAST_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_EXTENDED_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_MULTICAST_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_LOOPBACK_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_UP_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DOWN_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DISCONNECT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DISCONNECT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DEBUG_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_DEBUG_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_FLOW_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_FLOW_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_BNEP_HCI_SWITCH_ROLE_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_OPEN_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_OPEN_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_OPEN_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_OPEN_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_DATA_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_DATA_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_CLOSE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_CLOSE_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_CLOSED_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_CLOSED_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_ABORT_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_ABORT_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_TCP_ABORT_RSP_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_OPEN_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_OPEN_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_LISTEN_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_IGNORE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_EXTENDED_DATA_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_DATA_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_EXTENDED_DATA_IND_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_CLOSE_REQ_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 
void debug_UDP_CLOSE_CFM_T (int indent, void *aprim, std::string& m_buf, char *tmp=0) 
 ; 

};

#endif _WINPRIMDEBUG_H
